﻿using CRM.Domain.Shared.Enums;
using EventFlow.Entities;
using Newtonsoft.Json;

namespace CRM.Domain.Branch.Entities
{
    public class ContactDetail : Entity<ContactDetailId>
    {
        public ContactDetail(ContactDetailId id) : base(id)
        {
        }

        [JsonConstructor]
        public ContactDetail(ContactDetailId id,
            string contactDetailName,
            string contactDetailValue,
            bool isPrivate,
            ContactDetailType contactType) : base(id)
        {
            ContactDetailName = contactDetailName;
            ContactDetailValue = contactDetailValue;
            IsPrivate = isPrivate;
            ContactType = contactType;
        }

        public string ContactDetailName { get; private set; } = "";
        public string ContactDetailValue { get; private set; } = "";
        public bool IsPrivate { get; private set; }
        public ContactDetailType ContactType { get; private set; } = ContactDetailType.Text;

        public void ChangeContactDetail(string contactDetailName,
            string contactDetailValue,
            bool isPrivate,
            ContactDetailType contactType)
        {
            ContactDetailName = contactDetailName;
            ContactDetailValue = contactDetailValue;
            IsPrivate = isPrivate;
            ContactType = contactType;
        }
    }
}