﻿using System.Collections.Generic;
using CRM.Domain.Branch.Models;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.Branch.Events
{
    [EventVersion("BranchCreatedEvent", 1)]
    public class BranchCreatedEvent : AggregateEvent<BranchAggregate, BranchId>
    {
        public BranchCreatedEvent(string branchName,
            AddressModel address,
            string customerId,
            ICollection<ContactDetailModel> contactDetails)
        {
            BranchName = branchName;
            Address = address;
            CustomerId = customerId;
            ContactDetails = contactDetails;
        }

        public string BranchName { get; }
        public AddressModel Address { get; }
        public string CustomerId { get; }
        public ICollection<ContactDetailModel> ContactDetails { get; }
    }
}