﻿using System.Collections.Generic;
using CRM.Domain.Branch.Entities;
using CRM.Domain.Branch.Models;
using EventFlow.Snapshots;

namespace CRM.Domain.Branch.Snapshots
{
    [SnapshotVersion("Branch", 1)]
    public class BranchSnapshot : ISnapshot
    {
        public BranchSnapshot(string branchName,
            AddressModel address,
            string customerId,
            ICollection<ContactDetail> contactDetails,
            bool deleted,
            bool created)
        {
            BranchName = branchName;
            Address = address;
            CustomerId = customerId;
            ContactDetails = contactDetails;
            Deleted = deleted;
            Created = created;
        }

        public string BranchName { get; }
        public AddressModel Address { get; }
        public string CustomerId { get; }
        public ICollection<ContactDetail> ContactDetails { get; }
        public bool Deleted { get; }
        public bool Created { get; }
    }
}