﻿using System.Collections.Generic;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.CallScript.Events
{
    [EventVersion("CallScriptCreatedEvent", 1)]
    public class CallScriptCreatedEvent : AggregateEvent<CallScriptAggregate, CallScriptId>
    {
        public CallScriptCreatedEvent(string callScriptBody,
            string dossierId,
            List<string> tags)
        {
            CallScriptBody = callScriptBody;
            DossierId = dossierId;
            Tags = tags;
        }

        public string CallScriptBody { get; }
        public string DossierId { get; }
        public List<string> Tags { get; }
    }
}