﻿using CRM.Domain.CallScript.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.CallScript.Events
{
    [EventVersion("CallScriptCommentCreatedEvent", 1)]
    public class CommentCreatedEvent : AggregateEvent<CallScriptAggregate, CallScriptId>
    {
        public CommentCreatedEvent(CallScriptCommentId id,
            string commentBody,
            string commentQuote,
            string userId,
            string callscriptId)
        {
            Id = id;
            CommentBody = commentBody;
            CommentQuote = commentQuote;
            UserId = userId;
            CallscriptId = callscriptId;
        }

        public CallScriptCommentId Id { get; }
        public string CommentBody { get; }
        public string CommentQuote { get; }
        public string UserId { get; }
        public string CallscriptId { get; }
    }
}