﻿using CRM.Domain.CallScript.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.CallScript.Events
{
    [EventVersion("callscriptCommentModified", 1)]
    public class CommentModifiedEvent : AggregateEvent<CallScriptAggregate, CallScriptId>
    {
        public CommentModifiedEvent(string commentBody,
            string commentQuote,
            CallScriptCommentId callscriptCommentId)
        {
            CommentBody = commentBody;
            CommentQuote = commentQuote;
            CallscriptCommentId = callscriptCommentId;
        }

        public string CommentBody { get; }
        public string CommentQuote { get; }
        public CallScriptCommentId CallscriptCommentId { get; }
    }
}