﻿using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.Customer.Events
{
    [EventVersion("CustomerCreatedEvent", 1)]
    public class CustomerCreatedEvent : AggregateEvent<CustomerAggregate, CustomerId>
    {
        public CustomerCreatedEvent(string customerName,
            string tenant,
            int? cCMCLientId,
            int webPortalLicenseAmount)
        {
            CustomerName = customerName;
            Tenant = tenant;
            CCMCLientId = cCMCLientId;
            WebPortalLicenseAmount = webPortalLicenseAmount;
        }

        public string CustomerName { get; }
        public string Tenant { get; }
        public int? CCMCLientId { get; }
        public int WebPortalLicenseAmount { get; }
    }
}