﻿using System.Collections.Generic;
using EventFlow.Snapshots;

namespace CRM.Domain.Customer.Snapshots
{
    [SnapshotVersion("Customer", 1)]
    public class CustomerSnapshot : ISnapshot
    {
        public CustomerSnapshot(bool created,
            bool deleted,
            string customerName,
            string tenant,
            int? cCMCLientId,
            int webPortalLicenseAmount,
            string customerBranchId,
            ICollection<string> subscriptions)
        {
            Created = created;
            Deleted = deleted;
            CustomerName = customerName;
            Tenant = tenant;
            CCMCLientId = cCMCLientId;
            WebPortalLicenseAmount = webPortalLicenseAmount;
            CustomerBranchId = customerBranchId;
            Subscriptions = subscriptions;
        }

        public bool Created { get; }
        public bool Deleted { get; }
        public string CustomerName { get; }
        public string Tenant { get; }
        public int? CCMCLientId { get; }
        public int WebPortalLicenseAmount { get; }
        public string CustomerBranchId { get; }
        public ICollection<string> Subscriptions { get; }
    }
}