﻿using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.Dossier.Events
{
    [EventVersion("DossierCreatedEvent", 1)]
    public class DossierCreatedEvent : AggregateEvent<DossierAggregate, DossierId>
    {
        public DossierCreatedEvent(string dossierName,
            string customerId,
            int? ccmId = null)
        {
            DossierName = dossierName;
            CustomerId = customerId;
            CcmId = ccmId;
        }

        public string DossierName { get; }
        public string CustomerId { get; }
        public int? CcmId { get; }
    }
}