﻿using System.Collections.Generic;
using EventFlow.Entities;

namespace CRM.Domain.Duty.Entities
{
    public class DutyContact : Entity<DutyContactId>
    {
        public DutyContact(DutyContactId id) : base(id)
        {
        }

        public DutyContact(DutyContactId id,
            string contactId,
            ICollection<DutyContactPoint> contactPoints,
            ICollection<string> tags,
            int orderId) : base(id)
        {
            ContactId = contactId;
            ContactPoints = contactPoints;
            Tags = tags;
            OrderId = orderId;
        }

        public string ContactId { get; set; }
        public ICollection<DutyContactPoint> ContactPoints { get; set; }
        public ICollection<string> Tags { get; set; }
        public int OrderId { get; set; }
    }
}