﻿using System.Collections.Generic;
using CRM.Domain.Duty.Entities;
using CRM.Domain.Duty.Models;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.Duty.Events
{
    [EventVersion("DutyEmployeeAddedEvent", 1)]
    public class DutyEmployeeAddedEvent : AggregateEvent<DutyAggregate, DutyId>
    {
        public DutyEmployeeAddedEvent(DutyContactId id,
            string employeeId,
            ICollection<ContactPointModel> contactPoints,
            ICollection<string> tags,
            int orderId)
        {
            Id = id;
            EmployeeId = employeeId;
            ContactPoints = contactPoints;
            Tags = tags;
            OrderId = orderId;
        }

        public DutyContactId Id { get; }
        public string EmployeeId { get; }
        public ICollection<ContactPointModel> ContactPoints { get; }
        public ICollection<string> Tags { get; }
        public int OrderId { get; }
    }
}