﻿using System.Collections.Generic;
using CRM.Domain.Duty.Models;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.Duty.Events
{
    [EventVersion("DutyEmployeeUpdatedEvent", 1)]
    public class DutyEmployeeUpdatedEvent: AggregateEvent<DutyAggregate, DutyId>
    {
        public ICollection<DutyEmployeeModel> DutyEmployees { get; private set; }

        public DutyEmployeeUpdatedEvent(ICollection<DutyEmployeeModel> dutyEmployees)
        {
            DutyEmployees = dutyEmployees;
        }
    }
}