﻿using System;
using System.Collections.Generic;
using System.Linq;
using CRM.Domain.DutyCategoryAndTemplate.Models;
using EventFlow.Entities;

namespace CRM.Domain.DutyCategoryAndTemplate.Entities
{
    public class Duty: Entity<DutyId>
    {
        public Duty(DutyId id) : base(id)
        {
        }

        public Duty(DutyId id, DutyModel model) : base(id)
        {
            Start = model.Start;
            End = model.End;
            Note = model.Note;
            Changes = model.Changes;
            SavedOnce = model.SavedOnce;
            MarkedForDeletion = model.MarkedForDeletion;

            if (model.TimeSlots == null) return;
            TimeSlots = model.TimeSlots.Select(x
                => new TimeSlot(TimeSlotId.With(x.Id), x)).ToList();

        }

        public ICollection<TimeSlot> TimeSlots { get; set; }
        public DateTime Start { get; set; }
        public DateTime End { get; set; }
        public string Note { get; set; }
        public DutyChangesModel Changes { get; set; }
        public bool SavedOnce { get; set; }
        public bool MarkedForDeletion { get; set; }
    }
}
