﻿using System;
using System.Collections.Generic;
using System.Linq;
using CRM.Domain.DutyCategoryAndTemplate.Models;
using CRM.Domain.Shared.ValueObjects;
using EventFlow.Entities;

namespace CRM.Domain.DutyCategoryAndTemplate.Entities
{
    public class TimeSlot: Entity<TimeSlotId>
    {
        public TimeSlot(TimeSlotId id) : base(id)
        {
        }

        public TimeSlot(TimeSlotId id, TimeSlotModelNoMore model) : base(id)
        {
            StartTime = model.StartTime;
            EndTime = model.EndTime;
            WeekDays = model.WeekDays;
            Note = model.Note;
            TimeSlotName = model.TimeSlotName;
            DutyContacts = model.DutyContacts == null
                           ? null
                : model.DutyContacts.Select(x 
                => new DutyContact(DutyContactId.With(x.Id), x)).ToList();
        }

        public TimeSpan StartTime { get; set; }
        public TimeSpan EndTime { get; set; }
        public ICollection<WeekDay> WeekDays { get; set; }
        public string Note { get; set; }
        public string TimeSlotName { get; set; }
        public ICollection<DutyContact> DutyContacts { get; set; }

    }
}
