﻿using System;
using System.Collections.Generic;
using CRM.Domain.DutyCategoryAndTemplate.Models;
using CRM.Domain.Shared.ValueObjects;
using EventFlow.Entities;

namespace CRM.Domain.DutyCategoryAndTemplate.Entities
{
    public class TimeSlotTemplate: Entity<TimeSlotTemplateId>
    {
        public TimeSlotTemplate(TimeSlotTemplateId id,
            TimeSpan startTime,
            TimeSpan endTime,
            ICollection<WeekDay> weekDays,
            string note,
            string timeSlotName) : base(id)
        {
            StartTime = startTime;
            EndTime = endTime;
            WeekDays = weekDays;
            Note = note;
            TimeSlotName = timeSlotName;
        }

        public TimeSlotTemplate(TimeSlotTemplateId id) : base(id)
        {
        }

        public TimeSlotTemplate(TimeSlotTemplateId id, TimeSlotTemplateModel model) : base(id)
        {
            StartTime = model.StartTime;
            EndTime = model.EndTime;
            WeekDays = model.WeekDays;
            Note = model.Note;
            TimeSlotName = model.TimeSlotName;
        }

        public TimeSpan StartTime { get; set; }
        public TimeSpan EndTime { get; set; }
        public ICollection<WeekDay> WeekDays { get; set; }
        public string Note { get; set; }
        public string TimeSlotName { get; set; }
    }
}
