﻿using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.DutyCategoryAndTemplate.Events.DutyCategory.Duties
{
    [EventVersion("DutyModifiedNoteEvent2", 1)]
    public class DutyModifiedNoteEvent : AggregateEvent<DutyCategoryAggregate, DutyCategoryId>
    {
        public DutyModifiedNoteEvent(
            DutyId id, string note)
        {
            Note = note;
            Id = id;
        }

        public string Note { get; }
        public DutyId Id { get; }
    }
}
