﻿using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.DutyCategoryAndTemplate.Events.DutyCategory.Duties.TimeSlots.DutyContacts
{
    [EventVersion("DutyContactAddedEvent2", 1)]
    public class DutyContactAddedEvent : AggregateEvent<DutyCategoryAggregate, DutyCategoryId>
    {

        public DutyContactAddedEvent(DutyId idDuty,
            TimeSlotId idTimeSlot,
            DutyContactId idDutyContact,
            string employeeId,
            int orderId)
        {
            IdDuty = idDuty;
            IdTimeSlot = idTimeSlot;
            IdDutyContact = idDutyContact;
            EmployeeId = employeeId;
            OrderId = orderId;
        }

        public DutyId IdDuty { get; }
        public TimeSlotId IdTimeSlot { get; }
        public  DutyContactId IdDutyContact { get; }
        public string EmployeeId { get; }
        public int OrderId { get; }

    }
}
