﻿using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.DutyCategoryAndTemplate.Events.DutyCategory.Duties.TimeSlots.DutyContacts
{
    [EventVersion("DutyContactDeletedEvent2", 1)]

    public class DutyContactDeletedEvent : AggregateEvent<DutyCategoryAggregate, DutyCategoryId>
    {
        public DutyContactDeletedEvent(DutyId idDuty,
            TimeSlotId idTimeSlot,
            DutyContactId idDutyContact)
        {
            IdDuty = idDuty;
            IdTimeSlot = idTimeSlot;
            IdDutyContact = idDutyContact;
        }

        public DutyId IdDuty { get; }
        public TimeSlotId IdTimeSlot { get; }
        public DutyContactId IdDutyContact { get; }

    }
}
