﻿using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.DutyCategoryAndTemplate.Events.DutyCategory.Duties.TimeSlots.DutyContacts
{
    [EventVersion("DutyContactModifiedEmployeeEvent2", 1)]
    public class DutyContactModifiedEmployeeEvent : AggregateEvent<DutyCategoryAggregate, DutyCategoryId>
    {
        public DutyContactModifiedEmployeeEvent(DutyId idDuty,
            TimeSlotId idTimeSlot,
            DutyContactId idDutyContact, string employeeId)
        {
            IdDuty = idDuty;
            IdTimeSlot = idTimeSlot;
            IdDutyContact = idDutyContact;
            EmployeeId = employeeId;
        }

        public DutyId IdDuty { get; }
        public TimeSlotId IdTimeSlot { get; }
        public DutyContactId IdDutyContact { get; }
        public string EmployeeId { get; }

    }
}
