﻿using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.DutyCategoryAndTemplate.Events.DutyCategory.Duties.TimeSlots.DutyContacts
{
    [EventVersion("DutyContactModifiedOrderIdEvent2", 1)]

    public class DutyContactModifiedOrderIdEvent : AggregateEvent<DutyCategoryAggregate, DutyCategoryId>
    {
        public DutyContactModifiedOrderIdEvent(DutyId idDuty,
            TimeSlotId idTimeSlot,
            DutyContactId idDutyContact,
            int orderId)
        {
            IdDuty = idDuty;
            IdTimeSlot = idTimeSlot;
            IdDutyContact = idDutyContact;
            OrderId = orderId;
        }

        public DutyId IdDuty { get; }
        public TimeSlotId IdTimeSlot { get; }
        public DutyContactId IdDutyContact { get; }
        public int OrderId { get; }

    }
}
