﻿using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.DutyCategoryAndTemplate.Events.DutyCategory.Duties.TimeSlots.DutyContacts.DutyContactPoints
{
    [EventVersion("DutyContactPointAddedEvent2", 1)]
    public class DutyContactPointAddedEvent : AggregateEvent<DutyCategoryAggregate, DutyCategoryId>
    {
        public DutyContactPointAddedEvent(DutyId idDuty,
            TimeSlotId idTimeSlot,
            DutyContactId idDutyContact,
            DutyContactPointId idDutyContactPoint,
            string contactDetailId,
            string description)
        {
            IdDuty = idDuty;
            IdTimeSlot = idTimeSlot;
            IdDutyContact = idDutyContact;
            IdDutyContactPoint = idDutyContactPoint;
            ContactDetailId = contactDetailId;
            Description = description;
        }

        public DutyId IdDuty { get; }
        public TimeSlotId IdTimeSlot { get; }
        public DutyContactId IdDutyContact { get; }
        public DutyContactPointId IdDutyContactPoint { get; }
        public string ContactDetailId { get;}
        public string Description { get; }


    }
}
