﻿using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.DutyCategoryAndTemplate.Events.DutyCategory.Duties.TimeSlots.DutyContacts.DutyContactPoints
{
    [EventVersion("DutyContactPointDeletedEvent2", 1)]

    public class DutyContactPointDeletedEvent : AggregateEvent<DutyCategoryAggregate, DutyCategoryId>
    {
        public DutyContactPointDeletedEvent(DutyId idDuty,
            TimeSlotId idTimeSlot,
            DutyContactId idDutyContact,
            DutyContactPointId idDutyContactPoint)
        {
            IdDuty = idDuty;
            IdTimeSlot = idTimeSlot;
            IdDutyContact = idDutyContact;
            IdDutyContactPoint = idDutyContactPoint;
        }

        public DutyId IdDuty { get; }
        public TimeSlotId IdTimeSlot { get; }
        public DutyContactId IdDutyContact { get; }
        public DutyContactPointId IdDutyContactPoint { get; }

    }
}
