﻿using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.DutyCategoryAndTemplate.Events.DutyCategory.Duties.TimeSlots.DutyContacts.Tags
{
    [EventVersion("DutyContactTagDeletedEvent2", 1)]

    public class DutyContactTagDeletedEvent : AggregateEvent<DutyCategoryAggregate, DutyCategoryId>
    {
        public DutyContactTagDeletedEvent(DutyId idDuty,
            TimeSlotId idTimeSlot,
            DutyContactId idDutyContact,
            string tag)
        {
            IdDuty = idDuty;
            IdTimeSlot = idTimeSlot;
            IdDutyContact = idDutyContact;
            Tag = tag;
        }

        public DutyId IdDuty { get; }
        public TimeSlotId IdTimeSlot { get; }
        public DutyContactId IdDutyContact { get; }
        public string Tag { get; }

    }
}
