﻿using System;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.DutyCategoryAndTemplate.Events.DutyCategory.Duties.TimeSlots
{
    [EventVersion("DutyTimeSlotEndTimeModifiedEvent2", 1)]

    public class DutyTimeSlotEndTimeModifiedEvent : AggregateEvent<DutyCategoryAggregate, DutyCategoryId>
    {
        public DutyTimeSlotEndTimeModifiedEvent(DutyId idDuty,
            TimeSlotId idTimeSlot,
            TimeSpan endTime)
        {
            IdDuty = idDuty;
            IdTimeSlot = idTimeSlot;
            EndTime = endTime;
        }

        public DutyId IdDuty { get; }
        public TimeSlotId IdTimeSlot { get; }
        public TimeSpan EndTime { get; }

    }
}
