﻿using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.DutyCategoryAndTemplate.Events.DutyCategory.Duties.TimeSlots
{
    [EventVersion("DutyTimeSlotNameModifiedEvent2", 1)]

    public class DutyTimeSlotNameModifiedEvent : AggregateEvent<DutyCategoryAggregate, DutyCategoryId>
    {
        public DutyId IdDuty { get; }
        public TimeSlotId IdTimeSlot { get; }
        public string Name { get; }

        public DutyTimeSlotNameModifiedEvent(DutyId idDuty,
            TimeSlotId idTimeSlot,
            string name)
        {
            IdDuty = idDuty;
            IdTimeSlot = idTimeSlot;
            Name = name;
        }
    }
}
