﻿using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.DutyCategoryAndTemplate.Events.DutyCategory.Duties.TimeSlots
{
    [EventVersion("DutyTimeSlotNoteModifiedEvent2", 1)]
    public class DutyTimeSlotNoteModifiedEvent : AggregateEvent<DutyCategoryAggregate, DutyCategoryId>
    {
        public DutyTimeSlotNoteModifiedEvent(DutyId idDuty,
            TimeSlotId idTimeSlot,
            string note)
        {
            IdDuty = idDuty;
            IdTimeSlot = idTimeSlot;
            Note = note;
        }

        public DutyId IdDuty { get; }
        public TimeSlotId IdTimeSlot { get; }
        public string Note { get; }

    }
}
