﻿using System;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.DutyCategoryAndTemplate.Events.DutyCategory.Duties.TimeSlots
{
    [EventVersion("DutyTimeSlotStartTimeModifiedEvent2", 1)]

    public class DutyTimeSlotStartTimeModifiedEvent : AggregateEvent<DutyCategoryAggregate, DutyCategoryId>
    {
        public DutyTimeSlotStartTimeModifiedEvent(DutyId idDuty,
            TimeSlotId idTimeSlot,
            TimeSpan startTime)
        {
            IdDuty = idDuty;
            IdTimeSlot = idTimeSlot;
            StartTime = startTime;
        }

        public DutyId IdDuty { get; }
        public TimeSlotId IdTimeSlot { get; }
        public TimeSpan StartTime { get; }

    }
}
