﻿using System.Collections.Generic;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using CRM.Domain.Shared.ValueObjects;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.DutyCategoryAndTemplate.Events.DutyCategory.Duties.TimeSlots
{
    [EventVersion("DutyTimeSlotWeekdaysModifiedEvent2", 1)]

    public class DutyTimeSlotWeekdaysModifiedEvent : AggregateEvent<DutyCategoryAggregate, DutyCategoryId>
    {
        public DutyTimeSlotWeekdaysModifiedEvent(
            DutyId idDuty,
            TimeSlotId idTimeSlot,
            ICollection<WeekDay> weekDays)
        {
            WeekDays = weekDays;
            IdDuty = idDuty;
            IdTimeSlot = idTimeSlot;
        }

        public ICollection<WeekDay> WeekDays { get; }
        public DutyId IdDuty { get; }
        public TimeSlotId IdTimeSlot { get; }
    }
}
