﻿using System;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.DutyCategoryAndTemplate.Events.DutyCategory.DutyTemplate
{
    [EventVersion("DutyTemplateTimeSlotTemplateEndTimeModifiedEvent2", 1)]

    public class DutyTemplateTimeSlotTemplateEndTimeModifiedEvent : AggregateEvent<DutyCategoryAggregate, DutyCategoryId>
    {
        public DutyTemplateTimeSlotTemplateEndTimeModifiedEvent(TimeSlotTemplateId templateTimeSlotId,
            TimeSpan endTime)
        {
            TemplateTimeSlotId = templateTimeSlotId;
            EndTime = endTime;
        }

        public TimeSlotTemplateId TemplateTimeSlotId { get;}
        public TimeSpan EndTime { get; }

    }
}
