﻿using System;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.DutyCategoryAndTemplate.Events.DutyCategory.DutyTemplate
{
    [EventVersion("DutyTemplateTimeSlotTemplateStartTimeModifiedEvent2", 1)]
    public class DutyTemplateTimeSlotTemplateStartTimeModifiedEvent : AggregateEvent<DutyCategoryAggregate, DutyCategoryId>
    {
        public DutyTemplateTimeSlotTemplateStartTimeModifiedEvent(TimeSlotTemplateId templateTimeSlotId,
            TimeSpan startTime)
        {
            TemplateTimeSlotId = templateTimeSlotId;
            StartTime = startTime;
        }

        public TimeSlotTemplateId TemplateTimeSlotId { get; }
        public TimeSpan StartTime { get; }
    }
}
