﻿using System.Collections.Generic;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using CRM.Domain.Shared.ValueObjects;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.DutyCategoryAndTemplate.Events.DutyCategory.DutyTemplate
{
    [EventVersion("DutyTemplateTimeSlotTemplateWeekdaysModifiedEvent2", 1)]

    public class DutyTemplateTimeSlotTemplateWeekdaysModifiedEvent : AggregateEvent<DutyCategoryAggregate, DutyCategoryId>
    {
        public DutyTemplateTimeSlotTemplateWeekdaysModifiedEvent(TimeSlotTemplateId templateTimeSlotId,
            ICollection<WeekDay> weekDays)
        {
            TemplateTimeSlotId = templateTimeSlotId;
            WeekDays = weekDays;
        }

        public TimeSlotTemplateId TemplateTimeSlotId { get; }
        public ICollection<WeekDay> WeekDays { get; }

    }
}
