﻿using System;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.DutyCategoryAndTemplate.Events.GlobalDutyTemplate.TimeSlots
{
    [EventVersion("GlobalDutyTemplateTimeSlotEndTimeModifiedEvent", 1)]

    public class GlobalDutyTemplateTimeSlotEndTimeModifiedEvent : AggregateEvent<GlobalDutyTemplateAggregate, GlobalDutyTemplateId>
    {
        public GlobalDutyTemplateTimeSlotEndTimeModifiedEvent(TimeSlotTemplateId idTimeSlotTemplate,
            TimeSpan endTime)
        {
            IdTimeSlotTemplate = idTimeSlotTemplate;
            EndTime = endTime;
        }

        public TimeSlotTemplateId IdTimeSlotTemplate { get; }
        public TimeSpan EndTime { get; }
    }
}
