﻿using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.DutyCategoryAndTemplate.Events.GlobalDutyTemplate.TimeSlots
{
    [EventVersion("GlobalDutyTemplateTimeSlotNameModifiedEvent", 1)]
    public class GlobalDutyTemplateTimeSlotNameModifiedEvent : AggregateEvent<GlobalDutyTemplateAggregate, GlobalDutyTemplateId>
    {

        public GlobalDutyTemplateTimeSlotNameModifiedEvent(TimeSlotTemplateId idTimeSlotTemplate,
            string name)
        {
            IdTimeSlotTemplate = idTimeSlotTemplate;
            Name = name;
        }

        public TimeSlotTemplateId IdTimeSlotTemplate { get; }
        public string Name { get; }
    }
}
