﻿using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.DutyCategoryAndTemplate.Events.GlobalDutyTemplate.TimeSlots
{
    [EventVersion("GlobalDutyTemplateTimeSlotNoteModifiedEvent", 1)]

    public class GlobalDutyTemplateTimeSlotNoteModifiedEvent : AggregateEvent<GlobalDutyTemplateAggregate, GlobalDutyTemplateId>
    {

        public GlobalDutyTemplateTimeSlotNoteModifiedEvent(TimeSlotTemplateId idTimeSlotTemplate,
            string note)
        {
            IdTimeSlotTemplate = idTimeSlotTemplate;
            Note = note;
        }

        public TimeSlotTemplateId IdTimeSlotTemplate { get; }
        public string Note { get; }
    }
}
