﻿using System;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.DutyCategoryAndTemplate.Events.GlobalDutyTemplate.TimeSlots
{
    [EventVersion("GlobalDutyTemplateTimeSlotStartTimeModifiedEvent", 1)]
    public class GlobalDutyTemplateTimeSlotStartTimeModifiedEvent : AggregateEvent<GlobalDutyTemplateAggregate, GlobalDutyTemplateId>
    {

        public GlobalDutyTemplateTimeSlotStartTimeModifiedEvent(TimeSlotTemplateId idTimeSlotTemplate,
            TimeSpan startTime)
        {
            IdTimeSlotTemplate = idTimeSlotTemplate;
            StartTime = startTime;
        }
        public TimeSlotTemplateId IdTimeSlotTemplate { get; }
        public TimeSpan StartTime { get; }
    }
}
