﻿using System.Collections.Generic;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using CRM.Domain.Shared.ValueObjects;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.DutyCategoryAndTemplate.Events.GlobalDutyTemplate.TimeSlots
{
    [EventVersion("GlobalDutyTemplateTimeSlotWeekdaysModifiedEvent", 1)]

    public class GlobalDutyTemplateTimeSlotWeekdaysModifiedEvent: AggregateEvent<GlobalDutyTemplateAggregate, GlobalDutyTemplateId>
    {
        public GlobalDutyTemplateTimeSlotWeekdaysModifiedEvent(TimeSlotTemplateId idTimeSlotTemplate,
            ICollection<WeekDay> weekdays)
        {
            IdTimeSlotTemplate = idTimeSlotTemplate;
            Weekdays = weekdays;
        }

        public TimeSlotTemplateId IdTimeSlotTemplate { get; }

        public ICollection<WeekDay> Weekdays { get; }
    }
}
