﻿using CRM.Domain.DutyCategoryAndTemplate.ReadModels;
using System.Collections.Generic;
using System.Linq;

namespace CRM.Domain.DutyCategoryAndTemplate.Models
{
    public class DutyCategoryChangesReadModel
    {
        public string CategoryName { get; set; }
        public string Note { get; set; }
        //public DutyTemplateModel TemplateDuty { get; set; }
        public ICollection<TimeSlotTemplateModel> TimeSlotTemplates { get; set; }

        public string GlobalDutyTemplateId { get; set; }
        public string GlobalDutyTemplateTitle { get; set; }


        public DutyCategoryChangesReadModel()
        {
        }

        //public DutyCategoryChangesReadModel(string categoryName,
        //    string note,
        //    //DutyTemplateModel templateDuty,
        //    string globalDutyTemplateId)
        //{
        //    CategoryName = categoryName;
        //    Note = note;
        //    //TemplateDuty = templateDuty;
        //    GlobalDutyTemplateId = globalDutyTemplateId;
        //}

        public DutyCategoryChangesReadModel(DutyCategoryModel model)
        {
            CategoryName = model.CategoryName;
            Note = model.Note;
            GlobalDutyTemplateId = model.GlobalDutyTemplateId;
            TimeSlotTemplates = model.TimeSlotTemplates
                .Select(x => new TimeSlotTemplateModel(x))
                .ToList();
        }

        public DutyCategoryChangesReadModel(DutyCategoryReadModel model)
        {
            CategoryName = model.CategoryName;
            Note = model.Note;
            GlobalDutyTemplateId = model.GlobalDutyTemplateId;
            TimeSlotTemplates = model.TimeSlotTemplates == null 
                ? new List<TimeSlotTemplateModel>()
                : new List<TimeSlotTemplateModel>(model.TimeSlotTemplates);

        }

        public DutyCategoryChangesReadModel(string categoryName, string note, ICollection<TimeSlotTemplateModel> timeSlotTemplates, string globalDutyTemplateId)
        {
            CategoryName = categoryName;
            Note = note;
            TimeSlotTemplates = timeSlotTemplates;
            GlobalDutyTemplateId = globalDutyTemplateId;
        }
    }
}
