﻿using System.Collections.Generic;
using System.Linq;
using CRM.Domain.DutyCategoryAndTemplate.Entities;

namespace CRM.Domain.DutyCategoryAndTemplate.Models
{
    public class DutyCategoryModel
    {
        public DutyCategoryModel()
        {
        }

        public DutyCategoryModel(string categoryName,
            string note,
            string globalDutyTemplateId, ICollection<TimeSlotTemplate> timeSlotTemplates)
        {
            CategoryName = categoryName;
            Note = note;
            GlobalDutyTemplateId = globalDutyTemplateId;
            TimeSlotTemplates = timeSlotTemplates == null 
                ? new List<TimeSlotTemplate>()
                : new List<TimeSlotTemplate>(timeSlotTemplates);
        }

        public DutyCategoryModel(DutyCategoryChangesReadModel model)
        {
            CategoryName = model.CategoryName;
            Note = model.Note;
            //TemplateDuty = model.TemplateDuty == null ? null
            //    : new DutyTemplate (model.TemplateDuty, DutyTemplateId.With(model.TemplateDuty.Id));
            GlobalDutyTemplateId = model.GlobalDutyTemplateId;
            TimeSlotTemplates = model.TimeSlotTemplates == null
                ? new List<TimeSlotTemplate>()
                : model.TimeSlotTemplates
                    .Select(x => new TimeSlotTemplate(TimeSlotTemplateId.With(x.Id), x))
                    .ToList();

        }


        public string CategoryName { get; set; } 
        public string Note { get; set; }
        //public DutyTemplate TemplateDuty { get; set; }
        public string GlobalDutyTemplateId { get; set; }
        public ICollection<TimeSlotTemplate> TimeSlotTemplates { get; set; }


    }
}
