﻿using System;
using System.Collections.Generic;
using System.Linq;
using CRM.Domain.DutyCategoryAndTemplate.Entities;

namespace CRM.Domain.DutyCategoryAndTemplate.Models
{
    public class DutyChangesModel
    {
        public DutyChangesModel(Duty duty)
        {
            Id = duty.Id.Value;
            TimeSlots = duty.TimeSlots == null
                ? null
                : duty.TimeSlots.Select(x => new TimeSlotModelNoMore(x)).ToList();
            Start = duty.Start;
            End = duty.End;
            Note = duty.Note;
            SavedOnce = duty.SavedOnce;
            MarkedForDeletion = duty.MarkedForDeletion;
        }

        public DutyChangesModel()
        {
        }

        public DutyChangesModel(DutyModel dutyModel)
        {
            Id = dutyModel.Id;
            TimeSlots = new List<TimeSlotModelNoMore>(dutyModel.TimeSlots);
            Start = dutyModel.Start;
            End = dutyModel.End;
            Note = dutyModel.Note;
            SavedOnce = dutyModel.SavedOnce;
            MarkedForDeletion = dutyModel.MarkedForDeletion;
        }

        public DutyChangesModel(string id,
            ICollection<TimeSlotModelNoMore> timeSlots,
            DateTime start,
            DateTime end,
            string note,
            bool savedOnce,
            bool markedForDeletion)
        {
            Id = id;
            TimeSlots = new List<TimeSlotModelNoMore>(timeSlots);
            Start = start;
            End = end;
            Note = note;
            SavedOnce = savedOnce;
            MarkedForDeletion = markedForDeletion;
        }

        public DutyChangesModel(string id)
        {
            Id = id;
        }

        public string Id { get; set; }
        public ICollection<TimeSlotModelNoMore> TimeSlots { get; set; }
        public DateTime Start { get; set; }
        public DateTime End { get; set; }
        public string Note { get; set; }
        public bool SavedOnce { get; set; }
        public bool MarkedForDeletion { get; set; }
    }
}
