﻿using System.Collections.Generic;
using System.Linq;
using CRM.Domain.DutyCategoryAndTemplate.Entities;

namespace CRM.Domain.DutyCategoryAndTemplate.Models
{
    public class DutyContactModel
    {
        public DutyContactModel()
        {
        }

        public DutyContactModel(string id,
            string employeeId,
            ICollection<DutyContactPointModel> contactPoints,
            ICollection<string> tags,
            int orderId)
        {
            Id = id;
            EmployeeId = employeeId;
            ContactPoints = contactPoints;
            Tags = tags;
            OrderId = orderId;
        }

        public DutyContactModel(DutyContact dutyContact)
        {
            Id = dutyContact.Id.Value;
            EmployeeId = dutyContact.EmployeeId;
            ContactPoints = dutyContact.ContactPoints?
                .Select(x => new DutyContactPointModel(x))
                .ToList();
            Tags = dutyContact.Tags;
            OrderId = dutyContact.OrderId;
        }

        public string Id { get; set; }
        public string EmployeeId { get; set; }
        public ICollection<DutyContactPointModel> ContactPoints { get; set; }
        public ICollection<string> Tags { get; set; }
        public int OrderId { get; set; }

    }
}
