﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.CompilerServices;
using CRM.Domain.DutyCategoryAndTemplate.Entities;

namespace CRM.Domain.DutyCategoryAndTemplate.Models
{
    public class DutyModel
    {
        public DutyModel()
        {
        }

        public DutyModel(string id,
            ICollection<TimeSlotModelNoMore> timeSlots,
            DateTime start,
            DateTime end,
            string note,
            DutyChangesModel changes,
            bool savedOnce,
            bool markedForDeletion)
        {
            Id = id;
            TimeSlots = new List<TimeSlotModelNoMore>(timeSlots);
            Start = start;
            End = end;
            Note = note;
            Changes = changes;
            SavedOnce = savedOnce;
            MarkedForDeletion = markedForDeletion;
        }

        public DutyModel(Duty duty)
        {
            Id = duty.Id.Value;
            TimeSlots = duty.TimeSlots?.Select(x => new TimeSlotModelNoMore(x)).ToList();
            Start = duty.Start;
            End = duty.End;
            Note = duty.Note;
            Changes = duty.Changes;
        }


        public string Id { get; set; }
        public ICollection<TimeSlotModelNoMore> TimeSlots { get; set; }
        public DateTime Start { get; set; }
        public DateTime End { get; set; }
        public string Note { get; set; }
        public DutyChangesModel Changes { get; set; }
        public bool SavedOnce { get; set; }
        public bool MarkedForDeletion { get; set; }


    }
}
