﻿using System.Collections.Generic;
using System.Linq;

namespace CRM.Domain.DutyCategoryAndTemplate.Models
{
    public class GlobalDutyTemplateChangesReadModel
    {
        public string Title { get; set; }
        public string Note { get; set; }
        public ICollection<TimeSlotTemplateModel> TimeSlotTemplates { get; set; }


        public GlobalDutyTemplateChangesReadModel()
        {
        }

        public GlobalDutyTemplateChangesReadModel(string title,
            string note,
            ICollection<TimeSlotTemplateModel> timeSlotTemplates)
        {
            Title = title;
            Note = note;
            TimeSlotTemplates = new List<TimeSlotTemplateModel>( timeSlotTemplates);
        }

        public GlobalDutyTemplateChangesReadModel(GlobalDutyTemplateModel model)
        {
            Title = model.Title;
            Note = model.Note;
            TimeSlotTemplates = model.TimeSlotTemplates == null 
                ? new List<TimeSlotTemplateModel>() 
                : model.TimeSlotTemplates.Select(x 
                => new TimeSlotTemplateModel(x)).ToList();
        }

    }
}
