﻿using System.Collections.Generic;
using System.Linq;
using CRM.Domain.DutyCategoryAndTemplate.Entities;

namespace CRM.Domain.DutyCategoryAndTemplate.Models
{
    public class GlobalDutyTemplateModel
    {
        public string Title { get; set; }
        public string Note { get; set; }
        public ICollection<TimeSlotTemplate> TimeSlotTemplates { get; set; }

        public GlobalDutyTemplateModel()
        {
        }

        public GlobalDutyTemplateModel(string title,
            string note,
            ICollection<TimeSlotTemplate> timeSlotTemplates)
        {
            Title = title;
            Note = note;
            TimeSlotTemplates = new List<TimeSlotTemplate>(timeSlotTemplates);
        }

        public GlobalDutyTemplateModel(GlobalDutyTemplateChangesReadModel readModel)
        {
            Title = readModel.Title;
            Note = readModel.Note;
            TimeSlotTemplates = readModel.TimeSlotTemplates.Select(x => new TimeSlotTemplate(TimeSlotTemplateId.With(x.Id), x)).ToList();
        }
    }
}
