﻿using System;
using System.Collections.Generic;
using System.Linq;
using CRM.Domain.DutyCategoryAndTemplate.Abstract;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using CRM.Domain.Shared.ValueObjects;
using CRM.Domain.Shared.Abstract;

namespace CRM.Domain.DutyCategoryAndTemplate.Models
{
    public class TimeSlotModelNoMore: TimeSlotModelAb
    {
        public TimeSlotModelNoMore(TimeSpan startTime,
            TimeSpan endTime,
            ICollection<WeekDay> weekDays,
            string note,
            string timeSlotName,
            string id, ICollection<DutyContactModel> dutyContacts) : base(startTime, endTime, weekDays, note, timeSlotName, id)
        {
            DutyContacts = dutyContacts;
        }
        public TimeSlotModelNoMore()
        {

        }

        public TimeSlotModelNoMore(string id) : base(id)
        {
        }

        public TimeSlotModelNoMore(TimeSlot timeSlot)
        {
            Id = timeSlot.Id.Value;
            StartTime = timeSlot.StartTime;
            EndTime = timeSlot.EndTime;
            WeekDays = timeSlot.WeekDays;
            Note = timeSlot.Note;
            TimeSlotName = timeSlot.TimeSlotName;

            if (timeSlot.DutyContacts == null) return;
            DutyContacts = timeSlot.DutyContacts
                .Select(x => new DutyContactModel(x))
                .ToList();
        }

        public ICollection<DutyContactModel> DutyContacts { get; set; }

    }
}
