﻿using System;
using System.Collections.Generic;
using CRM.Domain.DutyCategoryAndTemplate.Abstract;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using CRM.Domain.Shared.Abstract;
using CRM.Domain.Shared.ValueObjects;

namespace CRM.Domain.DutyCategoryAndTemplate.Models
{
    public class TimeSlotTemplateModel: TimeSlotModelAb
    {
        public TimeSlotTemplateModel()
        {
        }

        public TimeSlotTemplateModel(string id, TimeSpan startTime,
            TimeSpan endTime,
            ICollection<WeekDay> weekDays,
            string note,
            string timeSlotName
            ) : base(startTime, endTime, weekDays, note, timeSlotName, id)
        {
        }

        public TimeSlotTemplateModel(TimeSlotTemplate template)
        {
            Id = template.Id.Value;
            StartTime = template.StartTime;
            EndTime = template.EndTime;
            WeekDays = template.WeekDays;
            Note = template.Note;
            TimeSlotName = template.TimeSlotName;
        }
    }
}
