﻿using System.Collections.Generic;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Models;
using EventFlow.Snapshots;

namespace CRM.Domain.DutyCategoryAndTemplate.Snapshots
{
    [SnapshotVersion("DutyCategory", 1)]
    public class DutyCategorySnapshot: ISnapshot
    {
        public DutyCategorySnapshot(bool created,
            bool deleted,
            string dossierId,
            string categoryName,
            string note,
            //DutyTemplateModel templateDuty,
            ICollection<TimeSlotTemplateModel> timeSlotTemplates,
            ICollection<DutyModel> duties,
            string globalDutyTemplateId,
            DutyCategoryChangesReadModel changes)
        {
            Created = created;
            Deleted = deleted;
            DossierId = dossierId;
            CategoryName = categoryName;
            Note = note;
            //TemplateDuty = templateDuty;
            TimeSlotTemplates = timeSlotTemplates;
            Duties = duties;
            GlobalDutyTemplateId = globalDutyTemplateId;
            Changes = changes;
        }

        public bool Created { get;  }
        public bool Deleted { get; }
        public string DossierId { get;  } 
        public string CategoryName { get;  } 
        public string Note { get;  }
        //public DutyTemplateModel TemplateDuty { get;  }
        public ICollection<DutyModel> Duties { get; }
        public ICollection<TimeSlotTemplateModel> TimeSlotTemplates { get; }
        public string GlobalDutyTemplateId { get;  }


        public DutyCategoryChangesReadModel Changes { get;  }

    }
}
