﻿using System.Collections.Generic;
using CRM.Domain.DutyCategoryAndTemplate.Models;
using EventFlow.Snapshots;

namespace CRM.Domain.DutyCategoryAndTemplate.Snapshots
{
    [SnapshotVersion("GlobalDutyTemplate", 1)]
    public class GlobalDutyTemplateSnapshot : ISnapshot
    {
        public GlobalDutyTemplateSnapshot(bool created,
            bool deleted,
            string title,
            string note,
            int usage,
            GlobalDutyTemplateChangesReadModel changes,
            ICollection<TimeSlotTemplateModel> timeSlotTemplates
            )
        {
            Created = created;
            Deleted = deleted;
            Title = title;
            Note = note;
            Usage = usage;
            Changes = changes;
            TimeSlotTemplates = timeSlotTemplates;
        }

        public bool Created { get; }
        public bool Deleted { get; }
        public string Title { get; } 
        public string Note { get; }
        public int Usage { get; }
        public GlobalDutyTemplateChangesReadModel Changes { get; }
        public ICollection<TimeSlotTemplateModel> TimeSlotTemplates { get; set; }

    }
}
