﻿using EventFlow.Exceptions;
using EventFlow.ValueObjects;
using Newtonsoft.Json;

namespace CRM.Domain.DutyCategoryAndTemplate.ValueObjects
{
    [JsonConverter(typeof(SingleValueObjectConverter))]
    public class WeekDay : SingleValueObject<string>
    {
        public WeekDay(string value) : base(value)
        {
            _ = byte.TryParse(value, out var intVal)
                ? true
                : throw DomainError.With(
                    $"invalid day of week {value}, must be a number between and including 0 and 6");
            _ = (intVal <= 6) ? true : throw DomainError.With($"invalid day of week {value}, must be a number between and including 0 and 6");
        }
    }
}
