using CRM.Domain.Shared.Enums;
using EventFlow.Entities;
using Newtonsoft.Json;

namespace CRM.Domain.Employee.Entities
{
    public class EmployeeContactDetail : Entity<EmployeeContactDetailId>
    {
        public EmployeeContactDetail(EmployeeContactDetailId id) : base(id)
        {
        }

        [JsonConstructor]
        public EmployeeContactDetail(EmployeeContactDetailId id,
            string contactDetailName,
            string contactDetailValue,
            bool isPrivate,
            bool isInternal,
            bool isDefault,
            ContactDetailType contactType) : base(id)
        {
            ContactDetailName = contactDetailName;
            ContactDetailValue = contactDetailValue;
            IsPrivate = isPrivate;
            IsInternal = isInternal;
            IsDefault = isDefault;
            ContactType = contactType;
        }

        public string ContactDetailName { get; set; }
        public string ContactDetailValue { get; set; } 
        public bool IsPrivate { get; set; }
        public bool IsInternal { get; set; }
        public bool IsDefault { get; set; }
        public ContactDetailType ContactType { get; set; }
    }
}