﻿using CRM.Domain.Employee.Entities;
using CRM.Domain.Shared.Enums;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.Employee.Events
{
    [EventVersion("ContactDetailTypeModifiedEvent", 1)]
    public class ContactDetailTypeModifiedEvent: AggregateEvent<EmployeeAggregate, EmployeeId>
    {
        public ContactDetailTypeModifiedEvent(EmployeeContactDetailId id,
            ContactDetailType contactDetailType)
        {
            Id = id;
            ContactDetailType = contactDetailType;
        }

        public EmployeeContactDetailId Id { get; }
        public ContactDetailType ContactDetailType { get; }
    }
}
