using CRM.Domain.Shared.Enums;

namespace CRM.Domain.Employee.Models
{
    public class EmployeeContactDetailModel
    {
        public EmployeeContactDetailModel()
        {
        }

        public EmployeeContactDetailModel(string? contactDetailName,
            string id,
            string? contactDetailValue,
            bool isPrivate,
            bool isInternal,
            bool isDefault,
            ContactDetailType contactType)
        {
            ContactDetailName = contactDetailName;
            Id = id;
            ContactDetailValue = contactDetailValue;
            IsPrivate = isPrivate;
            IsInternal = isInternal;
            IsDefault = isDefault;
            ContactType = contactType;
        }

        public string? ContactDetailName { get; set; } = "";
        public string Id { get; set; } = "";
        public string? ContactDetailValue { get; set; } = "";
        public bool IsPrivate { get; set; }
        public bool IsInternal { get; set; }
        public bool IsDefault { get; set; }

        public ContactDetailType ContactType { get; set; }

        public override bool Equals(object obj)
        {
            if (obj == null)
                return false;
            var otherContact = (EmployeeContactDetailModel) obj;
            if (ContactDetailName == otherContact.ContactDetailName
                && ContactDetailValue == otherContact.ContactDetailValue
                && ContactType == otherContact.ContactType
                && IsPrivate == otherContact.IsPrivate
                && IsInternal == otherContact.IsInternal
                && IsDefault == otherContact.IsDefault)
                return true;
            return false;
        }
    }
}