﻿using CRM.Domain.NeoDuty.Models;
using EventFlow.Entities;

namespace CRM.Domain.NeoDuty.Entities
{
    public class DutyContactPoint : Entity<DutyContactPointId>
    {
        public DutyContactPoint(DutyContactPointId id,
            string description,
            string contactDetailId) : base(id)
        {
            Description = description;
            ContactDetailId = contactDetailId;
        }

        public DutyContactPoint(DutyContactPoint original): base(original.Id)
        {
            ContactDetailId = original.ContactDetailId;
            Description = original.Description;
        }

        public DutyContactPoint(DutyContactPointId id, DutyContactPointModel model) : base(id)
        {
            ContactDetailId = model.ContactDetailId;
            Description = model.Description;
        }

        public string ContactDetailId { get; set; }
        public string Description { get; set; }
    }
}