﻿using CRM.Domain.NeoDuty.Models;
using EventFlow.Aggregates;
using EventFlow.EventStores;
using System.Collections.Generic;

namespace CRM.Domain.NeoDuty.Events
{
    [EventVersion("NeoDutyCreatedEvent", 1)]
    public class NeoDutyCreatedEvent : AggregateEvent<NeoDutyAggregate, NeoDutyId>
    {
        public string DutyCategoryId { get;  }
        public string Note { get;  }
        public ICollection<AddTimeslotModel> TimeSlots { get;  }

        public NeoDutyCreatedEvent(string dutyCategoryId, string note, ICollection<AddTimeslotModel> timeSlots)
        {
            DutyCategoryId = dutyCategoryId;
            Note = note;
            TimeSlots = timeSlots;
        }
    }
}
