﻿using CRM.Domain.NeoDuty.Entities;
using CRM.Domain.NeoDuty.Models;
using EventFlow.Aggregates;
using EventFlow.EventStores;
using System.Collections.Generic;

namespace CRM.Domain.NeoDuty.Events.Timeslot.Contact
{
    [EventVersion("NeoContactAddedEvent", 1)]
    public class NeoContactAddedEvent: AggregateEvent<NeoDutyAggregate, NeoDutyId>
    {
        public NeoContactAddedEvent(TimeSlotId timeSlotId, DutyContactId contactId, string employeeId, List<string> defaultTags, List<DutyContactPointModel> defaultContactPoints)
        {
            TimeSlotId = timeSlotId;
            ContactId = contactId;
            EmployeeId = employeeId;
            DefaultTags = defaultTags;
            DefaultContactPoints = defaultContactPoints;
        }

        public TimeSlotId TimeSlotId { get; }
        public DutyContactId ContactId { get; }
        public string EmployeeId { get; }
        public List<string> DefaultTags { get; }
        public List<DutyContactPointModel> DefaultContactPoints { get; }

    }
}
