﻿using CRM.Domain.NeoDuty.Models;
using EventFlow.Aggregates;
using EventFlow.EventStores;
using System.Collections.Generic;

namespace CRM.Domain.NeoDuty.Events.Timeslot.Contact
{
    [EventVersion("NeoContactAddedToDutyEvent", 1)]
    public class NeoContactAddedToDutyEvent : AggregateEvent<NeoDutyAggregate, NeoDutyId>
    {
        public NeoContactAddedToDutyEvent(string employeeId, List<string> defaultTags, List<AddContactToNeoDutyModel> contactList)
        {
            EmployeeId = employeeId;
            DefaultTags = defaultTags;
            ContactList = contactList;
        }

        public string EmployeeId { get; }
        public List<string> DefaultTags { get; }
        public List<AddContactToNeoDutyModel> ContactList { get;  }
    }
}
