﻿using CRM.Domain.NeoDuty.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.NeoDuty.Events.Timeslot.Contact
{
    [EventVersion("NeoContactOrderIdModifiedEvent", 1)]
    public class NeoContactOrderIdModifiedEvent : AggregateEvent<NeoDutyAggregate, NeoDutyId>
    {
        public NeoContactOrderIdModifiedEvent(TimeSlotId timeslotId, string employeeId, int newOrderId)
        {
            TimeslotId = timeslotId;
            EmployeeId = employeeId;
            NewOrderId = newOrderId;
        }

        public TimeSlotId TimeslotId { get; }
        public string EmployeeId { get; }
        public int NewOrderId { get; }

    }
}
