﻿using CRM.Domain.NeoDuty.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;


namespace CRM.Domain.NeoDuty.Events.Timeslot.Contact
{
    [EventVersion("NeoContactPointAddedEvent", 1)]
    public class NeoContactPointAddedEvent : AggregateEvent<NeoDutyAggregate, NeoDutyId>
    {
        public NeoContactPointAddedEvent(TimeSlotId timeslotId, DutyContactId contactId, DutyContactPointId contactPointId, string contactDetailId)
        {
            TimeslotId = timeslotId;
            ContactId = contactId;
            ContactPointId = contactPointId;
            ContactDetailId = contactDetailId;
        }

        public TimeSlotId TimeslotId { get; }
        public DutyContactId ContactId { get; }
        public DutyContactPointId ContactPointId { get; set; }
        public string ContactDetailId { get; set; }

    }
}
