﻿using CRM.Domain.NeoDuty.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.NeoDuty.Events.Timeslot.Contact
{
    [EventVersion("NeoContactPointRemovedEvent", 1)]
    public class NeoContactPointRemovedEvent : AggregateEvent<NeoDutyAggregate, NeoDutyId>
    {
        public NeoContactPointRemovedEvent(TimeSlotId timeslotId, DutyContactId contactId, DutyContactPointId contactPointId)
        {
            TimeslotId = timeslotId;
            ContactId = contactId;
            ContactPointId = contactPointId;
        }

        public TimeSlotId TimeslotId { get; }
        public DutyContactId ContactId { get; }
        public DutyContactPointId ContactPointId { get; set; }

    }
}
