﻿using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.NeoDuty.Events.Timeslot.Contact
{
    [EventVersion("NeoContactRemovedEvent", 1)]
    public class NeoContactRemovedEvent : AggregateEvent<NeoDutyAggregate, NeoDutyId>
    {
        public NeoContactRemovedEvent(string employeeId, string timeSlotId = null)
        {
            EmployeeId = employeeId;
            TimeSlotId = timeSlotId;
        }

        public string EmployeeId { get; }
        public string TimeSlotId { get; }
    }
}
