﻿using CRM.Domain.NeoDuty.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.NeoDuty.Events.Timeslot.Contact
{
    [EventVersion("NeoTagAddedEvent", 1)]
    public class NeoTagAddedEvent : AggregateEvent<NeoDutyAggregate, NeoDutyId>
    {
        public NeoTagAddedEvent(TimeSlotId timeslotId, DutyContactId contactId, string tag)
        {
            TimeslotId = timeslotId;
            ContactId = contactId;
            Tag = tag;
        }

        public TimeSlotId TimeslotId { get; }
        public DutyContactId ContactId { get; }
        public string Tag { get; }
    }
}
