﻿using CRM.Domain.NeoDuty.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.NeoDuty.Events.Timeslot.Contact
{
    [EventVersion("NeoTagRemovedEvent", 1)]
    public class NeoTagRemovedEvent : AggregateEvent<NeoDutyAggregate, NeoDutyId>
    {
        public NeoTagRemovedEvent(TimeSlotId timeslotId, DutyContactId contactId, string tag)
        {
            TimeslotId = timeslotId;
            ContactId = contactId;
            Tag = tag;
        }

        public TimeSlotId TimeslotId { get; }
        public DutyContactId ContactId { get; }
        public string Tag { get; }

    }
}
