﻿using CRM.Domain.NeoDuty.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;
using System;

namespace CRM.Domain.NeoDuty.Events.Timeslot
{
    [EventVersion("NeoTimeSlotEndTimeModifiedEvent", 1)]
    public class NeoTimeSlotEndTimeModifiedEvent : AggregateEvent<NeoDutyAggregate, NeoDutyId>
    {
        public NeoTimeSlotEndTimeModifiedEvent(TimeSlotId timeslotId, TimeSpan endTime)
        {
            TimeslotId = timeslotId;
            EndTime = endTime;
        }

        public TimeSlotId TimeslotId { get; }
        public TimeSpan EndTime { get; }
    }
}
