﻿using CRM.Domain.NeoDuty.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.NeoDuty.Events.Timeslot
{
    [EventVersion("NeoTimeSlotNoteModifiedEvent", 1)]
    public class NeoTimeSlotNoteModifiedEvent : AggregateEvent<NeoDutyAggregate, NeoDutyId>
    {
        public NeoTimeSlotNoteModifiedEvent(TimeSlotId timeslotId, string note)
        {
            TimeslotId = timeslotId;
            Note = note;
        }

        public TimeSlotId TimeslotId { get; }
        public string Note { get; }
    }
}
