﻿using CRM.Domain.NeoDuty.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;
using System;


namespace CRM.Domain.NeoDuty.Events.Timeslot
{
    [EventVersion("NeoTimeSlotStartTimeModifiedEvent", 1)]
    public class NeoTimeSlotStartTimeModifiedEvent : AggregateEvent<NeoDutyAggregate, NeoDutyId>
    {
        public NeoTimeSlotStartTimeModifiedEvent(TimeSlotId timeslotId, TimeSpan startTime)
        {
            TimeslotId = timeslotId;
            StartTime = startTime;
        }

        public TimeSlotId TimeslotId { get; }
        public TimeSpan StartTime { get; }
    }
}
