﻿using CRM.Domain.NeoDuty.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.NeoDuty.Events.Timeslot
{
    [EventVersion("NeoTimeSlotTitleModifiedEvent", 1)]
    public class NeoTimeSlotTitleModifiedEvent : AggregateEvent<NeoDutyAggregate, NeoDutyId>
    {
        public NeoTimeSlotTitleModifiedEvent(TimeSlotId timeslotId, string title)
        {
            TimeslotId = timeslotId;
            Title = title;
        }

        public TimeSlotId TimeslotId { get; }
        public string Title { get; }
    }
}
