﻿using CRM.Domain.NeoDuty.Entities;
using CRM.Domain.Shared.ValueObjects;
using EventFlow.Aggregates;
using EventFlow.EventStores;
using System.Collections.Generic;

namespace CRM.Domain.NeoDuty.Events.Timeslot
{
    [EventVersion("NeoWeekdaysModifiedEvent", 1)]
    public class NeoWeekdaysModifiedEvent : AggregateEvent<NeoDutyAggregate, NeoDutyId>
    {
        public NeoWeekdaysModifiedEvent(TimeSlotId timeslotId, ICollection<WeekDay> weekDays)
        {
            TimeslotId = timeslotId;
            WeekDays = weekDays;
        }

        public TimeSlotId TimeslotId { get; }
        public ICollection<WeekDay> WeekDays { get; }
    }
}
