﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace CRM.Domain.NeoDuty.Models
{
    public class NeoDutyChangesReadModel
    {
        public string DutyCategoryId { get; set; }
        public string Note { get; set; }
        public DateTime Start { get; set; }
        public DateTime End { get; set; }
        public bool SavedOnce { get; set; }
        public bool AutomaticallyDestroy { get; set; }
        public ICollection<TimeSlotModel> TimeSlots { get; set; }

        public NeoDutyChangesReadModel()
        {
        }

        public NeoDutyChangesReadModel(string dutyCategoryId, string note, DateTime start, DateTime end, bool savedOnce, bool automaticallyDestroy, ICollection<TimeSlotModel> timeSlots)
        {
            DutyCategoryId = dutyCategoryId;
            Note = note;
            Start = start;
            End = end;
            SavedOnce = savedOnce;
            AutomaticallyDestroy = automaticallyDestroy;
            TimeSlots = new List<TimeSlotModel>(timeSlots);
        }

        public NeoDutyChangesReadModel(NeoDutyModel model, string dutyCategoryId, bool savedOnce)
        {
            DutyCategoryId = dutyCategoryId;
            Note = model.Note;
            Start = model.Start;
            End = model.End;    
            AutomaticallyDestroy = model.AutomaticallyDestroy;
            SavedOnce = savedOnce;
            TimeSlots = model.TimeSlots == null
                ? new List<TimeSlotModel>()
                : model.TimeSlots.Select(x =>
                new TimeSlotModel(x)).ToList();    
        }

    }
}
