﻿using CRM.Domain.NeoDuty.Entities;
using System;
using System.Collections.Generic;
using System.Linq;

namespace CRM.Domain.NeoDuty.Models
{
    public class NeoDutyModel
    {
        public string Note { get; set; } 
        public DateTime Start { get; set; } 
        public DateTime End { get; set; }
        public bool AutomaticallyDestroy { get; set; }
        public ICollection<TimeSlot> TimeSlots { get; set; }

        public NeoDutyModel()
        {
        }
        public NeoDutyModel(NeoDutyChangesReadModel model)
        {
            Note = model.Note;
            Start = model.Start;
            End = model.End;
            AutomaticallyDestroy = model.AutomaticallyDestroy;
            TimeSlots = model.TimeSlots == null
                ? new List<TimeSlot>()
                : model.TimeSlots.Select(x =>
                new TimeSlot(TimeSlotId.With(x.Id), x)).ToList();
        }


    }
}
