﻿using CRM.Domain.NeoDuty.Models;
using EventFlow.Snapshots;
using System;
using System.Collections.Generic;

namespace CRM.Domain.NeoDuty.Snapshots
{
    [SnapshotVersion("NeoDuty", 1)]
    public class NeoDutySnapshot: ISnapshot
    {
        public bool Created { get; }
        public bool Deleted { get; }
        public string DutyCategoryId { get;  }
        public string Note { get;  }
        public DateTime Start { get;  }
        public DateTime End { get;  }
        public bool SavedOnce { get;  }
        public bool AutomaticallyDestroy { get;  }
        public NeoDutyChangesReadModel Changes { get;  }
        public ICollection<TimeSlotModel> TimeSlots { get;  }

        public NeoDutySnapshot(bool created, bool deleted, string dutyCategoryId, string note, DateTime start, DateTime end, bool savedOnce, bool automaticallyDestroy, NeoDutyChangesReadModel changes, ICollection<TimeSlotModel> timeSlots)
        {
            Created = created;
            Deleted = deleted;
            DutyCategoryId = dutyCategoryId;
            Note = note;
            Start = start;
            End = end;
            SavedOnce = savedOnce;
            AutomaticallyDestroy = automaticallyDestroy;
            Changes = changes;
            TimeSlots = timeSlots;
        }
    }
}
