﻿using System;
using System.Collections.Generic;
using CRM.Domain.Shared.ValueObjects;

namespace CRM.Domain.Shared.Abstract
{
    public abstract class TimeSlotModelAb
    {
        public TimeSpan StartTime { get; set; }
        public TimeSpan EndTime { get; set; }
        public ICollection<WeekDay> WeekDays { get; set; }
        public string Note { get; set; }
        public string TimeSlotName { get; set; }
        public string Id { get; set; }

        protected TimeSlotModelAb(TimeSpan startTime,
            TimeSpan endTime,
            ICollection<WeekDay> weekDays,
            string note,
            string timeSlotName,
            string id)
        {
            StartTime = startTime;
            EndTime = endTime;
            WeekDays = weekDays;
            Note = note;
            TimeSlotName = timeSlotName;
            Id = id;
        }

        protected TimeSlotModelAb()
        {
        }

        protected TimeSlotModelAb(string id)
        {
            Id = id;
        }
    }
}
