﻿using CRM.Domain.Ticket.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.Ticket.Events
{
    [EventVersion("CommentAddedEvent", 1)]
    public class CommentAddedEvent : AggregateEvent<TicketAggregate, TicketId>
    {
        public CommentAddedEvent(TicketCommentId id,
            string commentBody,
            string commentQuote,
            string userId)
        {
            Id = id;
            CommentBody = commentBody;
            CommentQuote = commentQuote;
            UserId = userId;
        }

        public TicketCommentId Id { get; }
        public string CommentBody { get; }
        public string CommentQuote { get; }
        public string UserId { get; }
    }
}