﻿using CRM.Domain.Ticket.Entities;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.Ticket.Events
{
    [EventVersion("ticketCommentModified", 1)]
    public class CommentModifiedEvent : AggregateEvent<TicketAggregate, TicketId>
    {
        public CommentModifiedEvent(string commentBody,
            string commentQuote,
            TicketCommentId commentId)
        {
            CommentId = commentId;
            CommentBody = commentBody;
            CommentQuote = commentQuote;
        }

        public TicketCommentId CommentId { get; }
        public string CommentBody { get; }
        public string CommentQuote { get; }
    }
}