﻿using System;
using System.Collections.Generic;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.Ticket.Events
{
    [EventVersion("TicketCreatedEvent", 1)]
    public class TicketCreatedEvent : AggregateEvent<TicketAggregate, TicketId>
    {
        public TicketCreatedEvent(string DossierId,
            string ticketText,
            int? originalCCMMessageId,
            DateTime createdInCRM,
            DateTime lastModifiedInCRM,
            string createdCRMUser,
            string lastModifiedCRMUser,
            ICollection<string> tags)
        {
            this.DossierId = DossierId;
            TicketText = ticketText;
            OriginalCCMMessageId = originalCCMMessageId;
            CreatedInCRM = createdInCRM;
            LastModifiedInCRM = lastModifiedInCRM;
            CreatedCRMUser = createdCRMUser;
            LastModifiedCRMUser = lastModifiedCRMUser;
            Tags = tags;
        }

        public string DossierId { get; }
        public string TicketText { get; }
        public int? OriginalCCMMessageId { get; }
        public DateTime CreatedInCRM { get; }
        public DateTime LastModifiedInCRM { get; }
        public string CreatedCRMUser { get; }
        public string LastModifiedCRMUser { get; }
        public ICollection<string> Tags { get; }
    }
}