﻿using System;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.Ticket.Events
{
    [EventVersion("TicketModifiedEvent", 1)]
    public class TicketModifiedEvent : AggregateEvent<TicketAggregate, TicketId>
    {
        public TicketModifiedEvent(string ticketText,
            DateTime lastModifiedInCRM,
            string lastModifiedCRMUser)
        {
            TicketText = ticketText;
            LastModifiedInCRM = lastModifiedInCRM;
            LastModifiedCRMUser = lastModifiedCRMUser;
        }

        public string TicketText { get; }
        public DateTime LastModifiedInCRM { get; }
        public string LastModifiedCRMUser { get; }
    }
}