﻿using CRM.Domain.User.Models;
using CRM.Domain.User.ValueObjects;
using EventFlow.Entities;

namespace CRM.Domain.User.Entities
{
    public class ModuleRight : Entity<ModuleRightId>
    {
        public ModuleRight(ModuleRightId id,
            ModuleRightModel model) : base(id)
        {
            Duties = model.Duties;
            Statistics = model.Statistics;
            Tickets = model.Tickets;
            AutoTreeview = model.AutoTreeview;
            CallScript = model.CallScript;
            UserManagement = model.UserManagement;
            VirtualReception = model.VirtualReception;
        }

        public ModuleRight(ModuleRightId id) : base(id)
        {
        }

        public ModuleAccessLevel Tickets { get; set; } = ModuleAccessLevel.None;
        public ModuleAccessLevel VirtualReception { get; set; } = ModuleAccessLevel.None;
        public ModuleAccessLevel UserManagement { get; set; } = ModuleAccessLevel.None;
        public ModuleAccessLevel CallScript { get; set; } = ModuleAccessLevel.None;
        public ModuleAccessLevel Statistics { get; set; } = ModuleAccessLevel.None;
        public ModuleAccessLevel Duties { get; set; } = ModuleAccessLevel.None;

        public ModuleAccessLevel AutoTreeview { get; set; } = ModuleAccessLevel.None;
    }
}