﻿using CRM.Domain.User.Entities;
using CRM.Domain.User.Models;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.User.Events
{
    [EventVersion("ModuleRightCustomerAddedEvent", 1)]
    public class ModuleRightCustomerAddedEvent : AggregateEvent<UserAggregate, UserId>
    {
        public ModuleRightCustomerAddedEvent(ModuleRightModel moduleRight,
            string customerId)
        {
            ModuleRight = moduleRight;
            CustomerId = customerId;
        }

        public ModuleRightModel ModuleRight { get; }
        public string CustomerId { get; }
    }
}