﻿using CRM.Domain.User.Entities;
using CRM.Domain.User.Models;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.User.Events
{
    [EventVersion("ModuleRightCustomerGroupAddedEvent", 1)]
    public class ModuleRightCustomerGroupAddedEvent : AggregateEvent<UserAggregate, UserId>
    {
        public ModuleRightCustomerGroupAddedEvent(ModuleRightModel moduleRight,
            string customerGroupId)
        {
            ModuleRight = moduleRight;
            CustomerGroupId = customerGroupId;
        }

        public ModuleRightModel ModuleRight { get; }
        public string CustomerGroupId { get; }
    }
}