﻿using CRM.Domain.User.Entities;
using CRM.Domain.User.Models;
using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.User.Events
{
    [EventVersion("ModuleRightDossierModifiedEvent", 1)]
    public class ModuleRightDossierModifiedEvent : AggregateEvent<UserAggregate, UserId>
    {
        public ModuleRightDossierModifiedEvent(ModuleRightModel moduleRight,
            string dossierId)
        {
            ModuleRight = moduleRight;
            DossierId = dossierId;
        }

        public ModuleRightModel ModuleRight { get; }
        public string DossierId { get; }
    }
}