﻿using EventFlow.Aggregates;
using EventFlow.EventStores;

namespace CRM.Domain.User.Events
{
    [EventVersion("UserConnectedToEmployeeEvent", 1)]
    public class UserConnectedToEmployeeEvent : AggregateEvent<UserAggregate, UserId>
    {
        public UserConnectedToEmployeeEvent(string? employeeId)
        {
            EmployeeId = employeeId;
        }

        public string? EmployeeId { get; }
    }
}