﻿using System.Collections.Generic;
using CRM.Domain.User.Entities;
using CRM.Domain.User.Models;
using EventFlow.Aggregates;

namespace CRM.Domain.User.Events
{
    public class UserCustomerModuleRightsModifiedEvent: IAggregateEvent<UserAggregate, UserId>
    {
        public IReadOnlyDictionary<string, ModuleRightModel> ModuleRights { get; }
        public UserCustomerModuleRightsModifiedEvent(IReadOnlyDictionary<string, ModuleRightModel> moduleRights)
        {
            ModuleRights = moduleRights;
        }
    }
}