﻿using System.Collections.Generic;
using CRM.Domain.User.Entities;
using EventFlow.Snapshots;

namespace CRM.Domain.User.Snapshots
{
    [SnapshotVersion("User", 1)]
    public class UserSnapshot : ISnapshot
    {
        public UserSnapshot(bool created,
            bool deleted,
            string email,
            string userName,
            string customerId,
            bool isCompanyAdmin,
            string employeeId,
            string authenticationId,
            Dictionary<string,ModuleRight> customerModuleRights,
            Dictionary<string,ModuleRight> customerGroupModuleRights,
            Dictionary<string,ModuleRight> dossierModuleRights)
        {
            Created = created;
            Deleted = deleted;
            Email = email;
            UserName = userName;
            CustomerId = customerId;
            IsCustomerAdmin = isCompanyAdmin;
            EmployeeId = employeeId;
            AuthenticationId = authenticationId;
            CustomerModuleRights = customerModuleRights;
            CustomerGroupModuleRights = customerGroupModuleRights;
            DossierModuleRights = dossierModuleRights;
        }

        public bool Created { get; set; }
        public bool Deleted { get; }

        public string Email { get; }
        public string UserName { get; }
        public string CustomerId { get; }
        public bool IsCustomerAdmin { get; }
        public string EmployeeId { get; }
        public string AuthenticationId { get; }

        public Dictionary<string, ModuleRight> CustomerModuleRights { get; }

        public Dictionary<string, ModuleRight> CustomerGroupModuleRights { get; }

        public Dictionary<string, ModuleRight> DossierModuleRights { get; }
    }
}