﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;
using WebPortal.Application.Service.EventsReader;
using WebPortal.Application.Service.EventsReader.QueryEvents;

// For more information on enabling Web API for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860

namespace WebPortal.API.Controllers
{
    public class EventController : BaseController
    {
        private MongoEventReaderService _service;

        public EventController(IConfiguration configuration)
        {
            _service = new MongoEventReaderService(configuration);
        }

        // GET: api/<EventController>
        [HttpGet]
        public async Task<IActionResult> Get([FromQuery] GetEventsModel param, CancellationToken token)
        {
            try
            {
                var result = await _service.GetLastEvents(param.Amount, param.Page, token);
                return Ok(result);
            }
            catch (Exception e)
            {
                return StatusCode(500, e.Message);
            }
        }

        [HttpGet]
        [Route("filteredEvent")]
        public async Task<IActionResult> GetFilteredEvents([FromQuery] GetFilteredEventsModel param, CancellationToken token)
        {
            try
            {
                var result = await _service.GetEventsContain(param.Filter,param.Amount, param.Page, token);
                return Ok(result);
            }
            catch (Exception e)
            {
                return StatusCode(500, e.Message);
            }
        }
    }
}