﻿using System;
using System.Security.Cryptography;
using System.Text;

namespace WebPortal.API.Helpers
{
    public static class GeneratorHelper
    {
        public static string RandomPassword => GeneratePassword(16, 1);

        private static string GeneratePassword(int Length,
            int NonAlphaNumericChars)
        {
            string allowedChars = "abcdefghijkmnopqrstuvwxyzABCDEFGHJKLMNOPQRSTUVWXYZ0123456789";
            string allowedNonAlphaNum = "!@#$%^&*()_-+=[{]};:<>|./?";
            string pass = "";
            Random rd = new Random(DateTime.Now.Millisecond);
            for (var i = 0; i < Length; i++)
                if (rd.Next(1) > 0 && NonAlphaNumericChars > 0)
                {
                    pass += allowedNonAlphaNum[rd.Next(allowedNonAlphaNum.Length)];
                    NonAlphaNumericChars--;
                }
                else
                {
                    pass += allowedChars[rd.Next(allowedChars.Length)];
                }

            return pass;
        }

        public static string UsernameHasher(string strword)
        {
            MD5 md5 = MD5.Create();
            byte[] inputBytes = Encoding.ASCII.GetBytes(strword);
            byte[] hash = md5.ComputeHash(inputBytes);
            StringBuilder sb = new StringBuilder();
            for (var i = 0; i < hash.Length; i++) sb.Append(hash[i].ToString("x2"));
            return sb.ToString();
        }
    }
}