﻿using System.Collections.Generic;
using EventFlow.Aggregates;
using EventFlow.Core;
using EventFlow.EventStores;

namespace WebPortal.API.Helpers
{
    public class MetaDataProvider: IMetadataProvider
    {
        private readonly IUserContext _userContext;

        public MetaDataProvider(IUserContext userContext)
        {
            _userContext = userContext;
        }
        public IEnumerable<KeyValuePair<string, string>> ProvideMetadata<TAggregate, TIdentity>(TIdentity id,
            IAggregateEvent aggregateEvent,
            IMetadata metadata) where TAggregate : IAggregateRoot<TIdentity> where TIdentity : IIdentity
        {
            return new Dictionary<string, string>
            {
                {"userId", _userContext.User.Id},
                {"userName",_userContext.User.UserName }
            };
        }
    }
}