﻿using System.Linq;
using System.Threading;
using CRM.Domain.User.ReadModels;
using EventFlow.Queries;
using Microsoft.AspNetCore.Http;
using WebPortal.Application.Users.Queries;

namespace WebPortal.API.Helpers
{
    public class UserContext: IUserContext
    {
        public UserReadModel User { get; }
        public UserContext(IHttpContextAccessor httpContextAccessor, IQueryProcessor queryProcessor)
        {
            
            var httpContext = httpContextAccessor.HttpContext;
            var userid = httpContext.User.Claims.FirstOrDefault(x => x.Type == "user_id").Value;
            var userQuery = new GetUserQuery(userid);
            User = queryProcessor.Process(userQuery, CancellationToken.None);
        }


    }
}