﻿using System;
using Microsoft.AspNetCore;
using Microsoft.AspNetCore.Hosting;

namespace WebPortal.API;

    public class Program
    {
        public static void Main(string[] args)
        {
            CreateWebHostBuilder(args).Build().Run();
        }

        public static IWebHostBuilder CreateWebHostBuilder(string[] args)
        {
            var environment = Environment.GetEnvironmentVariable("ASPNETCORE_ENVIRONMENT");
            var isDevelopment = environment == EnvironmentName.Development;

            if (isDevelopment)
                return WebHost.CreateDefaultBuilder(args)
                    .UseStartup<Startup>();
            else
                return WebHost.CreateDefaultBuilder(args)
                    .UseStartup<Startup>()
                    .UseSentry();
        }
    }
