﻿using System.Collections.Generic;
using CRM.Domain.Branch;
using CRM.Domain.Branch.Models;
using EventFlow.Commands;
using WebPortal.Application.Branches.Models;

namespace WebPortal.Application.Branches.Commands
{
    public class CreateBranchCommand : Command<BranchAggregate, BranchId>
    {
        public CreateBranchCommand(BranchId aggregateId,
            string branchName,
            AddressModel address,
            string customerId,
            ICollection<ContactDetailModel> contactDetails) : base(aggregateId)
        {
            BranchName = branchName;
            Address = address;
            CustomerId = customerId;
            ContactDetails = contactDetails;
        }

        public CreateBranchCommand(BranchId aggregateId,
            CreateDossierBranchModel model) : base(aggregateId)
        {
            BranchName = model.BranchName;
            Address = model.Address;
            CustomerId = model.CustomerId;
            ContactDetails = model.ContactDetails;
        }

        public string BranchName { get; }
        public AddressModel Address { get; }
        public string CustomerId { get; }
        public ICollection<ContactDetailModel> ContactDetails { get; }
    }
}