﻿using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Branch.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.Application.Branches.Queries
{
    public class GetBranchByBranchIdQueryHandler : IQueryHandler<GetBranchByBranchIdQuery, BranchReadModel>
    {
        private readonly IMongoDbReadModelStore<BranchReadModel> _branchStore;

        public GetBranchByBranchIdQueryHandler(IMongoDbReadModelStore<BranchReadModel> branchStore)
        {
            _branchStore = branchStore;
        }

        public Task<BranchReadModel> ExecuteQueryAsync(GetBranchByBranchIdQuery query,
            CancellationToken cancellationToken)
        {
            if (string.IsNullOrEmpty(query.CustomerId))
                return Task.Run(() => _branchStore.AsQueryable().FirstOrDefault(x => x.Id.Equals(query.BranchId)),
                    cancellationToken);

            return Task.FromResult(_branchStore.AsQueryable()
                .FirstOrDefault(x => x.Id.Equals(query.BranchId) && x.CustomerId.Equals(query.CustomerId)));
        }
    }
}