﻿using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Branch.ReadModels;
using CRM.Domain.Customer.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.Application.Branches.Queries
{
    public class GetHqByCustomerIdQueryHandler : IQueryHandler<GetHqByCustomerIdQuery, BranchReadModel>
    {
        private readonly IMongoDbReadModelStore<BranchReadModel> _branchStore;
        private readonly IMongoDbReadModelStore<CustomerReadModel> _customerStore;

        public GetHqByCustomerIdQueryHandler(IMongoDbReadModelStore<CustomerReadModel> customerStore,
            IMongoDbReadModelStore<BranchReadModel> branchStore)
        {
            _customerStore = customerStore;
            _branchStore = branchStore;
        }

        public Task<BranchReadModel> ExecuteQueryAsync(GetHqByCustomerIdQuery query,
            CancellationToken cancellationToken)
        {
       
                var customer = _customerStore.AsQueryable().FirstOrDefault(x => x.Id.Equals(query.CustomerId));
                if (customer == null) throw new Exception("Customer not found");
                return Task.FromResult(_branchStore.AsQueryable().FirstOrDefault(x => x.Id.Equals(customer.CustomerBranchId)));
        }
    }
}