﻿using System;
using CRM.Domain.CallScript;
using EventFlow.Commands;

namespace WebPortal.Application.CallScripts.Commands
{
    public class CreateCallScriptCommentCommand : Command<CallScriptAggregate, CallScriptId>
    {
        public CreateCallScriptCommentCommand(CallScriptId callsscriptId,
            DateTime createdOn,
            DateTime lastModified,
            string commentBody,
            string commentQuote,
            string userId,
            string commentId) : base(callsscriptId)
        {
            CreatedOn = createdOn;
            LastModified = lastModified;
            CommentBody = commentBody;
            CommentQuote = commentQuote;
            UserId = userId;
            CommentId = commentId;
        }


        public string CommentBody { get; }
        public string CommentQuote { get; }
        public string UserId { get; }
        public string CommentId { get; }
        public DateTime CreatedOn { get; }
        public DateTime LastModified { get; }
    }
}