﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.CallScript;
using CRM.Domain.CallScript.Entities;
using EventFlow.Aggregates.ExecutionResults;
using EventFlow.Commands;

namespace WebPortal.Application.CallScripts.Commands
{
    public class CreateCallScriptCommentCommandHandler : CommandHandler<CallScriptAggregate, CallScriptId,
        IExecutionResult, CreateCallScriptCommentCommand>
    {
        public override Task<IExecutionResult> ExecuteCommandAsync(CallScriptAggregate aggregate,
            CreateCallScriptCommentCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(
                () => aggregate.UpsertComment(command.CommentBody, command.CommentQuote, command.UserId,
                    new CallScriptCommentId(command.CommentId), command.AggregateId.ToString()), cancellationToken);
        }
    }
}