﻿using CRM.Domain.CallScript;
using CRM.Domain.CallScript.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.CallScripts.Commands
{
    public class ModifyCallScriptCommentCommand : Command<CallScriptAggregate, CallScriptId>
    {
        public ModifyCallScriptCommentCommand(CallScriptId aggregateId,
            CallScriptCommentId callscriptCommentId,
            string commentBody,
            string commentQuote,
            string userId,
            string callscriptId) : base(aggregateId)
        {
            CallscriptCommentId = callscriptCommentId;
            CommentBody = commentBody;
            CommentQuote = commentQuote;
            UserId = userId;
            CallscriptId = callscriptId;
        }

        public CallScriptCommentId CallscriptCommentId { get; }

        public string CommentBody { get; }
        public string CommentQuote { get; }
        public string UserId { get; }
        public string CallscriptId { get; }
    }
}