﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.CallScript;
using EventFlow.Aggregates.ExecutionResults;
using EventFlow.Commands;

namespace WebPortal.Application.CallScripts.Commands
{
    public class ModifyCallScriptCommentCommandHandler : CommandHandler<CallScriptAggregate, CallScriptId,
        IExecutionResult, ModifyCallScriptCommentCommand>
    {
        public override Task<IExecutionResult> ExecuteCommandAsync(CallScriptAggregate aggregate,
            ModifyCallScriptCommentCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.UpsertComment(command.CommentBody, command.CommentQuote, command.UserId,
                command.CallscriptCommentId, command.CallscriptId));
        }
    }
}