﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.CallScript;
using EventFlow.Aggregates.ExecutionResults;
using EventFlow.Commands;

namespace WebPortal.Application.CallScripts.Commands
{
    public class RemoveCallScriptCommentCommandHandler : CommandHandler<CallScriptAggregate, CallScriptId,
        IExecutionResult, RemoveCallScriptCommentCommand>
    {
        public override Task<IExecutionResult> ExecuteCommandAsync(CallScriptAggregate aggregate,
            RemoveCallScriptCommentCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.RemoveComment(command.CallscriptCommentId));
        }
    }
}