﻿using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.CallScript.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;
using WebPortal.Application.CallScripts.Models;

namespace WebPortal.Application.CallScripts.Queries
{
    public class
        GetCallScriptQueryHandler : IQueryHandler<GetCallScriptQuery,
            GetCallScriptWithCommentsModel>
    {
        private readonly IMongoDbReadModelStore<CallScriptReadModel> _callScriptStore;

        public GetCallScriptQueryHandler(IMongoDbReadModelStore<CallScriptReadModel> callScriptStore)
        {
            _callScriptStore = callScriptStore;
        }

        public Task<GetCallScriptWithCommentsModel> ExecuteQueryAsync(GetCallScriptQuery query,
            CancellationToken cancellationToken)
        {
         
                var temp = _callScriptStore.AsQueryable()
                    .Where(x => !x.Deleted && x.Id == query.Id)
                    .Select(x => new GetCallScriptWithCommentsModel
                    {
                        DossierId = x.DossierId,
                        CallScriptBody = x.CallScriptBody,
                        Id = x.Id,
                        Comments = x.CommentList,
                        Tags = x.Tags,
                        TotalComments = x.CommentList.Count
                    }).FirstOrDefault();
                return Task.FromResult(temp);
        }
    }
}