﻿using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.CallScript.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;
using WebPortal.Application.CallScripts.Models;

namespace WebPortal.Application.CallScripts.Queries
{
    public class
        GetDataForDashboardCallscriptQueryHandler : IQueryHandler<GetDataForDashboardCallscriptQuery,
            GetCallScriptDashboardDataModel>
    {
        private readonly IMongoDbReadModelStore<CallScriptReadModel> _store;

        public GetDataForDashboardCallscriptQueryHandler(IMongoDbReadModelStore<CallScriptReadModel> store)
        {
            _store = store;
        }

        public Task<GetCallScriptDashboardDataModel> ExecuteQueryAsync(GetDataForDashboardCallscriptQuery query,
            CancellationToken cancellationToken)
        {
            
                var queryList = _store.AsQueryable().Where(x => x.DossierId.Equals(query.DossierId));
                var total = queryList.Count();
                var lastUpdate = queryList.OrderByDescending(x => x.Updated).FirstOrDefault();

                return Task.FromResult(new GetCallScriptDashboardDataModel
                {
                    TotalScripts = total,
                    LastUpdate = lastUpdate?.Updated
                });
        }
    }
}