﻿using System.Collections.Generic;
using CRM.Domain.CallScript.Models;
using EventFlow.Queries;

namespace WebPortal.Application.CallScripts.Queries
{
    public class GetMoreCommentsForCallScriptQuery : IQuery<List<CallScriptCommentModel>>
    {
        public GetMoreCommentsForCallScriptQuery(string callScriptId,
            int amountAlreadyLoaded,
            int commentAmount,
            bool commentOrderAscending)
        {
            CallScriptId = callScriptId;
            AmountAlreadyLoaded = amountAlreadyLoaded;
            CommentAmount = commentAmount;
            CommentOrderAscending = commentOrderAscending;
        }

        public string CallScriptId { get; }
        public int AmountAlreadyLoaded { get; set; }
        public int CommentAmount { get; set; }
        public bool CommentOrderAscending { get; set; }
    }
}