﻿using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Customer.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.Application.Customers.Queries
{
    public class GetCustomerByIdQueryHandler : IQueryHandler<GetCustomerByIdQuery, CustomerReadModel>
    {
        private readonly IMongoDbReadModelStore<CustomerReadModel> _store;

        public GetCustomerByIdQueryHandler(IMongoDbReadModelStore<CustomerReadModel> store)
        {
            _store = store;
        }

        public Task<CustomerReadModel> ExecuteQueryAsync(GetCustomerByIdQuery query,
            CancellationToken cancellationToken)
        {
            return Task.FromResult(
                _store
                    .AsQueryable()
                    .SingleOrDefault(x => x.Id == query.Id)
            );
        }
    }
}