﻿using CRM.Domain.Dossier;
using EventFlow.Commands;

namespace WebPortal.Application.Dossiers.Commands
{
    public class CreateDossierCommand : Command<DossierAggregate, DossierId>
    {
        public CreateDossierCommand(DossierId aggregateId,
            string name,
            string customerId,
            int? ccmId = null) : base(aggregateId)
        {
            Name = name;
            CustomerId = customerId;
            CcmId = ccmId;
        }

        public string Name { get; }
        public string CustomerId { get; }
        public int? CcmId { get; }
    }
}