﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Dossier;
using EventFlow.Commands;

namespace WebPortal.Application.Dossiers.Commands
{
    public class CreateDossierCommandHandler : CommandHandler<DossierAggregate, DossierId, CreateDossierCommand>
    {
        public override Task ExecuteAsync(DossierAggregate aggregate,
            CreateDossierCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.CreateDossier(command.Name, command.CustomerId, command.CcmId),
                cancellationToken);
        }
    }
}