﻿using CRM.Domain.Customer;
using CRM.Domain.Dossier.ReadModels;
using CRM.Domain.User.ReadModels;
using WebPortal.Application.Extentions;

namespace WebPortal.Application.Dossiers.Queries
{
    public class GetAllDossiersQuery : PageQuery<DossierReadModel>
    {
        public GetAllDossiersQuery(bool asc,
            string sort,
            int page,
            int pageSize,
            string? dossierName,
            string? customerId,
            string? clientId,
            string? branchId,
            UserReadModel user) : base(asc, sort, page, pageSize)
        {
            DossierName = dossierName != null ? dossierName.ToLower() : "";
            CustomerId = customerId;
            ClientId = clientId;
            BranchId = branchId;
            User = user;
        }

        public string? DossierName { get; }
        public string? CustomerId { get; }
        public string? ClientId { get; }
        public string? BranchId { get; }
        public UserReadModel? User { get; }
    }
}