﻿using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Dossier.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.Application.Dossiers.Queries
{
    public class GetDossierQueryHandler : IQueryHandler<GetDossierQuery, DossierReadModel>
    {
        private readonly IMongoDbReadModelStore<DossierReadModel> _store;

        public GetDossierQueryHandler(IMongoDbReadModelStore<DossierReadModel> store)
        {
            _store = store;
        }

        public Task<DossierReadModel> ExecuteQueryAsync(GetDossierQuery query,
            CancellationToken cancellationToken)
        {
            return Task.FromResult(_store.AsQueryable().FirstOrDefault(x => x.Id.Equals(query.DossierId)));
        }
    }
}