﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Duty;
using EventFlow.Commands;

namespace WebPortal.Application.Duties.Commands
{
    public class AddDutyCommandHandler : CommandHandler<DutyAggregate, DutyId, AddDutyCommand>

    {
        public override Task ExecuteAsync(DutyAggregate aggregate,
            AddDutyCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(
                () => aggregate.CreateDutyWithEmployees(command.Category, command.StartDate, command.EndDate,
                    command.ActionDescription, command.DossierId, command.DutyEmployeeModels, command.StartAt,
                    command.EndAt), cancellationToken);
        }
    }
}