﻿using System;
using System.Collections.Generic;
using CRM.Domain.Duty;
using CRM.Domain.Duty.Models;
using EventFlow.Commands;
using WebPortal.Application.Duties.Models;

namespace WebPortal.Application.Duties.Commands
{
    public class UpdateDutyCommand : Command<DutyAggregate, DutyId>
    {
        public UpdateDutyCommand(DutyId aggregateId,
            CreateDutyModel model) : base(aggregateId)
        {
            StartDate = model.StartDate;
            EndDate = model.EndDate;
            Category = model.Category;
            ActionDescription = model.ActionDescription;
            DossierId = model.DossierId;
            DutyEmployees = model.DutyEmployees;
            EndAt = model.EndAt;
            StartAt = model.StartAt;
        }

        public DateTime StartDate { get; set; }
        public DateTime EndDate { get; set; }
        public string Category { get; set; }
        public string ActionDescription { get; set; }
        public string DossierId { get; set; }
        public ICollection<DutyEmployeeModel> DutyEmployees { get; set; }
        public string EndAt { get; set; }
        public string StartAt { get; set; }
    }
}