﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Duty;
using EventFlow.Commands;

namespace WebPortal.Application.Duties.Commands
{
    public class UpdateDutyCommandHandler : CommandHandler<DutyAggregate, DutyId, UpdateDutyCommand>
    {
        public override Task ExecuteAsync(DutyAggregate aggregate,
            UpdateDutyCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
            {
                aggregate.Update(command.StartDate, command.EndDate, command.StartAt, command.EndAt, command.Category,
                    command.ActionDescription,
                    command.DossierId, command.DutyEmployees);
            }, cancellationToken);
        }
    }
}