﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Duty;
using EventFlow.Commands;

namespace WebPortal.Application.Duties.Commands
{
    public class UpdateDutyEndTimeCommandHandler : CommandHandler<DutyAggregate, DutyId, UpdateDutyEndTimeCommand>
    {
        public override Task ExecuteAsync(DutyAggregate aggregate,
            UpdateDutyEndTimeCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.ModifyDutyEndTime(command.EndDate, command.EndAt), cancellationToken);
        }
    }
}