﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Duty;
using EventFlow.Commands;

namespace WebPortal.Application.Duties.Commands
{
    public class UpdateDutyStartTimeCommandHandler : CommandHandler<DutyAggregate, DutyId, UpdateDutyStartTimeCommand>
    {
        public override Task ExecuteAsync(DutyAggregate aggregate,
            UpdateDutyStartTimeCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.ModifyDutyStartTime(command.StartDate, command.StartAt), cancellationToken);
        }
    }
}