﻿using System;
using System.Collections.Generic;
using System.Linq;
using EventFlow.Queries;
using WebPortal.Application.Duties.Models;
using WebPortal.Application.Extentions;

namespace WebPortal.Application.Duties.Queries
{
    /// <summary>
    ///     Tags en filterText zijn nog niet geïmplementeerd
    /// </summary>
    public class GetDutiesQuery : IQuery<PageResult<GetOverviewDutyModel>>
    {
        public GetDutiesQuery(string dossierId,
            int page = 1,
            bool asc = true,
            int pageSize = 30,
            string sort = "CompleteStartDate",
            string tagIds = null,
            string filterText = "")
        {
            Asc = asc;
            Sort = sort;
            Page = page;
            PageSize = pageSize;
            DossierId = dossierId;
            FilterText = filterText ?? "";
            TagIds = string.IsNullOrWhiteSpace(tagIds)
                ? new List<string>()
                : tagIds.Split(';').ToList();
        }

        public bool Asc { get; }
        public string Sort { get; }
        public int Page { get; }
        public int PageSize { get; }
        public string DossierId { get; }
        public string FilterText { get; }

        public List<string> TagIds { get; }
    }
}