﻿using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Duty.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;
using WebPortal.Application.Duties.Models;

namespace WebPortal.Application.Duties.Queries
{
    public class GetDutyCategoriesQueryHandler : IQueryHandler<GetDutyCategoriesQuery, GetCategoriesModel>
    {
        private readonly IMongoDbReadModelStore<DutyReadModel> _dutyStore;

        public GetDutyCategoriesQueryHandler(IMongoDbReadModelStore<DutyReadModel> dutyStore)
        {
            _dutyStore = dutyStore;
        }

        public Task<GetCategoriesModel> ExecuteQueryAsync(GetDutyCategoriesQuery query,
            CancellationToken cancellationToken)
        {
            return Task.FromResult(new GetCategoriesModel
            {
                Categories = _dutyStore
                    .AsQueryable()
                    .Where(x => x.DossierId.Equals(query.DossierId))
                    .Select(x => x.Category)
                    .Distinct().ToList()
           });
        }
    }
}