﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands
{
    public class CancelDutyCategoryCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public CancelDutyCategoryCommand(DutyCategoryId aggregateId) : base(aggregateId)
        {
        }
    }

    public class CancelDutyCategoryCommandHandler : CommandHandler<DutyCategoryAggregate, DutyCategoryId, CancelDutyCategoryCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            CancelDutyCategoryCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.CancelDutyCategory(), cancellationToken);
        }
    }
}
