﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands
{
    public class ClearDutyCategoryCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public ClearDutyCategoryCommand(DutyCategoryId aggregateId) : base(aggregateId)
        {
        }
    }

    public class ClearDutyCategoryCommandHandler : CommandHandler<DutyCategoryAggregate, DutyCategoryId, ClearDutyCategoryCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate, ClearDutyCategoryCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() =>
            aggregate.ClearDutyCategory(), cancellationToken);
        }
    }
}
