﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands
{
    public class CreateDutyCategoryCommand: Command<DutyCategoryAggregate,DutyCategoryId>
    {
        public CreateDutyCategoryCommand(DutyCategoryId aggregateId,
            string dossierId
            ) : base(aggregateId)
        {
            DossierId = dossierId;
        }

        public string DossierId { get; }
    }

    public class
        CreateDutyCategoryCommandHandler : CommandHandler<DutyCategoryAggregate, DutyCategoryId, CreateDutyCategoryCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            CreateDutyCategoryCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
            aggregate.CreateDutyCategory(command.DossierId), cancellationToken);
        }


    }


}
