﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands
{
    public class DeleteDutyCategoryCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public DeleteDutyCategoryCommand(DutyCategoryId aggregateId) : base(aggregateId)
        {
        }
    }

    public class
        DeleteDutyCategoryCommandHandler : CommandHandler<DutyCategoryAggregate, DutyCategoryId,
            DeleteDutyCategoryCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            DeleteDutyCategoryCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.DeleteDutyCategory(), cancellationToken);
        }
    }
}
