﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands.Duties
{
    public class AddDutyCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public AddDutyCommand(DutyCategoryId aggregateId,
            DutyId id) : base(aggregateId)
        {
            Id = id;
        }

        public DutyId Id { get; }
    }

    public class AddDutyCommandHandler : CommandHandler<DutyCategoryAggregate,
        DutyCategoryId, AddDutyCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            AddDutyCommand command,
            CancellationToken cancellationToken)
        {
           return Task.Run(() =>
                aggregate.AddDuty(command.Id), cancellationToken);
        }
    }
}
