﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands.Duties
{
    public class DeleteDutyCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public DeleteDutyCommand(DutyCategoryId aggregateId,
            DutyId id) : base(aggregateId)
        {
            Id = id;
        }

        public DutyId Id { get; }
    }

    public class DeleteDutyCommandHandler : CommandHandler<DutyCategoryAggregate,
        DutyCategoryId, DeleteDutyCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            DeleteDutyCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.DeleteDuty(command.Id), cancellationToken);
        }
    }
}
