﻿using System;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands.Duties
{
    public class ModifyEndDutyCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public ModifyEndDutyCommand(DutyCategoryId aggregateId,
            DutyId id,
            DateTime end) : base(aggregateId)
        {
            Id = id;
            End = end;
        }

        public DutyId Id { get; }
        public DateTime End { get; }

    }

    public class ModifyEndDutyCommandHandler : CommandHandler<DutyCategoryAggregate,
        DutyCategoryId, ModifyEndDutyCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            ModifyEndDutyCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifyEndDuty(command.Id, command.End), cancellationToken);
        }
    }
}

