﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands.Duties
{
    public class ModifyNoteDutyCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public ModifyNoteDutyCommand(DutyCategoryId aggregateId,
            
            DutyId id, string note) : base(aggregateId)
        {
            Note = note;
            Id = id;
        }

        public string Note { get; }
        public DutyId Id { get; }

    }

    public class ModifyNoteDutyCommandHandler : CommandHandler<DutyCategoryAggregate,
        DutyCategoryId, ModifyNoteDutyCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            ModifyNoteDutyCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifyNoteDuty(command.Id, command.Note), cancellationToken);
        }
    }
}
