﻿using System;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands.Duties
{
    public class ModifyStartDutyCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public ModifyStartDutyCommand(DutyCategoryId aggregateId,
            DutyId id,
            DateTime start) : base(aggregateId)
        {
            Id = id;
            Start = start;
        }

        public DutyId Id { get; }
        public DateTime Start { get; set; }

    }

    public class ModifyStartDutyCommandHandler : CommandHandler<DutyCategoryAggregate,
        DutyCategoryId, ModifyStartDutyCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            ModifyStartDutyCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifyStartDuty(command.Id, command.Start), cancellationToken);
        }
    }
}
