﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands.Duties.TimeSlots
{
    public class AddTimeSlotDutyCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public DutyId IdDuty { get; }
        public TimeSlotId IdTimeSlot { get; }

        public AddTimeSlotDutyCommand(DutyCategoryId aggregateId,
            DutyId idDuty,
            TimeSlotId idTimeSlot) : base(aggregateId)
        {
            IdDuty = idDuty;
            IdTimeSlot = idTimeSlot;
        }
    }

    public class AddTimeSlotDutyCommandHandler : CommandHandler<DutyCategoryAggregate,
        DutyCategoryId, AddTimeSlotDutyCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            AddTimeSlotDutyCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.AddTimeSlotToDuty(command.IdDuty, command.IdTimeSlot), cancellationToken);
        }
    }
}
