﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands.Duties.TimeSlots.DutyContacts
{
    public class AddDutyContactCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public AddDutyContactCommand(DutyCategoryId aggregateId,
            DutyId idDuty,
            TimeSlotId idTimeSlot,
            DutyContactId idDutyContact,
            string employeeId,
            int orderId) : base(aggregateId)
        {
            IdDuty = idDuty;
            IdTimeSlot = idTimeSlot;
            IdDutyContact = idDutyContact;
            EmployeeId = employeeId;
            OrderId = orderId;
        }

        public DutyId IdDuty { get; }
        public TimeSlotId IdTimeSlot { get; }
        public DutyContactId IdDutyContact { get; }
        public string EmployeeId { get; }
        public int OrderId { get; }

    }

    public class AddDutyContactCommandHandler : CommandHandler<DutyCategoryAggregate,
        DutyCategoryId, AddDutyContactCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            AddDutyContactCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() => 
                aggregate.AddDutyContact(command.IdDuty, command.IdTimeSlot, command.IdDutyContact, command.EmployeeId, command.OrderId), cancellationToken);
        }
    }
}
