﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands.Duties.TimeSlots.DutyContacts
{
    public class DeleteDutyContactCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public DeleteDutyContactCommand(DutyCategoryId aggregateId,
            DutyId idDuty,
            TimeSlotId idTimeSlot,
            DutyContactId idDutyContact) : base(aggregateId)
        {
            IdDuty = idDuty;
            IdTimeSlot = idTimeSlot;
            IdDutyContact = idDutyContact;
        }

        public DutyId IdDuty { get; }
        public TimeSlotId IdTimeSlot { get; }
        public DutyContactId IdDutyContact { get; }
    }

    public class DeleteDutyContactCommandHandler : CommandHandler<DutyCategoryAggregate,
        DutyCategoryId, DeleteDutyContactCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            DeleteDutyContactCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                    aggregate.DeleteDutyContact(command.IdDuty, command.IdTimeSlot, command.IdDutyContact),
                cancellationToken);
        }
    }
}
