﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands.Duties.TimeSlots.DutyContacts.DutyContactPoints
{
    public class AddDutyContactPointCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public AddDutyContactPointCommand(DutyCategoryId aggregateId,
            DutyId idDuty,
            TimeSlotId idTimeSlot,
            DutyContactId idDutyContact,
            DutyContactPointId idDutyContactPoint,
            string contactDetailId,
            string description) : base(aggregateId)
        {
            IdDuty = idDuty;
            IdTimeSlot = idTimeSlot;
            IdDutyContact = idDutyContact;
            IdDutyContactPoint = idDutyContactPoint;
            ContactDetailId = contactDetailId;
            Description = description;
        }

        public DutyId IdDuty { get; }
        public TimeSlotId IdTimeSlot { get; }
        public DutyContactId IdDutyContact { get; }
        public DutyContactPointId IdDutyContactPoint { get; }
        public string ContactDetailId { get; }
        public string Description { get; }
    }

    public class AddDutyContactPointCommandHandler : CommandHandler<DutyCategoryAggregate,
        DutyCategoryId, AddDutyContactPointCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            AddDutyContactPointCommand command,
            CancellationToken cancellationToken)
        {
            var c = command;
            return Task.Run(() =>
                aggregate.AddContactPointToDutyContact(c.IdDuty,c.IdTimeSlot,c.IdDutyContact, c.IdDutyContactPoint,c.Description,c.ContactDetailId), cancellationToken);
        }
    }
}
