﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands.Duties.TimeSlots.DutyContacts.DutyContactPoints
{
    public class DeleteDutyContactPointCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public DeleteDutyContactPointCommand(DutyCategoryId aggregateId,
            DutyId idDuty,
            TimeSlotId idTimeSlot,
            DutyContactId idDutyContact,
            DutyContactPointId dutyContactPoint) : base(aggregateId)
        {
            IdDuty = idDuty;
            IdTimeSlot = idTimeSlot;
            IdDutyContact = idDutyContact;
            IDutyContactPoint = dutyContactPoint;
        }

        public DutyId IdDuty { get; }
        public TimeSlotId IdTimeSlot { get; }
        public DutyContactId IdDutyContact { get; }
        public DutyContactPointId IDutyContactPoint { get; }
    }

    public class DeleteDutyContactPointCommandHandler : CommandHandler<DutyCategoryAggregate,
        DutyCategoryId, DeleteDutyContactPointCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            DeleteDutyContactPointCommand command,
            CancellationToken cancellationToken)
        {
            var c = command;
            return Task.Run(() =>
                aggregate.DeleteContactPointFromDutyContact(c.IdDuty, c.IdTimeSlot, c.IdDutyContact, c.IDutyContactPoint), cancellationToken);
        }
    }
}
