﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands.Duties.TimeSlots.DutyContacts
{
    public class ModifyEmployeeDutyContactCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public ModifyEmployeeDutyContactCommand(DutyCategoryId aggregateId,
            DutyId idDuty,
            TimeSlotId idTimeSlot,
            DutyContactId idDutyContact,
            string employeeId) : base(aggregateId)
        {
            IdDuty = idDuty;
            IdTimeSlot = idTimeSlot;
            IdDutyContact = idDutyContact;
            EmployeeId = employeeId;
        }

        public DutyId IdDuty { get; }
        public TimeSlotId IdTimeSlot { get; }
        public DutyContactId IdDutyContact { get; }
        public string EmployeeId { get; }
    }

    public class ModifyEmployeeDutyContactCommandHandler : CommandHandler<DutyCategoryAggregate,
        DutyCategoryId, ModifyEmployeeDutyContactCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            ModifyEmployeeDutyContactCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifyEmployeeDutyContact(command.IdDuty, command.IdTimeSlot, command.IdDutyContact, command.EmployeeId), cancellationToken);
        }
    }
}
