﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands.Duties.TimeSlots.DutyContacts
{
    public class ModifyOrderIdDutyContactCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public ModifyOrderIdDutyContactCommand(DutyCategoryId aggregateId,
            DutyId idDuty,
            TimeSlotId idTimeSlot,
            DutyContactId idDutyContact,
            int orderId) : base(aggregateId)
        {
            IdDuty = idDuty;
            IdTimeSlot = idTimeSlot;
            IdDutyContact = idDutyContact;
            OrderId = orderId;
        }

        public DutyId IdDuty { get; }
        public TimeSlotId IdTimeSlot { get; }
        public DutyContactId IdDutyContact { get; }
        public int OrderId { get; }
    }

    public class ModifyOrderIdDutyContactCommandHandler : CommandHandler<DutyCategoryAggregate,
        DutyCategoryId, ModifyOrderIdDutyContactCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            ModifyOrderIdDutyContactCommand command,
            CancellationToken cancellationToken)
        {
            var c = command;
            return Task.Run(() =>
                aggregate.ModifyOrderIdDutyContact(c.IdDuty, c.IdTimeSlot, c.IdDutyContact, c.OrderId), cancellationToken);
        }
    }
}
