﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands.Duties.TimeSlots.DutyContacts.Tags
{
    public class DeleteDutyContactTagCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public DeleteDutyContactTagCommand(DutyCategoryId aggregateId,
            DutyId idDuty,
            TimeSlotId idTimeSlot,
            DutyContactId idDutyContact,
            string tag) : base(aggregateId)
        {
            IdDuty = idDuty;
            IdTimeSlot = idTimeSlot;
            IdDutyContact = idDutyContact;
            Tag = tag;
        }

        public DutyId IdDuty { get; }
        public TimeSlotId IdTimeSlot { get; }
        public DutyContactId IdDutyContact { get; }
        public string Tag { get; }
    }

    public class DeleteDutyContactTagCommandHandler : CommandHandler<DutyCategoryAggregate,
        DutyCategoryId, DeleteDutyContactTagCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            DeleteDutyContactTagCommand command,
            CancellationToken cancellationToken)
        {
            var c = command;
            return Task.Run(() =>
                aggregate.DeleteTagFromDutyContact(c.IdDuty, c.IdTimeSlot, c.IdDutyContact, c.Tag));
        }
    }

}
