﻿using System;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands.Duties.TimeSlots
{
    public class ModifyStartTimeTimeSlotDutyCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public ModifyStartTimeTimeSlotDutyCommand(DutyCategoryId aggregateId,
            DutyId idDuty,
            TimeSlotId idTimeSlot,
            TimeSpan startTime) : base(aggregateId)
        {
            IdDuty = idDuty;
            IdTimeSlot = idTimeSlot;
            StartTime = startTime;
        }

        public DutyId IdDuty { get; }
        public TimeSlotId IdTimeSlot { get; }
        public TimeSpan StartTime { get; }

    }

    public class ModifyStartTimeTimeSlotDutyCommandHandler : CommandHandler<DutyCategoryAggregate,
        DutyCategoryId, ModifyStartTimeTimeSlotDutyCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            ModifyStartTimeTimeSlotDutyCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifyTimeSlotStartTimeInDuty(command.IdDuty,command.IdTimeSlot,command.StartTime), cancellationToken);
        }
    }
}
