﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands.DutyTemplate
{
    public class AddTimeSlotTemplateCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public AddTimeSlotTemplateCommand(DutyCategoryId aggregateId,
            TimeSlotTemplateId templateTimeSlotId) : base(aggregateId)
        {
            TemplateTimeSlotId = templateTimeSlotId;
        }

        public TimeSlotTemplateId TemplateTimeSlotId { get; }
    }

    public class AddTimeSlotTemplateCommandHandler : CommandHandler<DutyCategoryAggregate,
        DutyCategoryId, AddTimeSlotTemplateCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            AddTimeSlotTemplateCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.AddTimeSlotInDutyTemplate(command.TemplateTimeSlotId), cancellationToken);
        }
    }
}
