﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands.DutyTemplate
{
    public class DeleteTimeSlotTemplateCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public DeleteTimeSlotTemplateCommand(DutyCategoryId aggregateId,
            TimeSlotTemplateId templateTimeSlotId) : base(aggregateId)
        {
            TemplateTimeSlotId = templateTimeSlotId;
        }

        public TimeSlotTemplateId TemplateTimeSlotId { get; }
    }

    public class DeleteTimeSlotTemplateCommandHandler : CommandHandler<DutyCategoryAggregate,
        DutyCategoryId, DeleteTimeSlotTemplateCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            DeleteTimeSlotTemplateCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() 
                    => aggregate.DeleteTimeSlotInDutyTemplate(command.TemplateTimeSlotId), 
                cancellationToken
                );
        }
    }
}
