﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands.DutyTemplate
{
    public class ModifyNoteDutyTemplateCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public string Note { get; }

        public ModifyNoteDutyTemplateCommand(DutyCategoryId aggregateId,
            string note) : base(aggregateId)
        {
            Note = note;
        }
    }

    public class
        ModifyNoteDutyTemplateCommandHandler : CommandHandler<DutyCategoryAggregate, DutyCategoryId,
            ModifyNoteDutyTemplateCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            ModifyNoteDutyTemplateCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifyDutyCategoryDutyTemplateNote(command.Note), cancellationToken);
        }
    }
}
