﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands.DutyTemplate
{
    public class ModifyNoteTimeSlotTemplateCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public ModifyNoteTimeSlotTemplateCommand(DutyCategoryId aggregateId,
            TimeSlotTemplateId templateTimeSlotId,
            string note) : base(aggregateId)
        {
            TemplateTimeSlotId = templateTimeSlotId;
            Note = note;
        }

        public TimeSlotTemplateId TemplateTimeSlotId { get; }
        public string Note { get; }
    }

    public class ModifyNoteTimeSlotTemplateCommandHandler : CommandHandler<DutyCategoryAggregate,
        DutyCategoryId, ModifyNoteTimeSlotTemplateCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            ModifyNoteTimeSlotTemplateCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifyNoteTimeSlotDutyTemplate(command.TemplateTimeSlotId, command.Note), cancellationToken);
        }
    }
}
