﻿using System;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands.DutyTemplate
{
    public class ModifyStartTimeTimeSlotTemplateCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public ModifyStartTimeTimeSlotTemplateCommand(DutyCategoryId aggregateId,
            TimeSlotTemplateId templateTimeSlotId,
            TimeSpan startTime) : base(aggregateId)
        {
            TemplateTimeSlotId = templateTimeSlotId;
            StartTime = startTime;
        }

        public TimeSlotTemplateId TemplateTimeSlotId { get; }
        public TimeSpan StartTime { get; }

    }

    public class ModifyStartTimeTimeSlotTemplateCommandHandler : CommandHandler<DutyCategoryAggregate,
        DutyCategoryId, ModifyStartTimeTimeSlotTemplateCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            ModifyStartTimeTimeSlotTemplateCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifyStartTimeTimeSlotDutyTemplate(command.TemplateTimeSlotId, command.StartTime),
                cancellationToken);
        }
    }
}
