﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands
{
    public class ModifyGlobalDutyTemplateDutyCategoryCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public ModifyGlobalDutyTemplateDutyCategoryCommand(DutyCategoryId aggregateId,
            string globalDutyTemplateId) : base(aggregateId)
        {
            GlobalDutyTemplateId = globalDutyTemplateId;
        }

        public string GlobalDutyTemplateId { get; }
    }

    public class ModifyGlobalDutyTemplateDutyCategoryCommandHandler : CommandHandler<DutyCategoryAggregate,
        DutyCategoryId, ModifyGlobalDutyTemplateDutyCategoryCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            ModifyGlobalDutyTemplateDutyCategoryCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifyDutyCategoryGlobalDutyId(command.GlobalDutyTemplateId), cancellationToken);
        }
    }
}
