﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands
{
    public class ModifyNameDutyCategoryCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public string CategoryName { get; }

        public ModifyNameDutyCategoryCommand(DutyCategoryId aggregateId,
            string categoryName) : base(aggregateId)
        {
            CategoryName = categoryName;
        }
    }

    public class ModifyNameDutyCategoryCommandHandler : CommandHandler<DutyCategoryAggregate, DutyCategoryId,ModifyNameDutyCategoryCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            ModifyNameDutyCategoryCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifyDutyCategoryName(command.CategoryName), cancellationToken);
        }
    }
}
