﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands
{
    public class RemoveGlobalDutyIdCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public RemoveGlobalDutyIdCommand(DutyCategoryId aggregateId) : base(aggregateId)
        {
        }
    }

    public class RemoveGlobalDutyIdCommandHandler : CommandHandler<DutyCategoryAggregate, DutyCategoryId, RemoveGlobalDutyIdCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate, RemoveGlobalDutyIdCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() =>
            aggregate.RemoveGlobalDutyId(), cancellationToken);
        }
    }
}
