﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using EventFlow.Commands;

namespace WebPortal.Application.DutyCategories.Commands
{
    public class SaveDutyCategoryCommand : Command<DutyCategoryAggregate, DutyCategoryId>
    {
        public SaveDutyCategoryCommand(DutyCategoryId aggregateId) : base(aggregateId)
        {
        }
    }

    public class SaveDutyCategoryCommandHandler : CommandHandler<DutyCategoryAggregate, DutyCategoryId,SaveDutyCategoryCommand>
    {
        public override Task ExecuteAsync(DutyCategoryAggregate aggregate,
            SaveDutyCategoryCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.SaveDutyCategory(),cancellationToken);
        }
    }
}
