﻿using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.Application.DutyCategories.Queries
{
    public class GetDutyDossierIdQuery: IQuery<string>
    {
        public string Id { get; set; }

        public GetDutyDossierIdQuery(string id)
        {
            Id = id;
        }
    }

    public class GetDutyDossierIdQueryHandler : IQueryHandler<GetDutyDossierIdQuery, string>
    {
        public GetDutyDossierIdQueryHandler(IMongoDbReadModelStore<DutyCategoryReadModel> store)
        {
            _store = store;
        }

        private readonly IMongoDbReadModelStore<DutyCategoryReadModel> _store;

        public Task<string> ExecuteQueryAsync(GetDutyDossierIdQuery query,
            CancellationToken cancellationToken)
        {
            return Task.FromResult(
                GetResult(query)
            );
        }

        private string GetResult(GetDutyDossierIdQuery query)
        {
            var result = _store.AsQueryable()
                .SingleOrDefault(x => !x.Deleted && query.Id == x.Id);
            return result == null ? "" : result.DossierId;
        }
    }
}
