﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Employee;
using EventFlow.Commands;

namespace WebPortal.Application.Employees.Commands
{
    public class AddEmployeeCommandHandler : CommandHandler<EmployeeAggregate, EmployeeId, AddEmployeeCommand>
    {
        public override Task ExecuteAsync(EmployeeAggregate aggregate,
            AddEmployeeCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(
                () => aggregate.CreateEmployee(command.CustomerId, command.FirstName, command.LastName, command.CCEmail,
                    command.EmployeeComment, command.SendMailWithTicket, command.SetTicketAsRead,
                    command.ContactDetails, command.Tags,command.DefaultTags, command.CanBeOnDuty, command.EmployeeAddress),
                cancellationToken);
        }
    }
}