﻿using System.Collections.Generic;
using CRM.Domain.Employee;
using CRM.Domain.Employee.Models;
using EventFlow.Commands;

namespace WebPortal.Application.Employees.Commands
{
    public class ModifyEmployeeCommand : Command<EmployeeAggregate, EmployeeId>
    {
        public ModifyEmployeeCommand(EmployeeId aggregateId,
            string customerId,
            string firstName,
            string lastName,
            string cCEmail,
            string employeeComment,
            bool sendMailWithTicket,
            bool setTicketAsRead,
            ICollection<EmployeeContactDetailModel> contactDetails,
            ICollection<string> tags,
            ICollection<string> defaultTags,
            bool canBeOnDuty,
            Address employeeAddress) : base(aggregateId)
        {
            CustomerId = customerId;
            FirstName = firstName;
            LastName = lastName;
            CCEmail = cCEmail;
            EmployeeComment = employeeComment;
            SendMailWithTicket = sendMailWithTicket;
            SetTicketAsRead = setTicketAsRead;
            ContactDetails = contactDetails;
            Tags = tags;
            DefaultTags = defaultTags;
            CanBeOnDuty = canBeOnDuty;
            EmployeeAddress = employeeAddress;
        }

        public string CustomerId { get; }
        public string FirstName { get; }
        public string LastName { get; }
        public string CCEmail { get; }
        public string EmployeeComment { get; }
        public bool SendMailWithTicket { get; }
        public bool SetTicketAsRead { get; }
        public ICollection<EmployeeContactDetailModel> ContactDetails { get; }
        public ICollection<string> Tags { get; }
        public ICollection<string> DefaultTags { get; }
        public bool CanBeOnDuty { get; }
        public Address EmployeeAddress { get; }
    }
}