﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Employee;
using EventFlow.Commands;

namespace WebPortal.Application.Employees.Commands
{
    public class ModifyEmployeeCommandHandler : CommandHandler<EmployeeAggregate, EmployeeId, ModifyEmployeeCommand>
    {
        public override Task ExecuteAsync(EmployeeAggregate aggregate,
            ModifyEmployeeCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(
                () => aggregate.ModifyEmployee(command.FirstName, command.LastName, command.CCEmail,
                    command.EmployeeComment, command.SendMailWithTicket, command.SetTicketAsRead, command.CustomerId,
                    command.ContactDetails, command.Tags, command.DefaultTags, command.CanBeOnDuty, command.EmployeeAddress),
                cancellationToken);
        }
    }
}