﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Employee;
using EventFlow.Commands;

namespace WebPortal.Application.Employees.Commands
{
    public class RemoveEmployeeCommandHandler : CommandHandler<EmployeeAggregate, EmployeeId, RemoveEmployeeCommand>
    {
        public override Task ExecuteAsync(EmployeeAggregate aggregate,
            RemoveEmployeeCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(aggregate.DeleteEmployee, cancellationToken);
        }
    }
}