﻿using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Employee.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.Application.Employees.Queries
{
    public class GetAllTagsQueryHandler : IQueryHandler<GetAllTagsQuery, List<string>>
    {
        private readonly IMongoDbReadModelStore<EmployeeReadModel> _store;

        public GetAllTagsQueryHandler(IMongoDbReadModelStore<EmployeeReadModel> store)
        {
            _store = store;
        }
        public Task<List<string>> ExecuteQueryAsync(GetAllTagsQuery query,
            CancellationToken cancellationToken)
        {
            var result = new List<string>();
            _store.AsQueryable().Where(x => x.CustomerId.Equals(query.CustomerId)).ToList().ForEach(x => x.Tags?.ToList().ForEach((y =>
            {
                if(y != null)
                    result.Add(y);
            })));
            return Task.FromResult(
                result.Distinct().ToList()
            );
        }
    }
}