﻿using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Employee.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.Application.Employees.Queries
{
    public class GetEmployeeQueryHandler : IQueryHandler<GetEmployeeQuery, EmployeeReadModel>
    {
        private readonly IMongoDbReadModelStore<EmployeeReadModel> _store;

        public GetEmployeeQueryHandler(IMongoDbReadModelStore<EmployeeReadModel> store)
        {
            _store = store;
        }

        public Task<EmployeeReadModel> ExecuteQueryAsync(GetEmployeeQuery query,
            CancellationToken cancellationToken)
        {
            return Task.FromResult(_store.AsQueryable().SingleOrDefault(x => x.Id.Equals(query.Id)));
        }
    }
}