﻿using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Employee.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.Application.Employees.Queries
{
    public class
        GetPossibleOnDutyEmployeesQueryHandler : IQueryHandler<GetPossibleOnDutyEmployeesQuery, List<EmployeeReadModel>>
    {
        private readonly IMongoDbReadModelStore<EmployeeReadModel> _store;

        public GetPossibleOnDutyEmployeesQueryHandler(IMongoDbReadModelStore<EmployeeReadModel> store)
        {
            _store = store;
        }

        public Task<List<EmployeeReadModel>> ExecuteQueryAsync(GetPossibleOnDutyEmployeesQuery query,
            CancellationToken cancellationToken)
        {
            return Task.FromResult(
                 _store.AsQueryable().Where(employee =>
                    employee.CustomerId.Equals(query.CustomerId) && employee.CanBeOnDuty == query.CanBeOnDuty).ToList()
            );
        }
    }
}