﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using EventFlow.Commands;

namespace WebPortal.Application.GlobalDutyTemplates.Commands
{
    public class CancelGlobalDutyTemplateCommand : Command<GlobalDutyTemplateAggregate, GlobalDutyTemplateId>
    {
        public CancelGlobalDutyTemplateCommand(GlobalDutyTemplateId aggregateId) : base(aggregateId)
        {
        }
    }

    public class CancelGlobalDutyTemplateCommandHandler : CommandHandler<GlobalDutyTemplateAggregate,
        GlobalDutyTemplateId, CancelGlobalDutyTemplateCommand>
    {
        public override Task ExecuteAsync(GlobalDutyTemplateAggregate aggregate,
            CancelGlobalDutyTemplateCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.CancelGlobalDutyTemplate(), cancellationToken);
        }
    }
}
