﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using EventFlow.Commands;

namespace WebPortal.Application.GlobalDutyTemplates.Commands
{
    public class CreateGlobalDutyTemplateCommand: Command<GlobalDutyTemplateAggregate, GlobalDutyTemplateId>
    {
        public CreateGlobalDutyTemplateCommand(GlobalDutyTemplateId aggregateId) : base(aggregateId)
        {
        }
    }

    public class
        CreateGlobalDutyTemplateCommandHandler : CommandHandler<GlobalDutyTemplateAggregate, GlobalDutyTemplateId, CreateGlobalDutyTemplateCommand>
    {
        public override Task ExecuteAsync(GlobalDutyTemplateAggregate aggregate,
            CreateGlobalDutyTemplateCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.CreateGlobalDutyTemplate(), cancellationToken);
        }
    }
}
