﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using EventFlow.Commands;

namespace WebPortal.Application.GlobalDutyTemplates.Commands
{
    public class ModifyNoteGlobalDutyTemplateCommand : Command<GlobalDutyTemplateAggregate, GlobalDutyTemplateId>
    {
        public ModifyNoteGlobalDutyTemplateCommand(GlobalDutyTemplateId aggregateId,
            string note) : base(aggregateId)
        {
            Note = note;
        }

        public string Note { get; }
    }

    public class ModifyNoteGlobalDutyTemplateCommandHandler : CommandHandler<GlobalDutyTemplateAggregate,
        GlobalDutyTemplateId, ModifyNoteGlobalDutyTemplateCommand>
    {
        public override Task ExecuteAsync(GlobalDutyTemplateAggregate aggregate,
            ModifyNoteGlobalDutyTemplateCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifyNoteGlobalDutyTemplate(command.Note), cancellationToken);
        }
    }

}
