﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using EventFlow.Commands;

namespace WebPortal.Application.GlobalDutyTemplates.Commands
{
    public class ModifyTitleGlobalDutyTemplateCommand : Command<GlobalDutyTemplateAggregate, GlobalDutyTemplateId>
    {
        public ModifyTitleGlobalDutyTemplateCommand(GlobalDutyTemplateId aggregateId,
            string title) : base(aggregateId)
        {
            Title = title;
        }

        public string Title { get; }
    }

    public class ModifyTitleGlobalDutyTemplateCommandHandler : CommandHandler<GlobalDutyTemplateAggregate,
        GlobalDutyTemplateId, ModifyTitleGlobalDutyTemplateCommand>
    {
        public override Task ExecuteAsync(GlobalDutyTemplateAggregate aggregate,
            ModifyTitleGlobalDutyTemplateCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifyTitleGlobalDutyTemplate(command.Title), cancellationToken);
        }
    }
}
