﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using EventFlow.Commands;

namespace WebPortal.Application.GlobalDutyTemplates.Commands
{
    public class ModifyUsageGlobalDutyTemplateCommand : Command<GlobalDutyTemplateAggregate, GlobalDutyTemplateId>
    {
        public ModifyUsageGlobalDutyTemplateCommand(GlobalDutyTemplateId aggregateId,
            bool increase) : base(aggregateId)
        {
            Increase = increase;
        }

        public bool Increase { get; }
    }

    public class ModifyUsageGlobalDutyTemplateCommandHandler : CommandHandler<GlobalDutyTemplateAggregate,
        GlobalDutyTemplateId, ModifyUsageGlobalDutyTemplateCommand>
    {
        public override Task ExecuteAsync(GlobalDutyTemplateAggregate aggregate,
            ModifyUsageGlobalDutyTemplateCommand command,
            CancellationToken cancellationToken)
        {
           return Task.Run(() =>
                aggregate.ModifyUsageGlobalDutyTemplate(command.Increase), cancellationToken);
        }
    }
}
