﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using EventFlow.Commands;

namespace WebPortal.Application.GlobalDutyTemplates.Commands
{
    public class SaveGlobalDutyTemplateCommand : Command<GlobalDutyTemplateAggregate, GlobalDutyTemplateId>
    {
        public SaveGlobalDutyTemplateCommand(GlobalDutyTemplateId aggregateId) : base(aggregateId)
        {
        }
    }

    public class SaveGlobalDutyTemplateCommandHandler : CommandHandler<GlobalDutyTemplateAggregate, GlobalDutyTemplateId
        , SaveGlobalDutyTemplateCommand>
    {
        public override Task ExecuteAsync(GlobalDutyTemplateAggregate aggregate,
            SaveGlobalDutyTemplateCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.SaveGlobalDutyTemplate(), cancellationToken);
        }
    }
}
