﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.GlobalDutyTemplates.Commands.TimeSlots
{
    public class AddTimeSlotTemplateGlobalDutyTemplateCommand : Command<GlobalDutyTemplateAggregate, GlobalDutyTemplateId>
    {
        public AddTimeSlotTemplateGlobalDutyTemplateCommand(GlobalDutyTemplateId aggregateId,
            TimeSlotTemplateId idTimeSlotTemplate) : base(aggregateId)
        {
            IdTimeSlotTemplate = idTimeSlotTemplate;
        }

        public TimeSlotTemplateId IdTimeSlotTemplate { get; }
    }

    public class AddTimeSlotTemplateGlobalDutyTemplateCommandHandler : CommandHandler<GlobalDutyTemplateAggregate,
        GlobalDutyTemplateId, AddTimeSlotTemplateGlobalDutyTemplateCommand>
    {
        public override Task ExecuteAsync(GlobalDutyTemplateAggregate aggregate,
            AddTimeSlotTemplateGlobalDutyTemplateCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.AddTimeSlotToGlobalDutyTemplate(command.IdTimeSlotTemplate), cancellationToken);
        }
    }
}
