﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.GlobalDutyTemplates.Commands.TimeSlots
{
    public class DeleteTimeSlotTemplateGlobalDutyTemplateCommand : Command<GlobalDutyTemplateAggregate, GlobalDutyTemplateId>
    {
        public DeleteTimeSlotTemplateGlobalDutyTemplateCommand(GlobalDutyTemplateId aggregateId,
            TimeSlotTemplateId idTimeSlotTemplate) : base(aggregateId)
        {
            IdTimeSlotTemplate = idTimeSlotTemplate;
        }

        public TimeSlotTemplateId IdTimeSlotTemplate { get; }
    }

    public class DeleteTimeSlotTemplateGlobalDutyTemplateCommandHandler : CommandHandler<GlobalDutyTemplateAggregate,
        GlobalDutyTemplateId, DeleteTimeSlotTemplateGlobalDutyTemplateCommand>
    {
        public override Task ExecuteAsync(GlobalDutyTemplateAggregate aggregate,
            DeleteTimeSlotTemplateGlobalDutyTemplateCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.DeleteTimeSlotFromGlobalDutyTemplate(command.IdTimeSlotTemplate), cancellationToken);
        }
    }
}
