﻿using System;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.GlobalDutyTemplates.Commands.TimeSlots
{
    public class ModifyEndTimeTimeSlotTemplateGlobalDutyTemplateCommand : Command<GlobalDutyTemplateAggregate, GlobalDutyTemplateId>
    {
        public ModifyEndTimeTimeSlotTemplateGlobalDutyTemplateCommand(GlobalDutyTemplateId aggregateId,
            TimeSlotTemplateId idTimeSlotTemplate,
            TimeSpan endTime) : base(aggregateId)
        {
            IdTimeSlotTemplate = idTimeSlotTemplate;
            EndTime = endTime;
        }

        public TimeSlotTemplateId IdTimeSlotTemplate { get; }
        public TimeSpan EndTime { get; }
    }

    public class ModifyEndTimeTimeSlotTemplateGlobalDutyTemplateCommandHandler : CommandHandler<
        GlobalDutyTemplateAggregate, GlobalDutyTemplateId, ModifyEndTimeTimeSlotTemplateGlobalDutyTemplateCommand>
    {
        public override Task ExecuteAsync(GlobalDutyTemplateAggregate aggregate,
            ModifyEndTimeTimeSlotTemplateGlobalDutyTemplateCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifyEndTimeTimeSlotGlobalDutyTemplate(command.IdTimeSlotTemplate, command.EndTime), cancellationToken);
        }
    }
}
