﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.GlobalDutyTemplates.Commands.TimeSlots
{
    public class ModifyNameTimeSlotTemplateGlobalDutyTemplateCommand : Command<GlobalDutyTemplateAggregate, GlobalDutyTemplateId>
    {
        public ModifyNameTimeSlotTemplateGlobalDutyTemplateCommand(GlobalDutyTemplateId aggregateId,
            TimeSlotTemplateId idTimeSlotTemplate,
            string name) : base(aggregateId)
        {
            IdTimeSlotTemplate = idTimeSlotTemplate;
            Name = name;
        }

        public TimeSlotTemplateId IdTimeSlotTemplate { get; }
        public string Name { get; }
    }

    public class ModifyNameTimeSlotTemplateGlobalDutyTemplateCommandHandler : CommandHandler<GlobalDutyTemplateAggregate
        , GlobalDutyTemplateId, ModifyNameTimeSlotTemplateGlobalDutyTemplateCommand>
    {
        public override Task ExecuteAsync(GlobalDutyTemplateAggregate aggregate,
            ModifyNameTimeSlotTemplateGlobalDutyTemplateCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifyTimeSlotNameGlobalDutyTemplate(command.IdTimeSlotTemplate, command.Name), cancellationToken);
        }
    }
}
