﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.GlobalDutyTemplates.Commands.TimeSlots
{
    public class ModifyNoteTimeSlotTemplateGlobalDutyTemplateCommand : Command<GlobalDutyTemplateAggregate, GlobalDutyTemplateId>
    {
        public ModifyNoteTimeSlotTemplateGlobalDutyTemplateCommand(GlobalDutyTemplateId aggregateId,
            TimeSlotTemplateId idTimeSlotTemplate,
            string note) : base(aggregateId)
        {
            IdTimeSlotTemplate = idTimeSlotTemplate;
            Note = note;
        }

        public TimeSlotTemplateId IdTimeSlotTemplate { get; }
        public string Note { get; }

    }

    public class ModifyNoteTimeSlotTemplateGlobalDutyTemplateCommandHandler : CommandHandler<GlobalDutyTemplateAggregate
        , GlobalDutyTemplateId, ModifyNoteTimeSlotTemplateGlobalDutyTemplateCommand>
    {
        public override Task ExecuteAsync(GlobalDutyTemplateAggregate aggregate,
            ModifyNoteTimeSlotTemplateGlobalDutyTemplateCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifyNoteTimeSlotGlobalDutyTemplate(command.IdTimeSlotTemplate, command.Note), cancellationToken);
        }
    }
}
