﻿using System;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.GlobalDutyTemplates.Commands.TimeSlots
{
    public class ModifyStartTimeTimeSlotTemplateGlobalDutyTemplateCommand : Command<GlobalDutyTemplateAggregate, GlobalDutyTemplateId>
    {
        public ModifyStartTimeTimeSlotTemplateGlobalDutyTemplateCommand(GlobalDutyTemplateId aggregateId,
            TimeSlotTemplateId idTimeSlotTemplate,
            TimeSpan startTime) : base(aggregateId)
        {
            IdTimeSlotTemplate = idTimeSlotTemplate;
            StartTime = startTime;
        }

        public TimeSlotTemplateId IdTimeSlotTemplate { get; }
        public TimeSpan StartTime { get; }
    }

    public class ModifyStartTimeTimeSlotTemplateGlobalDutyTemplateCommandHandler : CommandHandler<
        GlobalDutyTemplateAggregate, GlobalDutyTemplateId, ModifyStartTimeTimeSlotTemplateGlobalDutyTemplateCommand>
    {
        public override Task ExecuteAsync(GlobalDutyTemplateAggregate aggregate,
            ModifyStartTimeTimeSlotTemplateGlobalDutyTemplateCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifyStartTimeTimeSlotGlobalDutyTemplate(command.IdTimeSlotTemplate, command.StartTime), cancellationToken);
        }
    }
}
