﻿using System.Collections.Generic;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using CRM.Domain.Shared.ValueObjects;
using EventFlow.Commands;

namespace WebPortal.Application.GlobalDutyTemplates.Commands.TimeSlots
{
    public class ModifyWeekdaysTimeSlotTemplateGlobalDutyTemplateCommand : Command<GlobalDutyTemplateAggregate, GlobalDutyTemplateId>
    {
        public ModifyWeekdaysTimeSlotTemplateGlobalDutyTemplateCommand(GlobalDutyTemplateId aggregateId,
            TimeSlotTemplateId idTimeSlotTemplate,
            ICollection<WeekDay> weekdays) : base(aggregateId)
        {
            IdTimeSlotTemplate = idTimeSlotTemplate;
            Weekdays = weekdays;
        }

        public TimeSlotTemplateId IdTimeSlotTemplate { get; }
        public ICollection<WeekDay> Weekdays { get; }
    }

    public class ModifyWeekdaysTimeSlotTemplateGlobalDutyTemplateCommandHandler : CommandHandler<
        GlobalDutyTemplateAggregate, GlobalDutyTemplateId, ModifyWeekdaysTimeSlotTemplateGlobalDutyTemplateCommand>
    {
        public override Task ExecuteAsync(GlobalDutyTemplateAggregate aggregate,
            ModifyWeekdaysTimeSlotTemplateGlobalDutyTemplateCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifyWeekdaysTimeSlotGlobalDutyTemplate(command.IdTimeSlotTemplate, command.Weekdays), cancellationToken);
        }
    }
}
