﻿using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.Application.GlobalDutyTemplates.Queries
{
    public class GetOneGlobalDutyTemplateQuery: IQuery<GlobalDutyTemplateReadModel>
    {
        public GetOneGlobalDutyTemplateQuery(string id)
        {
            Id = id;
        }

        public string Id { get; set; }
    }

    public class
        GetOneGlobalDutyTemplateQueryHandler : IQueryHandler<GetOneGlobalDutyTemplateQuery, GlobalDutyTemplateReadModel>
    {
        private readonly IMongoDbReadModelStore<GlobalDutyTemplateReadModel> _store;

        public GetOneGlobalDutyTemplateQueryHandler(IMongoDbReadModelStore<GlobalDutyTemplateReadModel> store)
        {
            _store = store;
        }

        public Task<GlobalDutyTemplateReadModel> ExecuteQueryAsync(GetOneGlobalDutyTemplateQuery query,
            CancellationToken cancellationToken)
        {
            return Task.FromResult(
                _store.AsQueryable()
                    .SingleOrDefault(x => x.Id == query.Id));
        }
    }
}
