﻿using CRM.Domain.NeoDuty;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;

namespace WebPortal.Application.NeoDuties.Commands
{
    public class CancelNeoDutyCommand : Command<NeoDutyAggregate, NeoDutyId>
    {
        public CancelNeoDutyCommand(NeoDutyId aggregateId) : base(aggregateId)
        {
        }
    }

    public class CancelNeoDutyCommandHandler : CommandHandler<NeoDutyAggregate, NeoDutyId, CancelNeoDutyCommand>
    {
        public override Task ExecuteAsync(NeoDutyAggregate aggregate, CancelNeoDutyCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.CancelNeoDuty(), cancellationToken);
        }
    }

}
