﻿using CRM.Domain.NeoDuty;
using CRM.Domain.NeoDuty.Models;
using EventFlow.Commands;
using System.Collections.Generic;
using System.Threading;
using System.Threading.Tasks;

namespace WebPortal.Application.NeoDuties.Commands
{
    public class CreateNeoDutyCommand : Command<NeoDutyAggregate, NeoDutyId>
    {
        public string DutyCategoryId { get; }
        public string Note { get; }
        public List<AddTimeslotModel> TimeSlots { get; }

        public CreateNeoDutyCommand(NeoDutyId aggregateId, string dutyCategoryId, string note, List<AddTimeslotModel> timeSlots) : base(aggregateId)
        {
            DutyCategoryId = dutyCategoryId;
            Note = note;
            TimeSlots = timeSlots;
        }
    }

    public class CreateNeoDutyCommandHandler : CommandHandler<NeoDutyAggregate, NeoDutyId, CreateNeoDutyCommand>
    {
        public override Task ExecuteAsync(NeoDutyAggregate aggregate, CreateNeoDutyCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.CreateNeoDuty(command.DutyCategoryId, command.Note, command.TimeSlots), cancellationToken);
        }
    }
}
