﻿using CRM.Domain.NeoDuty;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;

namespace WebPortal.Application.NeoDuties.Commands
{
    public class DeleteNeoDutyCommand : Command<NeoDutyAggregate, NeoDutyId>
    {
        public DeleteNeoDutyCommand(NeoDutyId aggregateId) : base(aggregateId)
        {
        }
    }

    public class DeleteNeoDutyCommandHandler : CommandHandler<NeoDutyAggregate, NeoDutyId, DeleteNeoDutyCommand>
    {
        public override Task ExecuteAsync(NeoDutyAggregate aggregate, DeleteNeoDutyCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.DeleteNeoDuty(), cancellationToken);
        }
    }
}
