﻿using System;
using CRM.Domain.NeoDuty;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;
namespace WebPortal.Application.NeoDuties.Commands
{
    public class ModifyEndCommand : Command<NeoDutyAggregate, NeoDutyId>
    {
        public ModifyEndCommand(NeoDutyId aggregateId, DateTime end) : base(aggregateId)
        {
            End = end;
        }

        public DateTime End { get; }
    }

    public class ModifyEndCommandHandler : CommandHandler<NeoDutyAggregate, NeoDutyId, ModifyEndCommand>
    {
        public override Task ExecuteAsync(NeoDutyAggregate aggregate, ModifyEndCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.ModifyEnd(command.End), cancellationToken);
        }
    }

}
