﻿using CRM.Domain.NeoDuty;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;

namespace WebPortal.Application.NeoDuties.Commands
{
    public class ModifyNoteCommand : Command<NeoDutyAggregate, NeoDutyId>
    {
        public string Note { get; }

        public ModifyNoteCommand(NeoDutyId aggregateId, string note) : base(aggregateId)
        {
            Note = note;
        }
    }
    public class ModifyNoteCommandHandler : CommandHandler<NeoDutyAggregate, NeoDutyId, ModifyNoteCommand>
    {
        public override Task ExecuteAsync(NeoDutyAggregate aggregate, ModifyNoteCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.ModifyNote(command.Note),cancellationToken);
        }
    }
}
