﻿using System;
using CRM.Domain.NeoDuty;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;
namespace WebPortal.Application.NeoDuties.Commands
{
    public class ModifyStartCommand : Command<NeoDutyAggregate, NeoDutyId>
    {
        public ModifyStartCommand(NeoDutyId aggregateId, DateTime start) : base(aggregateId)
        {
            Start = start;
        }

        public DateTime Start { get; }
    }

    public class ModifyStartCommandHandler : CommandHandler<NeoDutyAggregate, NeoDutyId, ModifyStartCommand>
    {
        public override Task ExecuteAsync(NeoDutyAggregate aggregate, ModifyStartCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.ModifyStart(command.Start), cancellationToken);
        }
    }

}