﻿using System;
using CRM.Domain.NeoDuty;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;

namespace WebPortal.Application.NeoDuties.Commands
{
    public class ModifyStartEndCommand : Command<NeoDutyAggregate, NeoDutyId>
    {
        public ModifyStartEndCommand(NeoDutyId aggregateId, DateTime start, DateTime end) : base(aggregateId)
        {
            Start = start;
            End = end;
        }

        public DateTime Start { get; }
        public DateTime End { get; }

    }

    public class ModifyStartEndCommandHandler : CommandHandler<NeoDutyAggregate, NeoDutyId, ModifyStartEndCommand>
    {
        public override Task ExecuteAsync(NeoDutyAggregate aggregate, ModifyStartEndCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.ModifyStartEnd(command.Start, command.End), cancellationToken);
        }
    }
}
