﻿using CRM.Domain.NeoDuty;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;

namespace WebPortal.Application.NeoDuties.Commands
{
    public class SaveNeoDutyCommand : Command<NeoDutyAggregate, NeoDutyId>
    {
        public SaveNeoDutyCommand(NeoDutyId aggregateId) : base(aggregateId)
        {
        }
    }

    public class SaveNeoDutyCommandHandler : CommandHandler<NeoDutyAggregate, NeoDutyId, SaveNeoDutyCommand>
    {
        public override Task ExecuteAsync(NeoDutyAggregate aggregate, SaveNeoDutyCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.SaveNeoDuty(), cancellationToken);
        }
    }
}
