﻿using CRM.Domain.NeoDuty.Entities;
using CRM.Domain.NeoDuty;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;

namespace WebPortal.Application.NeoDuties.Commands.TimeSlot
{
    public class AddTimeSlotCommand : Command<NeoDutyAggregate, NeoDutyId>
    {
        public AddTimeSlotCommand(NeoDutyId aggregateId, TimeSlotId timeslotId) : base(aggregateId)
        {
            TimeslotId = timeslotId;
        }

        public TimeSlotId TimeslotId { get; set; }

    }

    public class AddTimeSlotCommandHandler : CommandHandler<NeoDutyAggregate, NeoDutyId, AddTimeSlotCommand>
    {
        public override Task ExecuteAsync(NeoDutyAggregate aggregate, AddTimeSlotCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.AddTimeSlot(command.TimeslotId), cancellationToken);
        }
    }
}