﻿using CRM.Domain.NeoDuty.Entities;
using CRM.Domain.NeoDuty;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;

namespace WebPortal.Application.NeoDuties.Commands.TimeSlot.Contact
{
    public class AddContactPointCommand : Command<NeoDutyAggregate, NeoDutyId>
    {
        public AddContactPointCommand(NeoDutyId aggregateId, TimeSlotId timeslotId, DutyContactId contactId, DutyContactPointId contactPointId, string contactDetailId) : base(aggregateId)
        {
            TimeslotId = timeslotId;
            ContactId = contactId;
            ContactPointId = contactPointId;
            ContactDetailId = contactDetailId;
        }

        public TimeSlotId TimeslotId { get; set; }
        public DutyContactId ContactId { get; set; }
        public DutyContactPointId ContactPointId { get; set; }
        public string ContactDetailId { get; set; }
    }

    public class AddContactPointCommandHandler : CommandHandler<NeoDutyAggregate, NeoDutyId, AddContactPointCommand>
    {
        public override Task ExecuteAsync(NeoDutyAggregate aggregate, AddContactPointCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.AddContactPoint(command.TimeslotId, command.ContactId, command.ContactPointId, command.ContactDetailId), cancellationToken);
        }
    }
}
