﻿using CRM.Domain.NeoDuty;
using CRM.Domain.NeoDuty.Models;
using EventFlow.Commands;
using System.Collections.Generic;
using System.Threading;
using System.Threading.Tasks;

namespace WebPortal.Application.NeoDuties.Commands.TimeSlot.Contact
{
    public class AddContactToDutyCommand : Command<NeoDutyAggregate, NeoDutyId>
    {
        public AddContactToDutyCommand(NeoDutyId aggregateId, string employeeId, List<string> defaultTags, List<AddContactToNeoDutyModel> contactList) : base(aggregateId)
        {
            EmployeeId = employeeId;
            DefaultTags = defaultTags;
            ContactList = contactList;
        }

        public string EmployeeId { get; set; }
        public List<string> DefaultTags { get; set; }
        public List<AddContactToNeoDutyModel> ContactList { get; set; }

    }

    public class AddContactToDutyCommandHandler : CommandHandler<NeoDutyAggregate, NeoDutyId, AddContactToDutyCommand>
    {
        public override Task ExecuteAsync(NeoDutyAggregate aggregate, AddContactToDutyCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.AddContactToDuty(
                command.EmployeeId,
                command.DefaultTags,
                command.ContactList), cancellationToken);
        }
    }
}
