﻿using CRM.Domain.NeoDuty.Entities;
using CRM.Domain.NeoDuty;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;

namespace WebPortal.Application.NeoDuties.Commands.TimeSlot.Contact
{
    public class AddTagCommand : Command<NeoDutyAggregate, NeoDutyId>
    {
        public AddTagCommand(NeoDutyId aggregateId, TimeSlotId timeslotId, DutyContactId contactId, string tag) : base(aggregateId)
        {
            TimeslotId = timeslotId;
            ContactId = contactId;
            Tag = tag;
        }

        public TimeSlotId TimeslotId { get; set; }
        public DutyContactId ContactId { get; set; }
        public string Tag { get; set; }
    }

    public class AddTagCommandHandler : CommandHandler<NeoDutyAggregate, NeoDutyId, AddTagCommand>
    {
        public override Task ExecuteAsync(NeoDutyAggregate aggregate, AddTagCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.AddTag(command.TimeslotId, command.ContactId, command.Tag), cancellationToken);
        }
    }
}
