﻿using CRM.Domain.NeoDuty.Entities;
using CRM.Domain.NeoDuty;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;

namespace WebPortal.Application.NeoDuties.Commands.TimeSlot.Contact
{
    public class ModifyOrderIdContactCommand : Command<NeoDutyAggregate, NeoDutyId>
    {
        public ModifyOrderIdContactCommand(NeoDutyId aggregateId, TimeSlotId timeslotId, string employeeId, int newOrderId) : base(aggregateId)
        {
            TimeslotId = timeslotId;
            EmployeeId = employeeId;
            NewOrderId = newOrderId;
        }

        public TimeSlotId TimeslotId { get; set; }
        public string EmployeeId { get; set; }
        public int NewOrderId { get; set; }
    }

    public class ModifyOrderIdContactCommandHandler : CommandHandler<NeoDutyAggregate, NeoDutyId, ModifyOrderIdContactCommand>
    {
        public override Task ExecuteAsync(NeoDutyAggregate aggregate, ModifyOrderIdContactCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.ModifyContactOrder(command.TimeslotId, command.EmployeeId, command.NewOrderId), cancellationToken);
        }
    }
}
