﻿using CRM.Domain.NeoDuty;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;

namespace WebPortal.Application.NeoDuties.Commands.TimeSlot.Contact
{
    public class RemoveContactCommand : Command<NeoDutyAggregate, NeoDutyId>
    {
        public RemoveContactCommand(NeoDutyId aggregateId, string employeeId, string timeSlotId = null) : base(aggregateId)
        {
            EmployeeId = employeeId;
            TimeSlotId = timeSlotId;
        }

        public string EmployeeId { get; set; }
        public string TimeSlotId { get; set; }
    }

    public class RemoveContactCommandHandler : CommandHandler<NeoDutyAggregate, NeoDutyId, RemoveContactCommand>
    {
        public override Task ExecuteAsync(NeoDutyAggregate aggregate, RemoveContactCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.RemoveContactFromDuty(command.EmployeeId, command.TimeSlotId), cancellationToken);
        }
    }
}
