﻿using CRM.Domain.NeoDuty.Entities;
using CRM.Domain.NeoDuty;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;

namespace WebPortal.Application.NeoDuties.Commands.TimeSlot.Contact
{
    public class RemoveContactPointCommand : Command<NeoDutyAggregate, NeoDutyId>
    {
        public RemoveContactPointCommand(NeoDutyId aggregateId, TimeSlotId timeslotId, DutyContactId contactId, DutyContactPointId contactPointId) : base(aggregateId)
        {
            TimeslotId = timeslotId;
            ContactId = contactId;
            ContactPointId = contactPointId;
        }

        public TimeSlotId TimeslotId { get; set; }
        public DutyContactId ContactId { get; set; }
        public DutyContactPointId ContactPointId { get; set; }
    }

    public class RemoveContactPointCommandHandler : CommandHandler<NeoDutyAggregate, NeoDutyId, RemoveContactPointCommand>
    {
        public override Task ExecuteAsync(NeoDutyAggregate aggregate, RemoveContactPointCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.RemoveContactPoint(command.TimeslotId, command.ContactId, command.ContactPointId), cancellationToken);
        }
    }
}
