﻿using System;
using CRM.Domain.NeoDuty.Entities;
using CRM.Domain.NeoDuty;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;

namespace WebPortal.Application.NeoDuties.Commands.TimeSlot
{
    public class ModifyEndTimeTimeSlotCommand : Command<NeoDutyAggregate, NeoDutyId>
    {
        public ModifyEndTimeTimeSlotCommand(NeoDutyId aggregateId, TimeSlotId timeslotId, TimeSpan endTime) : base(aggregateId)
        {
            TimeslotId = timeslotId;
            EndTime = endTime;
        }

        public TimeSlotId TimeslotId { get; set; }
        public TimeSpan EndTime { get; set; }
    }

    public class ModifyEndTimeTimeSlotCommandHandler : CommandHandler<NeoDutyAggregate, NeoDutyId, ModifyEndTimeTimeSlotCommand>
    {
        public override Task ExecuteAsync(NeoDutyAggregate aggregate, ModifyEndTimeTimeSlotCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.ModifyEndTimeTimeSlot(command.TimeslotId, command.EndTime), cancellationToken);
        }
    }
}
