﻿using CRM.Domain.NeoDuty.Entities;
using CRM.Domain.NeoDuty;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;

namespace WebPortal.Application.NeoDuties.Commands.TimeSlot
{
    public class ModifyNoteTimeSlotCommand : Command<NeoDutyAggregate, NeoDutyId>
    {
        public TimeSlotId TimeslotId { get; set; }
        public string Note { get; set; }

        public ModifyNoteTimeSlotCommand(NeoDutyId aggregateId, TimeSlotId timeslotId, string note) : base(aggregateId)
        {
            TimeslotId = timeslotId;
            Note = note;
        }
    }

    public class ModifyNoteTimeSlotCommandHandler : CommandHandler<NeoDutyAggregate, NeoDutyId, ModifyNoteTimeSlotCommand>
    {
        public override Task ExecuteAsync(NeoDutyAggregate aggregate, ModifyNoteTimeSlotCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.ModifyNoteTimeSlot(command.TimeslotId, command.Note), cancellationToken);
        }
    }
}
