﻿using System;
using CRM.Domain.NeoDuty.Entities;
using CRM.Domain.NeoDuty;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;

namespace WebPortal.Application.NeoDuties.Commands.TimeSlot
{
    public class ModifyStartTimeTimeSlotCommand : Command<NeoDutyAggregate, NeoDutyId>
    {
        public ModifyStartTimeTimeSlotCommand(NeoDutyId aggregateId, TimeSlotId timeslotId, TimeSpan startTime) : base(aggregateId)
        {
            TimeslotId = timeslotId;
            StartTime = startTime;
        }

        public TimeSlotId TimeslotId { get; set; }
        public TimeSpan StartTime { get; set; }
    }

    public class ModifyStartTimeTimeSlotCommandHandler : CommandHandler<NeoDutyAggregate, NeoDutyId, ModifyStartTimeTimeSlotCommand>
    {
        public override Task ExecuteAsync(NeoDutyAggregate aggregate, ModifyStartTimeTimeSlotCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.ModifyStartTimeTimeSlot(command.TimeslotId, command.StartTime), cancellationToken);
        }
    }
}
