﻿using CRM.Domain.NeoDuty.Entities;
using CRM.Domain.NeoDuty;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;

namespace WebPortal.Application.NeoDuties.Commands.TimeSlot
{
    public class ModifyTitleTimeSlotCommand : Command<NeoDutyAggregate, NeoDutyId>
    {
        public ModifyTitleTimeSlotCommand(NeoDutyId aggregateId, TimeSlotId timeslotId, string title) : base(aggregateId)
        {
            TimeslotId = timeslotId;
            Title = title;
        }

        public TimeSlotId TimeslotId { get; set; }
        public string Title { get; set; }
    }

    public class ModifyTitleTimeSlotCommandHandler : CommandHandler<NeoDutyAggregate, NeoDutyId, ModifyTitleTimeSlotCommand>
    {
        public override Task ExecuteAsync(NeoDutyAggregate aggregate, ModifyTitleTimeSlotCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.ModifyTitleTimeSlot(command.TimeslotId, command.Title), cancellationToken);
        }
    }

}
