﻿using System;
using CRM.Domain.NeoDuty.Entities;
using CRM.Domain.NeoDuty;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Shared.ValueObjects;
using System.Collections.Generic;

namespace WebPortal.Application.NeoDuties.Commands.TimeSlot
{
    public class ModifyWeekdaysCommand : Command<NeoDutyAggregate, NeoDutyId>
    {
        public ModifyWeekdaysCommand(NeoDutyId aggregateId, TimeSlotId timeslotId, ICollection<WeekDay> weekdays) : base(aggregateId)
        {
            TimeslotId = timeslotId;
            Weekdays = weekdays;
        }

        public TimeSlotId TimeslotId { get; }
        public ICollection<WeekDay> Weekdays { get; }

    }

    public class ModifyWeekdaysCommandHandler : CommandHandler<NeoDutyAggregate, NeoDutyId, ModifyWeekdaysCommand>
    {
        public override Task ExecuteAsync(NeoDutyAggregate aggregate, ModifyWeekdaysCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.ModifyWeekDays(command.TimeslotId, command.Weekdays), cancellationToken);
        }
    }
}
