﻿using CRM.Domain.NeoDuty.Entities;
using CRM.Domain.NeoDuty;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;

namespace WebPortal.Application.NeoDuties.Commands.TimeSlot
{
    public class RemoveTimeSlotCommand : Command<NeoDutyAggregate, NeoDutyId>
    {
        public RemoveTimeSlotCommand(NeoDutyId aggregateId, TimeSlotId timeslotId) : base(aggregateId)
        {
            TimeslotId = timeslotId;
        }

        public TimeSlotId TimeslotId { get; set; }

    }

    public class RemoveTimeSlotCommandHandler : CommandHandler<NeoDutyAggregate, NeoDutyId, RemoveTimeSlotCommand>
    {
        public override Task ExecuteAsync(NeoDutyAggregate aggregate, RemoveTimeSlotCommand command, CancellationToken cancellationToken)
        {
           return Task.Run(() => aggregate.RemoveTimeSlot(command.TimeslotId), cancellationToken);
        }
    }
}
