﻿using CRM.Domain.NeoDuty.Models;
using System.Collections.Generic;
using System.Linq;

namespace WebPortal.Application.NeoDuties.Models.Detail
{
    public class ContactDetailModel
    {
        public string Id { get; set; }
        public string EmployeeId { get; set; }
        public string FullName { get; set; }
        public int OrderId { get; set; }
        public List<string> Tags { get; set; }
        public List<ContactPointDetailModel> ContactPoints { get; set; }

        public ContactDetailModel(DutyContactModel dc)
        {
            Id = dc.Id;
            EmployeeId = dc.EmployeeId;
            FullName = "";
            OrderId = dc.OrderId;
            Tags = dc.Tags.ToList();
           ContactPoints = dc.ContactPoints == null 
                ? new List<ContactPointDetailModel>() 
                : dc.ContactPoints.Select(x => new ContactPointDetailModel(x)).ToList();
        }
    }
}
