﻿using CRM.Domain.NeoDuty.Models;
using CRM.Domain.Shared.ValueObjects;
using System;
using System.Collections.Generic;
using System.Linq;

namespace WebPortal.Application.NeoDuties.Models.Detail
{
    public class TimeSlotDetailModel
    {
        public string Id { get; set; }
        public string Note { get; set; }
        public string TimeSlotName { get; set; }
        public TimeSpan StartTime { get; set; }
        public TimeSpan EndTime { get; set; }
        public List<WeekDay> WeekDays { get; set; }
        public List<ContactDetailModel> Contacts { get; set; }

        public TimeSlotDetailModel (TimeSlotModel t)
        {
            Id = t.Id;
            TimeSlotName = t.TimeSlotName;
            StartTime = t.StartTime;
            EndTime = t.EndTime;
            Note = t.Note;
            WeekDays = t.WeekDays.ToList();
            Contacts = t.DutyContacts == null 
                ? new List<ContactDetailModel> () 
                : t.DutyContacts.Select(x => new ContactDetailModel(x)).ToList();

        }
    }
}
