﻿using System;
using CRM.Domain.Ticket;
using EventFlow.Commands;
using EventFlow.Core;

namespace WebPortal.Application.Tickets.Commands
{
    public class AddTicketCommand: Command<TicketAggregate, TicketId>
    {
        public string DossierId { get; }
        public string TicketText { get; }
        public int? OriginalCcmMessageId { get; }
        public DateTime CreatedInCrm { get; }
        public DateTime LastModifiedInCrm { get; }
        public string CreatedCrmUser { get; }
        public string LastModifiedCrmUser { get; }

        public AddTicketCommand(TicketId aggregateId, string dossierId,
            string ticketText,
            int? originalCCMMessageId,
            DateTime createdInCRM,
            DateTime lastModifiedInCRM,
            string createdCRMUser,
            string lastModifiedCRMUser) : base(aggregateId)
        {
            DossierId = dossierId;
            TicketText = ticketText;
            OriginalCcmMessageId = originalCCMMessageId;
            CreatedInCrm = createdInCRM;
            LastModifiedInCrm = lastModifiedInCRM;
            CreatedCrmUser = createdCRMUser;
            LastModifiedCrmUser = lastModifiedCRMUser;
        }
    }
}