﻿using CRM.Domain.Ticket;
using CRM.Domain.Ticket.Entities;
using EventFlow.Commands;

namespace WebPortal.Application.Tickets.Commands
{
    public class ModifyTicketCommentCommand : Command<TicketAggregate, TicketId>
    {
        public ModifyTicketCommentCommand(TicketId aggregateId,
            TicketCommentId ticketCommentId,
            string commentBody,
            string commentQuote,
            string userId) : base(aggregateId)
        {
            TicketCommentId = ticketCommentId;
            CommentBody = commentBody;
            CommentQuote = commentQuote;
            UserId = userId;
        }

        public TicketCommentId TicketCommentId { get; }
        public string CommentBody { get; }
        public string CommentQuote { get; }
        public string UserId { get; }
    }
}