﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Ticket;
using EventFlow.Aggregates.ExecutionResults;
using EventFlow.Commands;

namespace WebPortal.Application.Tickets.Commands
{
    public class ModifyTicketCommentCommandHandler : CommandHandler<TicketAggregate, TicketId, IExecutionResult,
        ModifyTicketCommentCommand>
    {
        public override Task<IExecutionResult> ExecuteCommandAsync(TicketAggregate aggregate,
            ModifyTicketCommentCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(
                () => aggregate.UpSertComment(command.CommentBody, command.CommentQuote, command.UserId,
                    command.TicketCommentId), cancellationToken);
        }
    }
}