﻿using CRM.Domain.Ticket;
using EventFlow.Commands;

namespace WebPortal.Application.Tickets.Commands
{
    public class PlaceTicketCommentCommand : Command<TicketAggregate, TicketId>
    {
        public PlaceTicketCommentCommand(TicketId aggregateId,
            string commentBody,
            string commentQuote,
            string userId) : base(aggregateId)
        {
            CommentBody = commentBody;
            CommentQuote = commentQuote;
            UserId = userId;
        }

        public string CommentBody { get; }
        public string CommentQuote { get; }
        public string UserId { get; }
    }
}