﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Ticket;
using EventFlow.Aggregates.ExecutionResults;
using EventFlow.Commands;

namespace WebPortal.Application.Tickets.Commands
{
    public class RemoveTicketCommentCommandHandler : CommandHandler<TicketAggregate, TicketId, IExecutionResult,
        RemoveTicketCommentCommand>
    {
        public override Task<IExecutionResult> ExecuteCommandAsync(TicketAggregate aggregate,
            RemoveTicketCommentCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.RemoveComment(command.TicketCommentId), cancellationToken);
        }
    }
}