﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Ticket;
using EventFlow.Aggregates.ExecutionResults;
using EventFlow.Commands;

namespace WebPortal.Application.Tickets.Commands
{
    public class SetTicketAsReadOrUnreadCommandHandler : CommandHandler<TicketAggregate, TicketId, IExecutionResult,
        SetTicketAsReadOrUnreadCommand>
    {
        public override Task<IExecutionResult> ExecuteCommandAsync(TicketAggregate aggregate,
            SetTicketAsReadOrUnreadCommand command,
            CancellationToken cancellationToken)
        {
            return command.IsRead
                ? Task.Run(() => aggregate.ReadTicket(command.UserId), cancellationToken)
                : Task.Run(() => aggregate.UnReadTicket(command.UserId), cancellationToken);
        }
    }
}