﻿using System.Collections.Generic;
using CRM.Domain.Ticket.Models;
using EventFlow.Queries;

namespace WebPortal.Application.Tickets.Queries
{
    public class GetMoreCommentsForTicketQuery : IQuery<List<TicketCommentModel>>
    {
        public GetMoreCommentsForTicketQuery(string ticketId,
            int amountAlreadyLoaded,
            int commentAmount,
            bool commentOrderAscending)
        {
            TicketId = ticketId;
            AmountAlreadyLoaded = amountAlreadyLoaded;
            CommentAmount = commentAmount;
            CommentOrderAscending = commentOrderAscending;
        }

        public string TicketId { get; }
        public int AmountAlreadyLoaded { get; set; }
        public int CommentAmount { get; set; }
        public bool CommentOrderAscending { get; set; }
    }
}