﻿using EventFlow.Queries;
using WebPortal.Application.Tickets.Models;

namespace WebPortal.Application.Tickets.Queries
{
    public class GetTicketWithCommentsQuery : IQuery<GetTicketWithCommentsModel>
    {
        public GetTicketWithCommentsQuery(string aggregateId,
            int commentAmount,
            bool commentOrderAscending,
            string userId)
        {
            Id = aggregateId;
            CommentAmount = commentAmount;
            CommentOrderAscending = commentOrderAscending;
            UserId = userId;
        }

        public string Id { get; }
        public int CommentAmount { get; set; }
        public bool CommentOrderAscending { get; set; }
        public string UserId { get; }
    }
}