﻿using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Ticket.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.Application.Tickets.Queries
{
    public class GetTicketWithInteractionKeyQueryHandler : IQueryHandler<GetTicketWithInteractionKeyQuery, TicketReadModel>
    {
        private readonly IMongoDbReadModelStore<TicketReadModel> _store;

        public GetTicketWithInteractionKeyQueryHandler(IMongoDbReadModelStore<TicketReadModel> _store)
        {
            this._store = _store;
        }

        public Task<TicketReadModel> ExecuteQueryAsync(GetTicketWithInteractionKeyQuery query,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                 _store.AsQueryable().FirstOrDefault(x => x.TicketText.Contains(query.InteractionId))
              , cancellationToken);
        }
    }
}