﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.User;
using EventFlow.Aggregates.ExecutionResults;
using EventFlow.Commands;

namespace WebPortal.Application.Users.Commands
{
    public class AddModuleRightCustomerCommandHandler : CommandHandler<UserAggregate, UserId, IExecutionResult,
        AddModuleRightCustomerCommand>
    {
        public override Task<IExecutionResult> ExecuteCommandAsync(UserAggregate aggregate,
            AddModuleRightCustomerCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.AddCustomerModuleRight(command.ModuleRight, command.CustomerId));
        }
    }
}