﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.User;
using EventFlow.Aggregates.ExecutionResults;
using EventFlow.Commands;

namespace WebPortal.Application.Users.Commands
{
    public class
        ConnectUserToEmployeeCommandHandler : CommandHandler<UserAggregate, UserId, IExecutionResult,
            ConnectUserToEmployeeCommand>
    {
        public override Task<IExecutionResult> ExecuteCommandAsync(UserAggregate aggregate,
            ConnectUserToEmployeeCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.ConnectToEmployee(command.EmployeeId));
        }
    }
}