﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.User;
using EventFlow.Aggregates.ExecutionResults;
using EventFlow.Commands;
using FirebaseAdmin.Auth;

namespace WebPortal.Application.Users.Commands
{
    public class DeleteUserCommandHandler : CommandHandler<UserAggregate, UserId, IExecutionResult, DeleteUserCommand>
    {
        private readonly FirebaseAuth _auth;

        public DeleteUserCommandHandler(FirebaseAuth auth)
        {
            _auth = auth;
        }

        public override Task<IExecutionResult> ExecuteCommandAsync(UserAggregate aggregate,
            DeleteUserCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(async () =>
            {
                await _auth.DeleteUserAsync(command.AggregateId.ToString(), cancellationToken);
                return aggregate.DeleteUser();
            });
        }
    }
}