﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.User;
using EventFlow.Aggregates.ExecutionResults;
using EventFlow.Commands;

namespace WebPortal.Application.Users.Commands
{
    public class ModifyModuleRightCustomerCommandHandler : CommandHandler<UserAggregate, UserId, IExecutionResult,
        ModifyModuleRightCustomerCommand>
    {
        public override Task<IExecutionResult> ExecuteCommandAsync(UserAggregate aggregate,
            ModifyModuleRightCustomerCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifyCustomerModuleRight(command.ModuleRight, command.CustomerId));
        }
    }
}