﻿using System.Collections.Generic;
using CRM.Domain.User;
using EventFlow.Commands;
using Newtonsoft.Json;
using WebPortal.Application.Users.Models;
using ModuleRightModel = CRM.Domain.User.Models.ModuleRightModel;

namespace WebPortal.Application.Users.Commands
{
    public class ModifyUserCommand : Command<UserAggregate, UserId>
    {
        public ModifyUserCommand(UpdateUserModel model) : base(UserId.With(model.Id))
        {
            Email = model.Email;
            UserName = model.UserName;
            CustomerId = model.CustomerId;
            IsCustomerAdmin = model.IsCustomerAdmin;
            EmployeeId = model.EmployeeId;
            CustomerModuleRights = model.CustomerModuleRights;
            DossierModuleRights = model.DossierModuleRights;
            CustomerGroupModuleRights = model.CustomerGroupModuleRights;
            Tenant = model.Tenant;
        }

        public string Email { get; }
        public string UserName { get; }
        public string CustomerId { get; }
        public bool IsCustomerAdmin { get; }
        public string EmployeeId { get; }
        public string? Tenant { get; }
        public Dictionary<string, ModuleRightModel> CustomerModuleRights { get; }
        public Dictionary<string, ModuleRightModel> DossierModuleRights { get; }
        public Dictionary<string, ModuleRightModel> CustomerGroupModuleRights { get; }
    }
}