﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.User;
using EventFlow.Aggregates.ExecutionResults;
using EventFlow.Commands;

namespace WebPortal.Application.Users.Commands
{
    public class RemoveModuleRightCustomerCommandHandler : CommandHandler<UserAggregate, UserId, IExecutionResult,
        RemoveModuleRightCustomerCommand>
    {
        public override Task<IExecutionResult> ExecuteCommandAsync(UserAggregate aggregate,
            RemoveModuleRightCustomerCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.RemoveCustomerModuleRight(command.CustomerId));
        }
    }
}