﻿using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.User.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;
using WebPortal.Application.Extentions;

namespace WebPortal.Application.Users.Queries
{
    public class GetGlobalUsersQueryHandler : IQueryHandler<GetGlobalUsersQuery, PageResult<UserReadModel>>
    {
        private readonly IMongoDbReadModelStore<UserReadModel> _store;

        public GetGlobalUsersQueryHandler(IMongoDbReadModelStore<UserReadModel> store)
        {
            _store = store;
        }

        public Task<PageResult<UserReadModel>> ExecuteQueryAsync(GetGlobalUsersQuery query,
            CancellationToken cancellationToken)
        {
            return Task.FromResult(
                _store.AsQueryable()
                    .Where(x => string.IsNullOrEmpty(x.CustomerId))
                    .Where(x => string.IsNullOrEmpty(query.Filter) || x.Email.ToLower().Contains(query.Filter.ToLower()))
                    .OrderBy(query.Sort, query.Asc)
                    .GetPage(query.Page, query.PageSize)
            );
        }
    }
}