﻿using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.User.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.Application.Users.Queries
{
    public class GetUserByAuthIdQueryHandler : IQueryHandler<GetUserByAuthIdQuery, UserReadModel>
    {
        private readonly IMongoDbReadModelStore<UserReadModel> _store;

        public GetUserByAuthIdQueryHandler(IMongoDbReadModelStore<UserReadModel> store)
        {
            _store = store;
        }

        public Task<UserReadModel> ExecuteQueryAsync(GetUserByAuthIdQuery query,
            CancellationToken cancellationToken)
        {
            return Task.FromResult( _store.AsQueryable()
                .SingleOrDefault(x =>
                    x.AuthenticationId.Equals(query.AuthenticationId)));
        }
    }
}