﻿using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.User.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.Application.Users.Queries
{
    public class GetUserQueryHandler : IQueryHandler<GetUserQuery, UserReadModel>
    {
        private readonly IMongoDbReadModelStore<UserReadModel> _store;

        public GetUserQueryHandler(IMongoDbReadModelStore<UserReadModel> store)
        {
            _store = store;
        }

        public Task<UserReadModel> ExecuteQueryAsync(GetUserQuery query,
            CancellationToken cancellationToken)
        {
            return Task.FromResult( _store.AsQueryable().FirstOrDefault(x => x.Id.Equals(query.Id) || x.EmployeeId.Equals(query.Id)));
        }
    }
}