﻿using System;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.ReadModels;
using EventFlow;
using EventFlow.Configuration;
using EventFlow.Extensions;
using EventFlow.MongoDB.Extensions;
using WebPortal.Application.DutyCategories.Queries;

namespace WebPortal.ApplicationTest.Configuration
{
    public class ConfigureQueries
    {
        public static IRootResolver ConfigureServicesWithHandlersMC(string connectionString, string databaseName)
        {
            return EventFlowOptions.New
                .AddDefaults(typeof(DutyCategoryAggregate).Assembly)


                .AddQueryHandlers(new Type[]
                {
                    //typeof(GetDutiesQueryHandler),
                    //typeof(GetActiveDutiesQueryHandler),
                    typeof(GetDutyCategoriesQueryHandler)
                })

                .ConfigureMongoDb(connectionString, databaseName)

                .UseMongoDbEventStore()
                .UseMongoDbSnapshotStore()
                .UseMongoDbReadModel<DutyCategoryReadModel>()
                .CreateResolver();
        }

    }
}
