﻿using System;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.ReadModels;
using CRM.Domain.Employee;
using CRM.Domain.Employee.ReadModels;
using EventFlow;
using EventFlow.Configuration;
using EventFlow.Extensions;
using EventFlow.MongoDB.Extensions;
using WebPortal.Application.DutyCategories.Commands;
using WebPortal.Application.DutyCategories.Commands.Duties;
using WebPortal.Application.DutyCategories.Commands.Duties.TimeSlots;
using WebPortal.Application.DutyCategories.Commands.Duties.TimeSlots.DutyContacts;
using WebPortal.Application.DutyCategories.Commands.Duties.TimeSlots.DutyContacts.DutyContactPoints;
using WebPortal.Application.DutyCategories.Commands.Duties.TimeSlots.DutyContacts.Tags;
using WebPortal.Application.DutyCategories.Commands.DutyTemplate;
using WebPortal.Application.GlobalDutyTemplates.Commands;
using WebPortal.Application.GlobalDutyTemplates.Commands.TimeSlots;
using WebPortal.Application.GlobalDutyTemplates.Queries;
using WebPortal.Application.DutyCategories.Queries;

namespace WebPortal.ApplicationTest.Configuration
{
    public class ConfigureServices
    {
        #region Comments



        //public static IRootResolver ConfigureServicesWithHandlersMC(string connectionString, string databaseName)


        //{


        //    return EventFlowOptions.New
        //        //.AddDefaults(typeof(CreateCustomerCommand).Assembly)
        //        .AddDefaults(typeof(CustomerAggregate).Assembly)
        //        .AddDefaults(typeof(BranchAggregate).Assembly)
        //        .AddDefaults(typeof(DossierAggregate).Assembly)
        //        .AddDefaults(typeof(InteractionStatisticAggregate).Assembly)
        //        .AddDefaults(typeof(CallScriptAggregate).Assembly)
        //        .AddDefaults(typeof(TicketAggregate).Assembly)
        //        .AddDefaults(typeof(EmployeeAggregate).Assembly)
        //        .AddDefaults(typeof(DutyAggregate).Assembly)
        //        .AddCommands(new Type[]
        //        {
        //        })
        //        .AddCommandHandlers(new Type[]
        //        {

        //        })
        //        .AddQueryHandlers(new Type[]
        //        {

        //        })


        //        .ConfigureMongoDb(connectionString, databaseName)
        //        .UseMongoDbEventStore()
        //        .UseMongoDbSnapshotStore()
        //        .UseMongoDbReadModel<CallScriptReadModel>()
        //        .UseMongoDbReadModel<CustomerReadModel>()
        //        .UseMongoDbReadModel<DossierReadModel>()
        //        .UseMongoDbReadModel<InteractionStatisticReadModel>()
        //        .UseMongoDbReadModel<TicketReadModel>()
        //        .UseMongoDbReadModel<BranchReadModel>()
        //        .UseMongoDbReadModel<EmployeeReadModel>()
        //        .UseMongoDbReadModel<DutyReadModel>()

        //        .CreateResolver();
        //}


        //public static IRootResolver ConfigureServicesWithHandlersMC(string connectionString, string databaseName)
        //{
        //    return EventFlowOptions.New
        //        //.AddDefaults(typeof(CreateCustomerCommand).Assembly)
        //        .AddDefaults(typeof(CustomerAggregate).Assembly)
        //        .AddDefaults(typeof(BranchAggregate).Assembly)
        //        .AddDefaults(typeof(CallScriptAggregate).Assembly)
        //        .AddDefaults(typeof(DossierAggregate).Assembly)
        //        .AddDefaults(typeof(EmployeeAggregate).Assembly)
        //        .AddDefaults(typeof(InteractionStatisticAggregate).Assembly)
        //        .AddDefaults(typeof(TicketAggregate).Assembly)
        //        .AddDefaults(typeof(CreateBranchCommand).Assembly)
        //        .ConfigureMongoDb(connectionString, databaseName)
        //        .UseMongoDbEventStore()
        //        .UseMongoDbSnapshotStore()
        //        .UseMongoDbReadModel<CallScriptReadModel>()
        //        .UseMongoDbReadModel<CustomerReadModel>()
        //        .UseMongoDbReadModel<BranchReadModel>()
        //        .UseMongoDbReadModel<DossierReadModel>()
        //        .UseMongoDbReadModel<EmployeeReadModel>()
        //        .UseMongoDbReadModel<InteractionStatisticReadModel>()
        //        .UseMongoDbReadModel<TicketReadModel>()
        //        .UseMongoDbReadModel<DutyReadModel>()
        //        .UseMongoDbReadModel<DutyReadModelV2>()

        //        .CreateResolver();
        //}

        //public static IRootResolver ConfigureServicesWithHandlersMC(string connectionString, string databaseName)
        //{
        //    return EventFlowOptions.New
        //        //.AddDefaults(typeof(CreateCustomerCommand).Assembly)
        //        .AddDefaults(typeof(EmployeeAggregate).Assembly)
        //        .AddDefaults(typeof(DutyAggregate).Assembly)
        //        //.AddDefaults(typeof(AddDutyCommand).Assembly)

        //        .AddQueryHandlers(new Type[]
        //        {
        //            typeof(GetDutiesQueryHandler),
        //            typeof(GetActiveDutiesQueryHandler)
        //        })

        //        .ConfigureMongoDb(connectionString, databaseName)

        //        .UseMongoDbEventStore()
        //        .UseMongoDbSnapshotStore()
        //        .UseMongoDbReadModel<EmployeeReadModel>()
        //        .UseMongoDbReadModel<DutyReadModel>()
        //        .CreateResolver();
        //}
        #endregion


        public static IRootResolver ConfigureServicesWithHandlersMC(string connectionString, string databaseName)
        {
            return EventFlowOptions.New
                //.AddDefaults(typeof(CreateCustomerCommand).Assembly)
                .AddDefaults(typeof(EmployeeAggregate).Assembly)
                //.AddDefaults(typeof(DutyAggregate).Assembly)
                .AddDefaults(typeof(DutyCategoryAggregate).Assembly)
                .AddDefaults(typeof(GlobalDutyTemplateAggregate).Assembly)
                //.AddDefaults(typeof(AddDutyCommand).Assembly)

                .AddCommands(new Type[]
                {
                    typeof(CreateGlobalDutyTemplateCommand),
                    typeof(ModifyTitleGlobalDutyTemplateCommand),
                    typeof(ModifyNoteGlobalDutyTemplateCommand),
                    typeof(AddTimeSlotTemplateGlobalDutyTemplateCommand),
                    typeof(ModifyStartTimeTimeSlotTemplateGlobalDutyTemplateCommand),
                    typeof(ModifyEndTimeTimeSlotTemplateGlobalDutyTemplateCommand),
                    typeof(ModifyNameTimeSlotTemplateGlobalDutyTemplateCommand),
                    typeof(ModifyNoteTimeSlotTemplateGlobalDutyTemplateCommand),
                    typeof(ModifyWeekdaysTimeSlotTemplateGlobalDutyTemplateCommand),
                    typeof(SaveGlobalDutyTemplateCommand),
                    typeof(CancelGlobalDutyTemplateCommand),
                    //dutyCategory
                    typeof(CreateDutyCategoryCommand),
                    typeof(ModifyNameDutyCategoryCommand),
                    typeof(ModifyNoteDutyTemplateCommand),
                    typeof(AddTimeSlotTemplateCommand),
                    typeof(ModifyStartTimeTimeSlotTemplateCommand),
                    typeof(ModifyEndTimeTimeSlotTemplateCommand),
                    typeof(ModifyNameTimeSlotTemplateCommand),
                    typeof(ModifyWeekdaysTimeSlotTemplateCommand),
                    typeof(ModifyNoteTimeSlotTemplateCommand),
                    typeof(SaveDutyCategoryCommand),
                    //duty
                    typeof(AddDutyCommand),
                    typeof(ModifyStartDutyCommand),
                    typeof(ModifyEndDutyCommand),
                    typeof(ModifyNoteDutyCommand),
                    typeof(AddTimeSlotDutyCommand),
                    typeof(ModifyNameTimeSlotDutyCommand),
                    typeof(ModifyStartTimeTimeSlotDutyCommand),
                    typeof(ModifyEndTimeTimeSlotDutyCommand),
                    typeof(ModifyWeekdaysTimeSlotDutyCommand),
                    typeof(ModifyNoteTimeSlotDutyCommand),
                    typeof(AddDutyContactCommand),
                    typeof(AddDutyContactPointCommand),
                    typeof(AddDutyContactTagCommand),
                    //delete
                    typeof(DeleteDutyCategoryCommand),
                    typeof(DeleteDutyCommand),
                    typeof(DeleteDutyContactCommand),
                    typeof(DeleteDutyContactPointCommand),
                    typeof(DeleteDutyContactTagCommand),
                    typeof(DeleteGlobalDutyTemplateCommand),
                    typeof(DeleteTimeSlotDutyCommand),
                    typeof(DeleteTimeSlotTemplateCommand),
                    typeof(DeleteTimeSlotTemplateGlobalDutyTemplateCommand)
                })

                .AddCommandHandlers(new Type[]
                {
                    typeof(CreateGlobalDutyTemplateCommandHandler),
                    typeof(ModifyTitleGlobalDutyTemplateCommandHandler),
                    typeof(ModifyNoteGlobalDutyTemplateCommandHandler),
                    typeof(AddTimeSlotTemplateGlobalDutyTemplateCommandHandler),
                    typeof(ModifyStartTimeTimeSlotTemplateGlobalDutyTemplateCommandHandler),
                    typeof(ModifyEndTimeTimeSlotTemplateGlobalDutyTemplateCommandHandler),
                    typeof(ModifyNameTimeSlotTemplateGlobalDutyTemplateCommandHandler),
                    typeof(ModifyNoteTimeSlotTemplateGlobalDutyTemplateCommandHandler),
                    typeof(ModifyWeekdaysTimeSlotTemplateGlobalDutyTemplateCommandHandler),
                    typeof(SaveGlobalDutyTemplateCommandHandler),
                    typeof(CancelGlobalDutyTemplateCommandHandler),
                    //dutyCategory
                    typeof(CreateDutyCategoryCommandHandler),
                    typeof(ModifyNameDutyCategoryCommandHandler),
                    typeof(ModifyNoteDutyTemplateCommandHandler),
                    typeof(AddTimeSlotTemplateCommandHandler),
                    typeof(ModifyStartTimeTimeSlotTemplateCommandHandler),
                    typeof(ModifyEndTimeTimeSlotTemplateCommandHandler),
                    typeof(ModifyNameTimeSlotTemplateCommandHandler),
                    typeof(ModifyWeekdaysTimeSlotTemplateCommandHandler),
                    typeof(ModifyNoteTimeSlotTemplateCommandHandler),
                    typeof(SaveDutyCategoryCommandHandler),
                    //duty
                    typeof(AddDutyCommandHandler),
                    typeof(ModifyStartDutyCommandHandler),
                    typeof(ModifyEndDutyCommandHandler),
                    typeof(ModifyNoteDutyCommandHandler),
                    typeof(AddTimeSlotDutyCommandHandler),
                    typeof(ModifyNameTimeSlotDutyCommandHandler),
                    typeof(ModifyStartTimeTimeSlotDutyCommandHandler),
                    typeof(ModifyEndTimeTimeSlotDutyCommandHandler),
                    typeof(ModifyWeekdaysTimeSlotDutyCommandHandler),
                    typeof(ModifyNoteTimeSlotDutyCommandHandler),
                    typeof(AddDutyContactCommandHandler),
                    typeof(AddDutyContactPointCommandHandler),
                    typeof(AddDutyContactTagCommandHandler),
                    //delete
                    typeof(DeleteDutyCategoryCommandHandler),
                    typeof(DeleteDutyCommandHandler),
                    typeof(DeleteDutyContactCommandHandler),
                    typeof(DeleteDutyContactPointCommandHandler),
                    typeof(DeleteDutyContactTagCommandHandler),
                    typeof(DeleteGlobalDutyTemplateCommandHandler),
                    typeof(DeleteTimeSlotDutyCommandHandler),
                    typeof(DeleteTimeSlotTemplateCommandHandler),
                    typeof(DeleteTimeSlotTemplateGlobalDutyTemplateCommandHandler)


                })


                .AddQueryHandlers(new Type[]
                {
                    //typeof(GetDutiesQueryHandler),
                    //typeof(GetActiveDutiesQueryHandler),
                    typeof(GetGlobalDutyTemplatesQueryHandler),
                    typeof(GetOneGlobalDutyTemplateQueryHandler),
                    typeof(GetDutyCategoriesQueryHandler)
                })

                .ConfigureMongoDb(connectionString, databaseName)

                .UseMongoDbEventStore()
                .UseMongoDbSnapshotStore()
                .UseMongoDbReadModel<EmployeeReadModel>()
                //.UseMongoDbReadModel<DutyReadModel>()
                .UseMongoDbReadModel<DutyCategoryReadModel>()
                .UseMongoDbReadModel<GlobalDutyTemplateReadModel>()
                .CreateResolver();
        }


        //public static IRootResolver ConfigureServicesWithHandlersMC(string connectionString, string databaseName)
        //{
        //    return EventFlowOptions.New
        //        //.AddDefaults(typeof(CreateCustomerCommand).Assembly)
        //        .ConfigureMongoDb(connectionString, databaseName)

        //        //.AddDefaults(typeof(CustomerAggregate).Assembly)
        //        //.AddDefaults(typeof(BranchAggregate).Assembly)
        //        //.AddDefaults(typeof(CallScriptAggregate).Assembly)
        //        //.AddDefaults(typeof(DossierAggregate).Assembly)
        //        //.AddDefaults(typeof(EmployeeAggregate).Assembly)
        //        //.AddDefaults(typeof(InteractionStatisticAggregate).Assembly)
        //        //.AddDefaults(typeof(TicketAggregate).Assembly)
        //        //.AddDefaults(typeof(DutyAggregate).Assembly)
        //        .AddDefaults(typeof(DutyCategoryAggregate).Assembly)
        //        .AddDefaults(typeof(GlobalDutyTemplateAggregate).Assembly)
        //        .AddDefaults(typeof(CreateDutyCategoryCommand).Assembly)

        //        .UseMongoDbEventStore()
        //        .UseMongoDbSnapshotStore()
        //        //.UseMongoDbReadModel<CallScriptReadModel>()
        //        //.UseMongoDbReadModel<CustomerReadModel>()
        //        //.UseMongoDbReadModel<BranchReadModel>()
        //        //.UseMongoDbReadModel<DossierReadModel>()
        //        //.UseMongoDbReadModel<EmployeeReadModel>()
        //        //.UseMongoDbReadModel<InteractionStatisticReadModel>()
        //        //.UseMongoDbReadModel<TicketReadModel>()
        //        //.UseMongoDbReadModel<DutyReadModel>()
        //        //.UseMongoDbReadModel<DutyReadModelV2>()
        //        .UseMongoDbReadModel<DutyCategoryReadModel>()
        //        .UseMongoDbReadModel<GlobalDutyTemplateReadModel>()

        //        .CreateResolver();
        //}


    }
}
