﻿using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.DutyCategoryAndTemplate.Aggregates;
using CRM.Domain.DutyCategoryAndTemplate.Entities;
using CRM.Domain.DutyCategoryAndTemplate.ValueObjects;
using EventFlow;
using EventFlow.Queries;
using WebPortal.Application.DutyCategories.Commands;
using WebPortal.Application.DutyCategories.Commands.Duties;
using WebPortal.Application.DutyCategories.Commands.Duties.TimeSlots;
using WebPortal.Application.DutyCategories.Commands.Duties.TimeSlots.DutyContacts;
using WebPortal.Application.DutyCategories.Commands.Duties.TimeSlots.DutyContacts.DutyContactPoints;
using WebPortal.Application.DutyCategories.Commands.Duties.TimeSlots.DutyContacts.Tags;
using WebPortal.Application.DutyCategories.Commands.DutyTemplate;
using WebPortal.Application.DutyCategories.Queries;
using WebPortal.ApplicationTest.Configuration;
using Xunit;

namespace WebPortal.ApplicationTest
{
    public class DutyCategoryTest
    {
        string conString = "mongodb://connector:connector123456789@192.168.121.11";
        string dbName = "wp_dev";
        //string dbName = "wp_staging";
        //string conString = "mongodb://localhost";
        //string conString = "mongodb://aac-dev01.cisicc.local";
        //string dbName = "WPMongoTest";
        //string dbName = "wp_prod";

        Guid _guid = new Guid("041de545-86d8-4fec-9ad6-91fb902e8f75");
        Guid _dutyTemplateGuid = new Guid("ede774cf-7765-46d1-b039-c9e9da67d2f2");
        Guid _tsGuid = new Guid("6c1566c1-b294-4364-8598-0c692e32bc00");

        Guid _dutyGuid1 = new Guid("1f056c9b-48de-4bb2-b6dc-188a8e7ff4ff");
        Guid _duty1Ts1 = new Guid("b285587b-4d38-4d72-ad54-49f55c79128c");
        Guid _contactGuid = new Guid("3bf737bc-9484-47e9-a667-c0a6cbe22bad");
        Guid _contactPointGuid = new Guid("39c8c0b8-e8c5-4b11-9cb0-a4eec4ce216a");

        string _peaceOfCake = "dossier-8b058291-0ebf-41f3-87a3-073aa3f9d7f8";

        #region comments
        //[Fact]
        //public async Task CreateDutyCategory()
        //{
        //    var services = ConfigureServices.ConfigureServicesWithHandlersMC(conString, dbName);

        //    var commandBus = services.Resolve<ICommandBus>();

        //    var id = DutyCategoryId.With(_guid);
        //    var dutyTemplateId = DutyTemplateId.With(_dutyTemplateGuid);


        //    var command = new CreateDutyCategoryCommand(id, _peaceOfCake, dutyTemplateId);
        //    await commandBus.PublishAsync(command, new CancellationToken());

        //    var nameCommand = new ModifyNameDutyCategoryCommand(id, "Ja, ja, Nog steeds: Buiten kantooruren");
        //    await commandBus.PublishAsync(nameCommand, new CancellationToken());

        //    var noteCommand = new ModifyNoteDutyTemplateCommand(id, "Wacht voor buiten kantooruren");
        //    await commandBus.PublishAsync(noteCommand, new CancellationToken());

        //    var tsId = TimeSlotTemplateId.With(_tsGuid);

        //    var timeSlotCommand = new AddTimeSlotTemplateCommand(id, tsId);
        //    await commandBus.PublishAsync(timeSlotCommand, new CancellationToken());

        //    var startTime = new TimeSpan(0, 0, 0, 0);
        //    var startCommand = new ModifyStartTimeTimeSlotTemplateCommand(id, tsId, startTime);
        //    await commandBus.PublishAsync(startCommand, new CancellationToken());

        //    var endTime = new TimeSpan(0, 8, 30, 0);
        //    var endCommand = new ModifyEndTimeTimeSlotTemplateCommand(id, tsId, endTime);
        //    await commandBus.PublishAsync(endCommand, new CancellationToken());

        //    var tsNameCommand = new ModifyNameTimeSlotTemplateCommand(id, tsId, "Ochtend");
        //    await commandBus.PublishAsync(tsNameCommand, new CancellationToken());

        //    var weekDays = new List<WeekDay>();

        //    for (int i = 1; i < 6; i++)
        //    {
        //        weekDays.Add(new WeekDay($"{i}"));
        //    }

        //    var weekdayCommand = new ModifyWeekdaysTimeSlotTemplateCommand(id, tsId, weekDays);
        //    await commandBus.PublishAsync(weekdayCommand, new CancellationToken());

        //    var tsNoteCommand = new ModifyNoteTimeSlotTemplateCommand(id, tsId, "Morning, should've taken it as a warning.");
        //    await commandBus.PublishAsync(tsNoteCommand, new CancellationToken());

        //}

        //[Fact]
        //public async Task SaveDutyCategory()
        //{
        //    var services = ConfigureServices.ConfigureServicesWithHandlersMC(conString, dbName);

        //    var commandBus = services.Resolve<ICommandBus>();

        //    var id = DutyCategoryId.With(_guid);

        //    var command = new SaveDutyCategoryCommand(id);
        //    await commandBus.PublishAsync(command, new CancellationToken());

        //}

        //[Fact]
        //public async Task AddDuty1()
        //{
        //    var services = ConfigureServices.ConfigureServicesWithHandlersMC(conString, dbName);

        //    var commandBus = services.Resolve<ICommandBus>();

        //    var id = DutyCategoryId.With(_guid);
        //    var dutyId = DutyId.With(_dutyGuid1);

        //    var dutyCommand = new AddDutyCommand(id, dutyId);
        //    await commandBus.PublishAsync(dutyCommand, new CancellationToken());
        //}

        //[Fact]
        //public async Task ContinueAddingDuty1()
        //{
        //    var services = ConfigureServices.ConfigureServicesWithHandlersMC(conString, dbName);

        //    var commandBus = services.Resolve<ICommandBus>();

        //    var id = DutyCategoryId.With(_guid);
        //    var dutyId = DutyId.With(_dutyGuid1);
        //    var timeSlotId = TimeSlotId.With(_duty1Ts1);

        //    var startDate = DateTime.Now.AddDays(-5);
        //    var endDate = DateTime.Now.AddDays(5);

        //    var startCommand = new ModifyStartDutyCommand(id, dutyId, startDate);
        //    var endCommand = new ModifyEndDutyCommand(id, dutyId, endDate);

        //    await commandBus.PublishAsync(startCommand, new CancellationToken());
        //    await commandBus.PublishAsync(endCommand, new CancellationToken());

        //    var noteCommand = new ModifyNoteDutyCommand(id, "Niet gebaseerd op DutyTemplate", dutyId);
        //    await commandBus.PublishAsync(noteCommand, new CancellationToken());

        //    var tsCommand = new AddTimeSlotDutyCommand(id, dutyId, timeSlotId);
        //    await commandBus.PublishAsync(tsCommand, new CancellationToken());

        //    var tsNameCommand = new ModifyNameTimeSlotDutyCommand(id, dutyId, timeSlotId, "Middagpauze");
        //    await commandBus.PublishAsync(tsNameCommand, new CancellationToken());

        //    var start = new TimeSpan(0, 12, 30, 0);
        //    var end = new TimeSpan(0, 13, 15, 0);
        //    var tsStartCommand = new ModifyStartTimeTimeSlotDutyCommand(id, dutyId, timeSlotId, start);
        //    var tsEndCommand = new ModifyEndTimeTimeSlotDutyCommand(id, dutyId, timeSlotId, end);
        //    await commandBus.PublishAsync(tsStartCommand, new CancellationToken());
        //    await commandBus.PublishAsync(tsEndCommand, new CancellationToken());

        //    var sat = new WeekDay("6");
        //    var sun = new WeekDay("0");

        //    var weekDays = new List<WeekDay>();
        //    weekDays.Add(sat);
        //    weekDays.Add(sun);

        //    var weekdaysCommand = new ModifyWeekdaysTimeSlotDutyCommand(id, weekDays, dutyId, timeSlotId);
        //    await commandBus.PublishAsync(weekdaysCommand, new CancellationToken());

        //    var tsNoteCommand = new ModifyNoteTimeSlotDutyCommand(id, dutyId, timeSlotId, "Yup, 45 minuten");
        //    await commandBus.PublishAsync(tsNoteCommand, new CancellationToken());
        //}

        //[Fact]
        //public async Task AddEmployeeToDuty1()
        //{
        //    var services = ConfigureServices.ConfigureServicesWithHandlersMC(conString, dbName);

        //    var commandBus = services.Resolve<ICommandBus>();

        //    var id = DutyCategoryId.With(_guid);
        //    var dutyId = DutyId.With(_dutyGuid1);
        //    var timeSlotId = TimeSlotId.With(_duty1Ts1);
        //    var contactId = DutyContactId.With(_contactGuid);

        //    var jeroenCelis = "employee-001bf53a-6abf-486c-85c0-99d8fc8337ab";

        //    var addContactCommand = new AddDutyContactCommand(id, dutyId, timeSlotId, contactId, jeroenCelis, 1);
        //    await commandBus.PublishAsync(addContactCommand, new CancellationToken());

        //}

        //[Fact]
        //public async Task AddContactPointDetailAndTag()
        //{
        //    var services = ConfigureServices.ConfigureServicesWithHandlersMC(conString, dbName);

        //    var commandBus = services.Resolve<ICommandBus>();

        //    var id = DutyCategoryId.With(_guid);
        //    var dutyId = DutyId.With(_dutyGuid1);
        //    var timeSlotId = TimeSlotId.With(_duty1Ts1);
        //    var contactId = DutyContactId.With(_contactGuid);
        //    var cellPhone = "employeecontactdetail-f9a03940-924b-44fa-acd0-91940846e7b9";
        //    var contactPointId = DutyContactPointId.With(_contactPointGuid);

        //    var addContactPointCommand = new AddDutyContactPointCommand(id, dutyId, timeSlotId, contactId, contactPointId, cellPhone, "0473/58.82.39");
        //    await commandBus.PublishAsync(addContactPointCommand, new CancellationToken());

        //    var addTagCommand = new AddDutyContactTagCommand(id, dutyId, timeSlotId, contactId,
        //        "JC behoort eigenlijk niet tot Peace Of Cake, maar goed.");
        //    await commandBus.PublishAsync(addTagCommand, new CancellationToken());

        //}

        //[Fact]
        //public async Task GetOverview()
        //{
        //    var services = ConfigureServices.ConfigureServicesWithHandlersMC(conString, dbName);
        //    var queryProcessor = services.Resolve<IQueryProcessor>();

        //    var start = DateTime.Now.AddDays(-14);
        //    var end = DateTime.Now.AddDays(-1);

        //    var query = new GetDutyCategoriesQuery(_peaceOfCake, start, end, true, true, true, true, "koru", "");
        //    var result = await queryProcessor.ProcessAsync(query, new CancellationToken());

        //    Assert.True(result.Count > 0);
        //}

        //[Fact]
        //public async Task DeleteContactPointAndTag()
        //{
        //    var services = ConfigureServices.ConfigureServicesWithHandlersMC(conString, dbName);

        //    var commandBus = services.Resolve<ICommandBus>();

        //    var id = DutyCategoryId.With(_guid);
        //    var dutyId = DutyId.With(_dutyGuid1);
        //    var timeSlotId = TimeSlotId.With(_duty1Ts1);
        //    var contactId = DutyContactId.With(_contactGuid);

        //    var contactPointId = DutyContactPointId.With(_contactPointGuid);

        //    var cpCommand = new DeleteDutyContactPointCommand(id, dutyId, timeSlotId, contactId, contactPointId);

        //    await commandBus.PublishAsync(cpCommand, new CancellationToken());

        //    var tagCommand = new DeleteDutyContactTagCommand(id, dutyId, timeSlotId, contactId, "JC behoort eigenlijk niet tot Peace Of Cake, maar goed.");

        //    await commandBus.PublishAsync(tagCommand, new CancellationToken());
        //}

        //[Fact]
        //public async Task DeleteEverything()
        //{
        //    var services = ConfigureServices.ConfigureServicesWithHandlersMC(conString, dbName);

        //    var commandBus = services.Resolve<ICommandBus>();

        //    var id = DutyCategoryId.With(_guid);
        //    var dutyId = DutyId.With(_dutyGuid1);
        //    var timeSlotId = TimeSlotId.With(_duty1Ts1);
        //    var contactId = DutyContactId.With(_contactGuid);
        //    var dutyTemplateId = DutyTemplateId.With(_dutyTemplateGuid);
        //    var tsId = TimeSlotTemplateId.With(_tsGuid);

        //    //var contactCommand = new DeleteDutyContactCommand(id, dutyId,timeSlotId,contactId);
        //    //await commandBus.PublishAsync(contactCommand, new CancellationToken());

        //    //var timeSlotCommand = new DeleteTimeSlotDutyCommand(id, dutyId, timeSlotId);
        //    //await commandBus.PublishAsync(timeSlotCommand, new CancellationToken());

        //    //var dutyCommand = new DeleteDutyCommand(id, dutyId);
        //    //await commandBus.PublishAsync(dutyCommand, new CancellationToken());

        //    //var tsTemplateCommand = new DeleteTimeSlotTemplateCommand(id, tsId);
        //    //await commandBus.PublishAsync(tsTemplateCommand, new CancellationToken());

        //    var cmd = new DeleteDutyCategoryCommand(id);
        //    await commandBus.PublishAsync(cmd, new CancellationToken());
        //}
        #endregion

        [Fact]
        private void GenerateSomeGuids()
        {
            var whatGuid = Guid.NewGuid();
            var whatId = $"what-{whatGuid}";
            var dutyCatGuid = new Guid("b4db24dd-4308-4ede-af77-92185a65b340");
            var dutyCatId = "dutycategory-b4db24dd-4308-4ede-af77-92185a65b340";

            var timeSlotTemplateGuid = new Guid("e00a820b-a952-4295-926d-94d98de347d3");
            var timeSlotTemplateId = "timeslottemplate-e00a820b-a952-4295-926d-94d98de347d3";
        }

    }
}
