﻿using System;
using System.Threading;
using System.Threading.Tasks;
using EventFlow.Queries;
using WebPortal.Application.Duties.Queries;
using WebPortal.ApplicationTest.Configuration;
using Xunit;

namespace WebPortal.ApplicationTest
{
    public class DutyTest
    {
        //string conString = "mongodb://connector:connector123456789@192.168.121.11";
        //string dbName = "wp_dev";
        //string dbName = "wp_staging";
        string conString = "mongodb://localhost";
        //string conString = "mongodb://aac-dev01.cisicc.local";
        string dbName = "WPMongoTest";
        //string dbName = "wp_prod";

        [Fact]
        public async Task GetDutiesTest()
        {
            var startDate = DateTime.UtcNow.AddDays(-30);
            var endDate = DateTime.UtcNow.AddDays(365);
            var dossierId = "dossier-56d080ef-362f-4105-a7d4-42603ef9a50b";
            dossierId = "dossier-3bb7edb5-f532-4342-939e-d1705bcd5a58";

            var services = ConfigureServices.ConfigureServicesWithHandlersMC(conString, dbName);

            //var commandBus = services.Resolve<ICommandBus>();
            var queryProcessor = services.Resolve<IQueryProcessor>();

            var q = new GetDutiesQuery(dossierId);

            var duties = await queryProcessor.ProcessAsync(q, new CancellationToken());

            Assert.True(duties.PageCount > 0);
        }

        [Fact]
        public async Task GetActiveDutiesTest()
        {
            var services = ConfigureServices.ConfigureServicesWithHandlersMC(conString, dbName);
            var queryProcessor = services.Resolve<IQueryProcessor>();
            var dossierId = "dossier-56d080ef-362f-4105-a7d4-42603ef9a50b";
            dossierId = "dossier-3bb7edb5-f532-4342-939e-d1705bcd5a58";

            var q = new GetActiveDutiesQuery(dossierId);
            var duties = await queryProcessor.ProcessAsync(q, new CancellationToken());

            Assert.True(duties.PageCount > 0);

        }

        public void SomeGuids()
        {
            var contact1Scar = new Guid("048cd82b-9591-4a7f-83be-9f9efd2daa3f");
            var id = "dutycontact-048cd82b-9591-4a7f-83be-9f9efd2daa3f";

            var contact2Scar = new Guid("3261727b-e332-49bf-bba5-268ca827b7d3");
            id = "dutycontact-3261727b-e332-49bf-bba5-268ca827b7d3";

            var nicole1 = new Guid("8839db5d-9972-4305-9425-1f80e5a18465");
            id = "dutycontact-8839db5d-9972-4305-9425-1f80e5a18465";
        }
    }
}
