﻿using System;
using System.Threading;
using System.Threading.Tasks;
using EventFlow.Queries;
using WebPortal.Application.Employees.Queries;
using WebPortal.ApplicationTest.Configuration;
using Xunit;

namespace WebPortal.ApplicationTest
{
    public class GlobalDutyTest
    {
        string conString = "mongodb://connector:connector123456789@192.168.121.11";
        //string dbName = "wp_dev";
        //string dbName = "wp_staging";
        //string conString = "mongodb://localhost";
        //string conString = "mongodb://aac-dev01.cisicc.local";
        //string dbName = "WPMongoTest";
        string dbName = "wp_prod";

        Guid _guid = new Guid("09d028cf-b6b9-41df-91ad-583ca961fc8f");

        [Fact]
        public async Task SearchCustomerByContactDetail()
        {
            var services = ConfigureServices.ConfigureServicesWithHandlersMC(conString, dbName);
            var queryProcessor = services.Resolve<IQueryProcessor>();

            var q = new GetCustomerByContactDetailValueQuery("86/94");
            var result = await queryProcessor.ProcessAsync(q, new CancellationToken());
            Assert.True(result != null);



        }

        //[Fact]
        //public async Task CreateGlobalDutyTemplate()
        //{
        //    var services = ConfigureServices.ConfigureServicesWithHandlersMC(conString, dbName);

        //    var commandBus = services.Resolve<ICommandBus>();

        //    var id = GlobalDutyTemplateId.With(_guid);

        //    //var c = new CreateGlobalDutyTemplateCommand(id);
        //    //await commandBus.PublishAsync(c, new CancellationToken());

        //    //var modifyTitleCommand = new ModifyTitleGlobalDutyTemplateCommand(id, "Eerste test voor Global Duty Template");
        //    //await commandBus.PublishAsync(modifyTitleCommand, new CancellationToken());

        //    //var modifyNoteCommand = new ModifyNoteGlobalDutyTemplateCommand(id, "Dit is een eenvoudige notitie die mee moet komen naar de category");
        //    //await commandBus.PublishAsync(modifyNoteCommand, new CancellationToken());

        //    var guidTimeSlot = new Guid("7995b0d0-3045-4471-ac4c-bf7140a91db0");
        //    var timeSlotId = TimeSlotTemplateId.With(guidTimeSlot);

        //    var addTimeslotCommand = new AddTimeSlotTemplateGlobalDutyTemplateCommand(id, timeSlotId);
        //    await commandBus.PublishAsync(addTimeslotCommand, new CancellationToken());

        //    var startTime = new TimeSpan(0, 7, 0, 0);
        //    var startCommand = new ModifyStartTimeTimeSlotTemplateGlobalDutyTemplateCommand(id, timeSlotId, startTime);
        //    await commandBus.PublishAsync(startCommand, new CancellationToken());

        //    var endTime = new TimeSpan(0, 18, 30, 0);
        //    var endCommand = new ModifyEndTimeTimeSlotTemplateGlobalDutyTemplateCommand(id, timeSlotId, endTime);
        //    await commandBus.PublishAsync(endCommand, new CancellationToken());

        //    var nameCommand = new ModifyNameTimeSlotTemplateGlobalDutyTemplateCommand(id, timeSlotId, "Naam van dit Slot Der Tijd");
        //    await commandBus.PublishAsync(nameCommand, new CancellationToken());

        //    var noteCommand = new ModifyNoteTimeSlotTemplateGlobalDutyTemplateCommand(id, timeSlotId, "Even een kleine notitie.");
        //    await commandBus.PublishAsync(noteCommand, new CancellationToken());


        //    //todo: pas employee nog aan met default tags en -contactDetails
        //    //Todo: maak test voor DutyCategory

        //}

        //[Fact]
        //public async Task ModifyWeekdays()
        //{
        //    var services = ConfigureServices.ConfigureServicesWithHandlersMC(conString, dbName);

        //    var commandBus = services.Resolve<ICommandBus>();
        //    var id = GlobalDutyTemplateId.With(_guid);

        //    var guidTimeSlot = new Guid("7995b0d0-3045-4471-ac4c-bf7140a91db0");
        //    var timeSlotId = TimeSlotTemplateId.With(guidTimeSlot);

        //    var weekDays = new List<WeekDay>();

        //    for (int i = 1; i < 6; i++)
        //    {
        //        weekDays.Add(new WeekDay($"{i}"));
        //    }

        //    var weekdayCommand = new ModifyWeekdaysTimeSlotTemplateGlobalDutyTemplateCommand(id, timeSlotId, weekDays);
        //    await commandBus.PublishAsync(weekdayCommand, new CancellationToken());


        //    //var modifyTitleCommand = new ModifyTitleGlobalDutyTemplateCommand(id, "Eerste test voor Global Duty Template");
        //    //await commandBus.PublishAsync(modifyTitleCommand, new CancellationToken());

        //}

        //[Fact]
        //public async Task SaveGlobalDutyTemplate()
        //{
        //    var services = ConfigureServices.ConfigureServicesWithHandlersMC(conString, dbName);

        //    var commandBus = services.Resolve<ICommandBus>();

        //    var id = GlobalDutyTemplateId.With(_guid);

        //    var saveCommand = new SaveGlobalDutyTemplateCommand(id);
        //    await commandBus.PublishAsync(saveCommand, new CancellationToken());

        //}

        //[Fact]
        //public async Task GetGlobalDuties()
        //{
        //    var services = ConfigureServices.ConfigureServicesWithHandlersMC(conString, dbName);
        //    var queryProcessor = services.Resolve<IQueryProcessor>();

        //    var q = new GetGlobalDutyTemplatesQuery(true, "Title", 1, 50, "");
        //    var result = await queryProcessor.ProcessAsync(q, new CancellationToken());

        //    Assert.True(result.PageCount > 0);

        //    var one = new GetOneGlobalDutyTemplateQuery("globaldutytemplate-09d028cf-b6b9-41df-91ad-583ca961fc8f");
        //    var oneResult = await queryProcessor.ProcessAsync(one, new CancellationToken());

        //    Assert.True(oneResult != null);
        //}

        ////Create guids for testing
        //private void JustGenerating()
        //{
        //    var gdtId = new Guid("78b19054-88ed-4c8a-be28-d2c7c8c91b00");
        //    var gdtString = "globaldutytemplate-78b19054-88ed-4c8a-be28-d2c7c8c91b00";

        //    var title = "Titel van de eerste Globale Duty";

        //    var note = "Notities bij eerste Globale Duty";

        //    var timeSlotId = new Guid("f764581b-7b00-41e1-9a62-62325f83dad5");
        //    var timeSlotString = "timeslottemplate-f764581b-7b00-41e1-9a62-62325f83dad5";

        //    var startTime = "07:30:00";

        //    var endTime = "16:15:00";

        //    var timeSlotName = "Normale werkdag";

        //    var timeSlotNote = "Yep, notitie bij normale werkdag";

        //    timeSlotId = new Guid("4f2f0425-50ac-44bc-8bdb-b5ec445f1f21");

        //    timeSlotString = "timeslottemplate-4f2f0425-50ac-44bc-8bdb-b5ec445f1f21";

        //     startTime = "22:30:00";

        //     endTime = "23:55:00";

        //     timeSlotName = "Tot vijf voor twaalf";

        //     timeSlotNote = "Stay awake";


        //     gdtId = new Guid("71ba8652-f4ba-461e-916e-28062a949e23");
        //     gdtString = "globaldutytemplate-71ba8652-f4ba-461e-916e-28062a949e23";

        //    note = "Deze Global Duty Template heeft enkel deze notitie.";


        //    gdtId = new Guid("7ba07bc2-b93d-4e90-ad10-2d74d23b9463");







        //}

    }
}
