﻿using System.Collections.Generic;
using CRM.Domain.Branch;
using CRM.Domain.Branch.Models;
using EventFlow.Commands;

namespace WebPortal.CCMConnector.Application.Branches.Commands
{
    public class CreateBranchCommand : Command<BranchAggregate, BranchId>
    {
        public string BranchName { get; }
        public AddressModel Address { get; }
        public string CustomerId { get; }
        public ICollection<ContactDetailModel> ContactDetails { get; }

        public CreateBranchCommand(BranchId aggregateId, string branchName, AddressModel address, string customerId, ICollection<ContactDetailModel> contactDetails) : base(aggregateId)
        {
            BranchName = branchName;
            Address = address;
            CustomerId = customerId;
            ContactDetails = contactDetails;
        }
    }
}