﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Branch;
using EventFlow.Commands;

namespace WebPortal.CCMConnector.Application.Branches.Commands
{
    public class CreateBranchCommandHandler : CommandHandler<BranchAggregate, BranchId, CreateBranchCommand>
    {
        public override Task ExecuteAsync(BranchAggregate aggregate,
            CreateBranchCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.CreateBranch(command.BranchName, command.Address, command.CustomerId, command.ContactDetails), cancellationToken);
        }
    }
}