﻿using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Branch.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.CCMConnector.Application.Branches.Queries
{
    public class GetBranchByBranchIdQueryHandler : IQueryHandler<GetBranchByBranchIdQuery, BranchReadModel>
    {
        private readonly IMongoDbReadModelStore<BranchReadModel> _branchStore;

        public GetBranchByBranchIdQueryHandler(IMongoDbReadModelStore<BranchReadModel> branchStore)
        {
            _branchStore = branchStore;
        }

        public Task<BranchReadModel> ExecuteQueryAsync(GetBranchByBranchIdQuery query,
            CancellationToken cancellationToken)
        {
            return Task.Run(() => _branchStore.AsQueryable().FirstOrDefault(x => x.Id.Equals(query.BranchId)), cancellationToken);
        }
    }
}