﻿using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Branch.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.CCMConnector.Application.Branches.Queries
{
    public class GetBranchIdsByCustomerIdQueryHandler: IQueryHandler<GetBranchIdsByCustomerIdQuery, List<string>>
    {
        public GetBranchIdsByCustomerIdQueryHandler(IMongoDbReadModelStore<BranchReadModel> store)
        {
            _store = store;
        }

        private readonly IMongoDbReadModelStore<BranchReadModel> _store;
        public Task<List<string>> ExecuteQueryAsync(GetBranchIdsByCustomerIdQuery query,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                _store.AsQueryable()
                    .Where(x => x.CustomerId == query.CustomerId
                                && !x.Deleted)
                    .Select(x => x.Id)
                    .ToList());
        }
    }
}
