﻿using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Branch.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.CCMConnector.Application.Branches.Queries
{
    public class GetBranchesByCustomerIdQueryHandler : IQueryHandler<GetBranchesByCustomerIdQuery, List<BranchReadModel>>
    {
        private readonly IMongoDbReadModelStore<BranchReadModel> _branchStore;

        public GetBranchesByCustomerIdQueryHandler(IMongoDbReadModelStore<BranchReadModel> branchStore)
        {
            _branchStore = branchStore;
        }

        public Task<List<BranchReadModel>> ExecuteQueryAsync(GetBranchesByCustomerIdQuery query,
            CancellationToken cancellationToken)
        {
            return Task.Run(() => _branchStore
                    .AsQueryable()
                    .Where(x => x.CustomerId.Equals(query.CustomerId))
                    .ToList()
            , cancellationToken);
        }
    }
}