﻿using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Customer.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.CCMConnector.Application.Branches.Queries
{
    public class GetHqBranchByCustomerIdQueryHandler: IQueryHandler<GetHqBranchByCustomerIdQuery, string>
    {
        private readonly IMongoDbReadModelStore<CustomerReadModel> _store;

        public GetHqBranchByCustomerIdQueryHandler(IMongoDbReadModelStore<CustomerReadModel> store)
        {
            _store = store;
        }

        public Task<string> ExecuteQueryAsync(GetHqBranchByCustomerIdQuery query,
            CancellationToken cancellationToken)
        {
            var rtn = _store.AsQueryable()
                .SingleOrDefault(x => !x.Deleted
                                      && x.Id == query.CustomerId)
                ?.CustomerBranchId;
            return Task.FromResult(rtn);
        }
    }
}
