﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.CallScript;
using EventFlow.Aggregates.ExecutionResults;
using EventFlow.Commands;

namespace WebPortal.CCMConnector.Application.CallScripts.Commands
{
    public class ModifyCallScriptCommandHandler : CommandHandler<CallScriptAggregate, CallScriptId, IExecutionResult, ModifyCallScriptCommand>
    {
        public override Task<IExecutionResult> ExecuteCommandAsync(CallScriptAggregate aggregate,
            ModifyCallScriptCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifyCallScript(command.CallScriptBody));
        }
    }
}
