﻿using System;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.CallScript;
using EventFlow.Aggregates.ExecutionResults;
using EventFlow.Commands;

namespace WebPortal.CCMConnector.Application.CallScripts.Commands
{
    public class ModifyCallScriptDossierIdCommandHandler : CommandHandler<CallScriptAggregate, CallScriptId, IExecutionResult, ModifyCallScriptDossierIdCommand>
    {
        public override Task<IExecutionResult> ExecuteCommandAsync(CallScriptAggregate aggregate,
            ModifyCallScriptDossierIdCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifyDossierIdCallScript(command.DossierId));
        }
    }
}
