﻿using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.CallScript.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.CCMConnector.Application.CallScripts.Queries
{
    public class GetCallScriptIdsByDossierIdQueryHandler: IQueryHandler<GetCallScriptIdsByDossierIdQuery, List<string>>
    {
        public GetCallScriptIdsByDossierIdQueryHandler(IMongoDbReadModelStore<CallScriptReadModel> store)
        {
            _store = store;
        }

        private readonly IMongoDbReadModelStore<CallScriptReadModel> _store;

        public Task<List<string>> ExecuteQueryAsync(GetCallScriptIdsByDossierIdQuery query,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                _store.AsQueryable()
                    .Where(x => x.DossierId == query.DossierId
                                && !x.Deleted)
                    .Select(x => x.Id)
                    .ToList()
            );
        }
    }
}
