﻿using CRM.Domain.Customer;
using EventFlow.Commands;

namespace WebPortal.CCMConnector.Application.Customers.Commands
{
    public class CreateCustomerCommand: Command<CustomerAggregate, CustomerId>
    {
        public CreateCustomerCommand(CustomerId aggregateId, string customerName, string tenant, int? cCMCLientId, int webPortalLicenseAmount) : base(aggregateId)
        {
            CustomerName = customerName;
            Tenant = tenant;
            CCMCLientId = cCMCLientId;
            WebPortalLicenseAmount = webPortalLicenseAmount;
        }

        public string CustomerName { get; private set; }
        public string Tenant { get; private set; }
        public int? CCMCLientId { get; private set; }
        public int WebPortalLicenseAmount { get; private set; }
    }
}
