﻿using EventFlow.Aggregates.ExecutionResults;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Customer;


namespace WebPortal.CCMConnector.Application.Customers.Commands
{
    public class CreateCustomerCommandHandler : CommandHandler<CustomerAggregate, CustomerId, IExecutionResult, CreateCustomerCommand>
    {
        public override Task<IExecutionResult> ExecuteCommandAsync(CustomerAggregate aggregate, CreateCustomerCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() =>
            aggregate.CreateCustomer(command.CustomerName, command.Tenant, command.CCMCLientId, command.WebPortalLicenseAmount));
        }
    }
}
