﻿using EventFlow.Aggregates.ExecutionResults;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Customer;

namespace WebPortal.CCMConnector.Application.Customers.Commands
{
    public class ModifyCustomerSubscriptionsCommandHandler : CommandHandler<CustomerAggregate, CustomerId, IExecutionResult, ModifyCustomerSubscriptionsCommand>
    {
        public override Task<IExecutionResult> ExecuteCommandAsync(CustomerAggregate aggregate,
            ModifyCustomerSubscriptionsCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifySubscriptions(command.Subscriptions));
        }
    }
}
