﻿using System.Linq;
using CRM.Domain.Dossier.ReadModels;
using EventFlow.Queries;
using System.Threading;
using System.Threading.Tasks;
using EventFlow.MongoDB.ReadStores;
using WebPortal.Application.Extentions;
using WebPortal.CCMConnector.Application.Dossiers.Queries;

namespace WebPortal.Application.Dossiers.Queries
{
    public class GetAllDossiersQueryHandler : IQueryHandler<GetAllDossiersQuery, PageResult<DossierReadModel>>
    {
        private readonly IMongoDbReadModelStore<DossierReadModel> _store;

        public GetAllDossiersQueryHandler(IMongoDbReadModelStore<DossierReadModel> store)
        {
            _store = store;
        }

        public Task<PageResult<DossierReadModel>> ExecuteQueryAsync(GetAllDossiersQuery query, CancellationToken cancellationToken)
        {
            return Task.Run(() => _store.AsQueryable()
                .Where(x=> string.IsNullOrEmpty(query.DossierName) || x.DossierName.Contains(query.DossierName))
                .OrderBy(query.Sort, query.Asc)
                .GetPage(query.Page, query.PageSize), cancellationToken);
        }
    }
}