﻿using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Dossier.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.CCMConnector.Application.Dossiers.Queries
{
    public class GetDossierIdsByCustomerIdQueryHandler: IQueryHandler<GetDossierIdsByCustomerIdQuery, List<string>>
    {
        public GetDossierIdsByCustomerIdQueryHandler(IMongoDbReadModelStore<DossierReadModel> store)
        {
            _store = store;
        }

        private readonly IMongoDbReadModelStore<DossierReadModel> _store;

        public Task<List<string>> ExecuteQueryAsync(GetDossierIdsByCustomerIdQuery query,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                _store.AsQueryable()
                    .Where(x => x.CustomerId == query.CustomerId
                                && !x.Deleted)
                    .Select(x => x.Id)
                    .ToList());
        }
    }
}
