﻿using System;
using System.Collections.Generic;
using CRM.Domain.Duty;
using CRM.Domain.Duty.Models;
using EventFlow.Commands;

namespace WebPortal.CCMConnector.Application.Duties.Commands
{
    public class AddDutyCommand : Command<DutyAggregate, DutyId>
    {
        public AddDutyCommand(DutyId aggregateId, string dossierId, string category, DateTime startDate, DateTime endDate, string actionDescription, string startAt, string endAt, ICollection<DutyEmployeeModel> dutyEmployeeModels = null) : base(aggregateId)
        {
            DossierId = dossierId;
            Category = category;
            StartDate = startDate;
            EndDate = endDate;
            ActionDescription = actionDescription;
            StartAt = startAt;
            EndAt = endAt;
            DutyEmployeeModels = dutyEmployeeModels;
        }

        public string DossierId { get; }
        public string Category { get; }
        public DateTime StartDate { get; }
        public DateTime EndDate { get; }
        public string ActionDescription { get; }
        public string StartAt { get; }
        public string EndAt { get; }
        public ICollection<DutyEmployeeModel> DutyEmployeeModels { get; }
    }
}