﻿using EventFlow.Queries;
using System;
using System.Collections.Generic;
using System.Linq;
using WebPortal.CCMConnector.Application.Duties.Models;

namespace WebPortal.CCMConnector.Application.Duties.Queries
{
    /// <summary>
    /// Tags en filterText zijn nog niet geïmplementeerd
    /// </summary>
    public class GetDutiesQuery : IQuery<List<GetOverviewDutyModel>>
    {
        public GetDutiesQuery(string dossierId, DateTime startDateTime,
            DateTime endDateTime, int page = 1, bool asc = true, int pageSize = 20,
            string sort = "StartDate", string tagIds = null, string filterText = "")
        {
            Asc = asc;
            Sort = sort;
            Page = page;
            PageSize = pageSize;
            DossierId = dossierId;
            StartDateTime = startDateTime;
            EndDateTime = endDateTime;
            FilterText = filterText ?? "";
            TagIds = string.IsNullOrWhiteSpace(tagIds)
                ? new List<string>()
                : tagIds.Split(';').ToList();
        }

        public bool Asc { get; }
        public string Sort { get; }
        public int Page { get; }
        public int PageSize { get; }
        public string DossierId { get; }
        public DateTime StartDateTime { get; }
        public DateTime EndDateTime { get; }
        public string FilterText { get; }

        public List<string> TagIds { get; }

    }
}
