﻿using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Duty.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.CCMConnector.Application.Duties.Queries
{
    public class GetDutyIdsByDossierIdQueryHandler: IQueryHandler<GetDutyIdsByDossierIdQuery, List<string>>
    {
        public GetDutyIdsByDossierIdQueryHandler(IMongoDbReadModelStore<DutyReadModel> store)
        {
            _store = store;
        }

        private readonly IMongoDbReadModelStore<DutyReadModel> _store;

        public Task<List<string>> ExecuteQueryAsync(GetDutyIdsByDossierIdQuery query,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                _store.AsQueryable()
                    .Where(x => x.DossierId == query.DossierId
                                && !x.Deleted)
                    .Select(x => x.Id)
                    .ToList()
            );
        }
    }
}
