﻿using System.Collections.Generic;
using CRM.Domain.Employee;
using CRM.Domain.Employee.Models;
using EventFlow.Commands;

namespace WebPortal.CCMConnector.Application.Employees.Commands
{
    public class CreateEmployeeCommand: Command<EmployeeAggregate, EmployeeId>
    {
        public CreateEmployeeCommand(EmployeeId aggregateId,
            string firstName,
            string lastName,
            string ccEmail,
            string employeeComment,
            bool sendMailWithTicket,
            string customerId,
            bool ticketAsRead,
            ICollection<EmployeeContactDetailModel> contactDetails,
            ICollection<string> tags) : base(aggregateId)
        {
            FirstName = firstName;
            LastName = lastName;
            CCEmail = ccEmail;
            EmployeeComment = employeeComment;
            SendMailWithTicket = sendMailWithTicket;
            CustomerId = customerId;
            SetTicketAsRead = ticketAsRead;
            ContactDetails = contactDetails;
            Tags = tags;
        }


        public string FirstName { get; }
        public string LastName { get; }
        public string CCEmail { get; }
        public string EmployeeComment { get; }
        public bool SendMailWithTicket { get; }
        public string CustomerId { get; }
        public bool SetTicketAsRead { get; }
        public ICollection<EmployeeContactDetailModel> ContactDetails { get; }
        public ICollection<string> Tags { get; }
    }
}
