﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Employee;
using EventFlow.Commands;

namespace WebPortal.CCMConnector.Application.Employees.Commands
{
    public class CreateEmployeeCommandHandler: CommandHandler<EmployeeAggregate, EmployeeId, CreateEmployeeCommand>
    {
        public override Task ExecuteAsync(EmployeeAggregate aggregate,
            CreateEmployeeCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.CreateEmployee(
                    command.CustomerId, 
                    command.FirstName, 
                    command.LastName, 
                    command.CCEmail,
                    command.EmployeeComment, 
                    command.SendMailWithTicket, 
                    command.SetTicketAsRead,
                    command.ContactDetails, 
                    command.Tags), cancellationToken);
        }
    }
}
