﻿using CRM.Domain.Employee;
using CRM.Domain.Shared.Enums;
using EventFlow.Commands;

namespace WebPortal.CCMConnector.Application.Employees.Commands
{
    public class ModifyContactDetailTypeCommand : Command<EmployeeAggregate, EmployeeId>
    {
        public ModifyContactDetailTypeCommand(EmployeeId aggregateId,
            string contactDetailId,
            ContactDetailType detailType) : base(aggregateId)
        {
            ContactDetailId = contactDetailId;
            DetailType = detailType;
        }

        public string ContactDetailId { get; set; }
        public ContactDetailType DetailType { get; set; }
    }
}
