﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Employee;
using CRM.Domain.Employee.Entities;
using EventFlow.Commands;

namespace WebPortal.CCMConnector.Application.Employees.Commands
{
    public class ModifyContactDetailTypeCommandHandler : CommandHandler<EmployeeAggregate, EmployeeId, ModifyContactDetailTypeCommand>
    {
        public override Task ExecuteAsync(EmployeeAggregate aggregate,
            ModifyContactDetailTypeCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                aggregate.ModifyContactDetailType(
                    EmployeeContactDetailId.With(command.ContactDetailId),
                    command.DetailType), cancellationToken);
        }
    }
}
