﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Employee;
using EventFlow.Commands;

namespace WebPortal.CCMConnector.Application.Employees.Commands
{
    public class ModifyEmployeeCustomerIdCommandHandler : CommandHandler<EmployeeAggregate, EmployeeId, ModifyEmployeeCustomerIdCommand>
    {

        public override Task ExecuteAsync(EmployeeAggregate aggregate,
            ModifyEmployeeCustomerIdCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                    aggregate.ModifyEmployeeCustomer(command.CustomerId),
                cancellationToken);
        }
    }
}
