﻿using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Employee.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;
using WebPortal.CCMConnector.Application.Employees.Models;

namespace WebPortal.CCMConnector.Application.Employees.Queries
{
    public class GetContactDetailsByTypeQueryHandler : IQueryHandler<GetContactDetailsByTypeQuery,
        List<GetContactDetailsByTypeModel>>
    {
        public GetContactDetailsByTypeQueryHandler(IMongoDbReadModelStore<EmployeeReadModel> store)
        {
            _store = store;
        }

        private IMongoDbReadModelStore<EmployeeReadModel> _store;
        public Task<List<GetContactDetailsByTypeModel>> ExecuteQueryAsync(GetContactDetailsByTypeQuery query, CancellationToken cancellationToken)
        {
            return Task.Run(() =>
            {
                //var rtn = _store.AsQueryable()
                //    .Where(x => !x.Deleted
                //                && x.ContactDetails.Select(y => y.ContactType)
                //                    .Contains(query.DetailType))
                //    .SelectMany(x 
                //        => x.ContactDetails, (parent,
                //        child) 
                //        => new GetContactDetailsByTypeModel()
                //    {
                //        EmployeeId = parent.Id,
                //        ContactDetailId = child.Id,
                //        DetailType = child.ContactType
                //    })
                //    .ToList();

                var rtn = _store.AsQueryable()
                    .Where(x => !x.Deleted
                                && x.ContactDetails != null)

                    .SelectMany(x
                        => x.ContactDetails, (parent,
                            child)
                        => new GetContactDetailsByTypeModel()
                        {
                            EmployeeId = parent.Id,
                            ContactDetailId = child.Id,
                            DetailType = child.ContactType
                        })
                    .ToList()
                    .Where(x => x.DetailType == query.DetailType)
                    .ToList();

                return rtn;
            });
        }
    }
}
