﻿using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Employee.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.CCMConnector.Application.Employees.Queries
{
    public class GetEmployeeIdsByCustomerIdQueryHandler: IQueryHandler<GetEmployeeIdsByCustomerIdQuery, List<string>>
    {
        public GetEmployeeIdsByCustomerIdQueryHandler(IMongoDbReadModelStore<EmployeeReadModel> store)
        {
            _store = store;
        }

        private readonly IMongoDbReadModelStore<EmployeeReadModel> _store;
        public Task<List<string>> ExecuteQueryAsync(GetEmployeeIdsByCustomerIdQuery query,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                _store.AsQueryable()
                    .Where(x => x.CustomerId == query.CustomerId 
                                && !x.Deleted)
                    .Select(x => x.Id)
                    .ToList());
        }
    }
}
