﻿using System.Collections.Generic;
using System.Linq;

namespace WebPortal.Application.Extentions
{
    public static class Pagination
    {
        public static PageResult<T> GetPage<T>(this IEnumerable<T> query,
            int page,
            int pageSize) where T : class, new()
        {
            return new PageResult<T>
            {
                Total = query.Count(),
                Page = page,
                PageSize = pageSize,
                Results = query.Skip((page - 1) * pageSize).Take(pageSize).ToList()
            };
        }
    }
}