﻿using CRM.Domain.InteractionStatistic;
using EventFlow.Commands;
using System;
using CRM.Domain.InteractionStatistic.Enums;

namespace WebPortal.CCMConnector.Application.InteractionStats.Commands
{
    public class CreateInteractionStatCommand : Command<InteractionStatisticAggregate, InteractionStatisticId>
    {
        public CreateInteractionStatCommand(InteractionStatisticId aggregateId, string interactionIdKey, string dossierId, int dNIS, DateTime? established, DateTime connected, TimeSpan duration, DateTime disconnected, InteractionType interactionTypeEnum, int? originalMessageIdCcm, string ticketId) : base(aggregateId)
        {
            InteractionIdKey = interactionIdKey;
            DossierId = dossierId;
            DNIS = dNIS;
            Established = established;
            Connected = connected;
            Duration = duration;
            Disconnected = disconnected;
            InteractionTypeEnum = interactionTypeEnum;
            OriginalMessageIdCcm = originalMessageIdCcm;
            TicketId = ticketId;
            if (TicketId != null)
            {

            }
        }

        public string InteractionIdKey { get; }
        public string DossierId { get; }
        public int DNIS { get; }
        public DateTime? Established { get; }
        public DateTime Connected { get; }
        public TimeSpan Duration { get; }
        public DateTime Disconnected { get; }
        public InteractionType InteractionTypeEnum { get; }
        public int? OriginalMessageIdCcm { get; }
        public string TicketId { get;}


    }
}
