﻿using CRM.Domain.InteractionStatistic;
using EventFlow.Aggregates.ExecutionResults;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;

namespace WebPortal.CCMConnector.Application.InteractionStats.Commands
{
    public class CreateInteractionStatCommandHandler : CommandHandler<InteractionStatisticAggregate, InteractionStatisticId, IExecutionResult, CreateInteractionStatCommand>
    {
        public override Task<IExecutionResult> ExecuteCommandAsync(InteractionStatisticAggregate aggregate, CreateInteractionStatCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.CreateInteractionStat(
                command.InteractionIdKey, command.DossierId, 
                command.DNIS, 
                command.Established, 
                command.Connected, 
                command.Duration, 
                command.Disconnected, 
                command.InteractionTypeEnum, 
                command.OriginalMessageIdCcm, 
                command.TicketId), cancellationToken);
        }
    }
}
