﻿using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.InteractionStatistic.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.CCMConnector.Application.InteractionStats.Queries
{
    public class GetStatisticIdsByDossierIdQueryHandler: IQueryHandler<GetStatisticIdsByDossierIdQuery, List<string>>
    {
        public GetStatisticIdsByDossierIdQueryHandler(IMongoDbReadModelStore<InteractionStatisticReadModel> store)
        {
            _store = store;
        }

        private readonly IMongoDbReadModelStore<InteractionStatisticReadModel> _store;

        public Task<List<string>> ExecuteQueryAsync(GetStatisticIdsByDossierIdQuery query,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                _store.AsQueryable()
                    .Where(x => 
                        x.DossierId == query.DossierId
                        && !x.Deleted)
                    .Select(x => x.Id)
                    .ToList()
            );
        }
    }
}
