﻿using EventFlow.Commands;
using System;
using System.Collections.Generic;
using CRM.Domain.Ticket;


namespace WebPortal.CCMConnector.Application.Tickets.Commands
{
    public class CreateTicketCommand: Command<TicketAggregate, TicketId>
    {
        public CreateTicketCommand(TicketId aggregateId, string dossierId, string ticketText, int? originalCCMMessageId, DateTime createdInCRM, DateTime lastModifiedInCRM, string createdCRMUser, string lastModifiedCRMUser, ICollection<string> tags) : base(aggregateId)
        {
            DossierId = dossierId;
            TicketText = ticketText;
            OriginalCCMMessageId = originalCCMMessageId;
            CreatedInCRM = createdInCRM;
            LastModifiedInCRM = lastModifiedInCRM;
            CreatedCRMUser = createdCRMUser;
            LastModifiedCRMUser = lastModifiedCRMUser;
            Tags = tags;
        }

        public string DossierId { get; private set; }
        public string TicketText { get; private set; }
        public int? OriginalCCMMessageId { get; private set; }
        public DateTime CreatedInCRM { get; private set; }
        public DateTime LastModifiedInCRM { get; private set; }
        public string CreatedCRMUser { get; private set; }
        public string LastModifiedCRMUser { get; private set; }
        public ICollection<string> Tags { get; private set; }
    }
}
