﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Ticket;
using EventFlow.Aggregates.ExecutionResults;
using EventFlow.Commands;

namespace WebPortal.CCMConnector.Application.Tickets.Commands
{
    public class
        CreateTicketCommandHandler : CommandHandler<TicketAggregate, TicketId, IExecutionResult, CreateTicketCommand>
    {
        public override Task<IExecutionResult> ExecuteCommandAsync(TicketAggregate aggregate,
            CreateTicketCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(
                () => aggregate.CreateTicket(command.DossierId, command.TicketText, command.OriginalCCMMessageId,
                    command.CreatedInCRM, command.LastModifiedInCRM, command.CreatedCRMUser,
                    command.LastModifiedCRMUser, command.Tags), cancellationToken);
        }
    }
}