﻿using EventFlow.Commands;
using System;
using System.Collections.Generic;
using CRM.Domain.Ticket;

namespace WebPortal.CCMConnector.Application.Tickets.Commands
{
    public class ModifyTicketCommand: Command<TicketAggregate, TicketId>
    {
        public ModifyTicketCommand(TicketId aggregateId, string ticketText, DateTime lastModifiedInCRM, string lastModifiedCRMUser): base(aggregateId)
        {
            TicketText = ticketText;
            LastModifiedInCRM = lastModifiedInCRM;
            LastModifiedCRMUser = lastModifiedCRMUser;
        }

        public string TicketText { get; private set; }
        public DateTime LastModifiedInCRM { get; private set; }
        public string LastModifiedCRMUser { get; private set; }

    }
}
