﻿using EventFlow.Aggregates.ExecutionResults;
using EventFlow.Commands;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Ticket;

namespace WebPortal.CCMConnector.Application.Tickets.Commands
{
    public class ModifyTicketCommandHandler : CommandHandler<TicketAggregate, TicketId, IExecutionResult, ModifyTicketCommand>
    {
        public override Task<IExecutionResult> ExecuteCommandAsync(TicketAggregate aggregate, ModifyTicketCommand command, CancellationToken cancellationToken)
        {
            return Task.Run(() => aggregate.ModifyTicket(command.TicketText, command.LastModifiedInCRM, command.LastModifiedCRMUser));
        }
    }
}
