﻿using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.Ticket.ReadModels;
using WebPortal.CCMConnector.Application.Tickets.Models;

namespace WebPortal.CCMConnector.Application.Tickets.Queries
{
    public class GetTicketIdsByCCMMessageIdsQueryHandler: IQueryHandler<GetTicketIdsByCCMMessageIdsQuery, List<GetWPAndCCMTicketIdModel>>
    {
        private IMongoDbReadModelStore<TicketReadModel> _readModelStore;

        public GetTicketIdsByCCMMessageIdsQueryHandler(IMongoDbReadModelStore<TicketReadModel> readModelStore)
        {
            _readModelStore = readModelStore;
        }


        public Task<List<GetWPAndCCMTicketIdModel>> ExecuteQueryAsync(GetTicketIdsByCCMMessageIdsQuery query, CancellationToken cancellationToken)
        {
            return Task.Run(() => _readModelStore.AsQueryable()
            .Where(x => !x.Deleted && query.OriginalCCMMessageIds.Contains(x.OriginalCCMMessageId.Value))
            .Select(x => new GetWPAndCCMTicketIdModel()
            {
                OriginalCCMMessageId = x.OriginalCCMMessageId,
                TicketId = x.Id
            }).ToList());

            
            
            //.SingleOrDefault(x => x.OriginalCCMMessageId == query.OriginalCCMMessageId).Id);
        }
    }
}
