﻿using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;
using CRM.Domain.Ticket.ReadModels;


namespace WebPortal.CCMConnector.Application.Tickets.Queries
{
    public class GetTicketIdsByDossierIdQueryHandler: IQueryHandler<GetTicketIdsByDossierIdQuery, List<string>>
    {
        public GetTicketIdsByDossierIdQueryHandler(IMongoDbReadModelStore<TicketReadModel> store)
        {
            _store = store;
        }

        private readonly IMongoDbReadModelStore<TicketReadModel> _store;

        public Task<List<string>> ExecuteQueryAsync(GetTicketIdsByDossierIdQuery query,
            CancellationToken cancellationToken)
        {
            return Task.Run(() =>
                _store.AsQueryable()
                    .Where(x => x.DossierId == query.DossierId
                                && !x.Deleted)
                    .Select(x => x.Id)
                    .ToList()
            );
        }
    }
}
