﻿using CRM.Domain.User;
using EventFlow.Commands;

namespace WebPortal.CCMConnector.Application.Users.Commands
{
    public class CreateUserCommand : Command<UserAggregate, UserId>
    {
        public CreateUserCommand(UserId aggregateId,
            string email,
            string userName,
            string? customerId,
            bool isCustomerAdmin,
            string? tenant
            ) : base(aggregateId)
        {
            Email = email;
            UserName = userName;
            CustomerId = customerId;
            IsCustomerAdmin = isCustomerAdmin;
            Tenant = tenant;
        }

        public string Email { get; }
        public string UserName { get; }
        public string? CustomerId { get; }
        public bool IsCustomerAdmin { get; }
        public string? Tenant {get;}
    }
}