﻿using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.User;
using EventFlow.Aggregates.ExecutionResults;
using EventFlow.Commands;

namespace WebPortal.CCMConnector.Application.Users.Commands
{
    public class DeleteUserCommandHandler : CommandHandler<UserAggregate, UserId, IExecutionResult, DeleteUserCommand>
    {

        public override Task<IExecutionResult> ExecuteCommandAsync(UserAggregate aggregate,
            DeleteUserCommand command,
            CancellationToken cancellationToken)
        {
            return Task.Run(aggregate.DeleteUser, cancellationToken);
        }
    }
}