﻿using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using CRM.Domain.User.ReadModels;
using EventFlow.MongoDB.ReadStores;
using EventFlow.Queries;

namespace WebPortal.CCMConnector.Application.Users.Queries
{
    public class GetUserIdsByCustomerIdQueryHandler: IQueryHandler<GetUserIdsByCustomerIdQuery, List<string>>
    {
        private readonly IMongoDbReadModelStore<UserReadModel> _store;

        public GetUserIdsByCustomerIdQueryHandler(IMongoDbReadModelStore<UserReadModel> store)
        {
            _store = store;
        }

        public Task<List<string>> ExecuteQueryAsync(GetUserIdsByCustomerIdQuery query,
            CancellationToken cancellationToken)
        {
            var rtn = _store.AsQueryable()
                .Where(x => x.CustomerId == query.CustomerId)
                .Select(x => x.Id)
                .ToList();
            return Task.FromResult(rtn);
        }
    }
}
