﻿using System.Threading;
using System.Threading.Tasks;
using EventFlow.Queries;
using WebPortal.CCMConnector.Application.Dossiers.Queries;
using WebPortal.CCMConnector.ApplicationTest.Configuration;
using Xunit;

namespace WebPortal.CCMConnector.ApplicationTest
{
    public class FaultyDossierTest
    {
        private string conString = "mongodb://connector:connector123456789@192.168.121.11";
        //string dbName = "wp_dev";
        string dbName = "wp_staging";

        [Fact]
        public async Task GetFaultyDossiers()
        {
            var services = ConfigureServices.ConfigureServicesWithHandlersMC(conString, dbName);
            var queryProcessor = services.Resolve<IQueryProcessor>();

            var q = new GetFaultyDossiersQuery();
            var dossiers = await queryProcessor
                .ProcessAsync(q, new CancellationToken());

            Assert.True(dossiers.Count > 0);
        }
    }
}
