﻿using System;
using CRM.Domain.Shared.Enums;
using WebPortal.CCMConnector.ConfigConsole.UI;
using WebPortal.CCMConnector.Data.Configuration;

namespace WebPortal.CCMConnector.ConfigConsole.StartUp
{
    public class MakeConnection
    {
        internal static bool Connected = false;
        internal static string ConString;
        internal static string DbName;

        public static void EstablishConnection()
        {
            Connected = false;
            WriteText.WriteInstruction("Please provide a connection-string");
            ConString = Console.ReadLine();
            WriteText.WriteInstruction($"Please provide database-name for '{ConString}'");
            DbName = Console.ReadLine();
            Console.WriteLine("Thank you. Please wait, verifying connection and db...");
            var s = VerifyConnection.VerifyMongoDBConnection(ConString, DbName);
            switch (s)
            {
                case ConnectionStatus.Ok:
                    Connected = true;
                    break;
                case ConnectionStatus.DbNotFound:
                    WriteText.WriteError($"\nCould not find db '{DbName}'");
                    break;
                case ConnectionStatus.InvalidConnectionString:
                    WriteText.WriteError($"\n'{ConString}' is not a valid connection-string!");
                    break;
            }
        }

    }
}
