﻿using System.Threading.Tasks;
using EventFlow.Configuration;
using WebPortal.CCMConnector.Data.ConnectorLogic.Dossiers;
using WebPortal.CCMConnector.Data.ConnectorLogic.General;
using WebPortal.CCMConnector.Data.ConnectorLogic.Tickets;

namespace WebPortal.CCMConnector.Data.Configuration
{
    public class RepairAndFix
    {
        private IRootResolver _serviceResolver;
        private DossierLogic _dossierLogic;
        private TicketLogic _ticketLogic;

        public RepairAndFix(string conString, string dbName)
        {
            _serviceResolver = ConfigureServices.ConfigureServicesWithHandlersMC(conString, dbName);

        }

        public async Task<string> CheckDossiersWithoutCustomerId()
        {
            _dossierLogic = new DossierLogic(_serviceResolver);
           return await _dossierLogic.GetFaultyDossiers();
        }

        public async Task<string> CheckDuplicateTickets()
        {
            _ticketLogic = new TicketLogic(_serviceResolver);
            return await _ticketLogic.GetFaultyTickets();
        }


        public int GetAmountToClean(string entityType)
        {
            switch (entityType.ToUpper())
            {
                case "DOSSIERS": return _dossierLogic.DossiersToClean;
                case "TICKETS": return _ticketLogic.TicketsToClean;
            }

            return 0;
        }

        public string RepairDossiers()
        {
            return _dossierLogic.RepairDossiers();
        }

        public string RepairTickets()
        {
            return _ticketLogic.RepairTickets();
        }

    }
}
