﻿using System.Threading.Tasks;
using CRM.Domain.Shared.Enums;
using EventFlow.Configuration;
using WebPortal.CCMConnector.Data.ConnectorLogic.Employees;
using WebPortal.CCMConnector.Data.ConnectorLogic.General;

namespace WebPortal.CCMConnector.Data.Configuration
{
    public class ReplaceAndFix
    {
        private IRootResolver _serviceResolver;
        private EmployeeLogic _employeeLogic;

        public ReplaceAndFix(string conString,
            string dbName)
        {
            _serviceResolver = ConfigureServices.ConfigureServicesWithHandlersMC(conString, dbName);
        }

        public async Task<string> CheckContactDetailsForType(ContactDetailType from)
        {
            _employeeLogic = new EmployeeLogic(_serviceResolver);
            return await _employeeLogic.GetContactDetailsByType(from);
        }

        public string ReplaceContactDetailTypess(ContactDetailType from,
            ContactDetailType to)
        {
            return _employeeLogic.ReplaceContactDetailTypes(from, to);
        }

        public int GetAmountToReplace(string entityType)
        {
            switch (entityType.ToUpper())
            {
                case "CONTACTDETAILTYPES": return _employeeLogic.AmountOfContactDetailsToModifyTypeFor;
            }

            return 0;
        }

    }
}
