﻿using System;
using System.Linq;
using CRM.Domain.Shared.Enums;
using MongoDB.Driver;

namespace WebPortal.CCMConnector.Data.Configuration
{
    public class VerifyConnection
    {
        public static ConnectionStatus VerifyMongoDBConnection(string conString,
            string dbName)
        {
            try
            {
                var client = new MongoClient(conString);
                //var db = client.GetDatabase(dbName);

                var names = client.ListDatabaseNames();

                names.MoveNext();

                var dbNames = names.Current.ToList();

                var mydb = dbNames.FirstOrDefault(x => x == dbName);
                if (mydb == null) return ConnectionStatus.DbNotFound;
                return ConnectionStatus.Ok;

                //return doc.AsBsonDocument.Names.First();
            }
            catch (Exception e)
            {
                return ConnectionStatus.InvalidConnectionString;
            }
        }
    }
}
