﻿using System;
using System.Collections.Generic;
using System.Linq;
using WebPortal.CCMConnector.Data.ConnectorLogic.General;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.CallScripts.CommandsCCM
{
    public class MarkCallScriptsAsUploadedCommand : ACCMCommandAndQuery
    {
        private static readonly NLog.Logger Logger = NLog.LogManager.GetCurrentClassLogger();

        internal static void MarkCallScriptsAsUploaded(List<int> customerIds)
        {
            using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
            {
                try
                {
                    ent.Database.Connection.ConnectionString = _prodTelesecConString;
                    var toMark = ent.CallScriptsHTML.Where(x => customerIds.Contains(x.CustomerId)).ToList();
                    toMark.ForEach(x =>
                    {
                        x.UploadedInWP = true;
                        x.LastModifiedBy = "CCMConnector";
                        x.LastModifiedOn = DateTime.UtcNow;
                    });
                    ent.SaveChanges();
                }
                catch (Exception e)
                {
                    Logger.Error(e, "Couldn't mark callscripts as uploaded in ProdTelesec-DB.");
                    throw;
                }

            }
        }

        internal static void MarkCallScriptsAsUploaded2(List<int> customerIds)
        {
            using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
            {
                try
                {
                    ent.Database.Connection.ConnectionString = _prodTelesecConString;
                    var toMark = ent.CallScript
                        .Where(x => customerIds.Contains(x.CustomerId) && x.Active)
                        .ToList();

                    toMark.ForEach(x =>
                   {
                       x.UploadedInWp = true;
                       x.LastModifiedOn = DateTime.UtcNow;
                   });

                    ent.SaveChanges();
                }
                catch (Exception e)
                {
                    Logger.Error(e, "Couldn't mark callscripts as uploaded in ProdTelesec-DB.");
                    throw;
                }

            }
        }


    }
}

