﻿using System;
using System.Collections.Generic;
using System.Threading;
using EventFlow.Queries;
using WebPortal.CCMConnector.Application.CallScripts.Models;
using WebPortal.CCMConnector.Application.CallScripts.Queries;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.CallScripts.QueriesWP
{
    public class GetCallScriptsWPQuery
    {
        private readonly IQueryProcessor _queryProcessor;
        private static readonly NLog.Logger Logger = NLog.LogManager.GetCurrentClassLogger();

        public GetCallScriptsWPQuery(IQueryProcessor queryProcessor)
        {
            _queryProcessor = queryProcessor;
        }

        public List<GetCallScriptIdModel> GetAlreadyUploaded(List<string> dossierIds)
        {
            try
            {
                return _queryProcessor.ProcessAsync(new GetDossierIdsAndTagsQuery(dossierIds), 
                    new CancellationToken())
                    .ConfigureAwait(false)
                    .GetAwaiter()
                    .GetResult();
            }
            catch (Exception e)
            {
                Logger.Error(e, "Couldn't get already uploaded CallScripts from WebPortal.");
                throw;
            }
        }
    }
}
