﻿using System.Collections.Generic;
using AutoMapper;
using WebPortal.CCMConnector.Data.ConnectorLogic.General;
using WebPortal.CCMConnector.Data.Models;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.Customers.CommandsCCM
{
    public class CreateSubscriptionsAndModules: ACCMCommandAndQuery
    {

        public static void CreateAndSaveSubscriptions(List<TempWPSubscription> tempSubscriptions, IMapper mapper)
        { 

            var subs = mapper.Map<List<TempWPSubscription>, List<EDMX.WPSubscriptions>>(tempSubscriptions);

            using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
            {
                ent.Database.Connection.ConnectionString = _prodTelesecConString;
                ent.WPSubscriptions.AddRange(subs);
                ent.SaveChanges();
            }

        }

        public static void CreateAndSaveCustomerModules(List<TempWPCustomerModule> tempCustomerModules, IMapper mapper)
        {
            var modules = mapper.Map<List<TempWPCustomerModule>, List<EDMX.WPCustomerModules>>(tempCustomerModules);
            using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
            {
                ent.Database.Connection.ConnectionString = _prodTelesecConString;
                ent.WPCustomerModules.AddRange(modules);
                ent.SaveChanges();
            }
        }
    }
}
