﻿using System;
using System.Linq;
using WebPortal.CCMConnector.Data.ConnectorLogic.General;
using WebPortal.CCMConnector.Data.EDMX;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.Customers.CommandsCCM
{
    public class DebriefUploadItem : ACCMCommandAndQuery
    {
        private static readonly NLog.Logger Logger = NLog.LogManager.GetCurrentClassLogger();

        public static void SetItemAsUploadedInWP(long id)
        {
            try
            {
                using (ProdtelesecEntities ent = new ProdtelesecEntities())
                {
                    ent.Database.Connection.ConnectionString = _prodTelesecConString;
                    var toUpdate = ent.WPModificationUpload.SingleOrDefault(x => x.Id == id);
                    if (toUpdate == null)
                        return;

                    toUpdate.IsUploadedInWP = true;
                    toUpdate.LastModifiedBy = "CCMConnector";
                    toUpdate.LastModifiedOn = DateTime.UtcNow;
                    ent.SaveChanges();
                }
            }
            catch (Exception e)
            {
                Logger.Error(e, $"The Modification with Id {id} was successfully uploaded to the webPortal, but could not mark this in de CCM-DB!");
                throw;
            }
        }

        public static void RemoveDossierIdFromCustomerFiche(int mainficheId)
        {
            try
            {
                using (ProdtelesecEntities ent = new ProdtelesecEntities())
                {
                    ent.Database.Connection.ConnectionString = _prodTelesecConString;
                    var custsWithDossierId =
                        ent.Customer.Where(x => x.CustomerId == mainficheId || x.Mainfiche == mainficheId)
                            .ToList();
                    custsWithDossierId.ForEach(x =>
                    {
                        x.DossierIdWP = null;
                        x.ClientId = null;
                    });
                    ent.SaveChanges();
                }
            }
            catch (Exception e)
            {
                Logger.Error(e, $"Couldnt remove the dossierId in customerfiche '{mainficheId}' or any ot its subfiches");
                throw;
            }
        }
    }
}
