﻿using System;
using System.Linq;
using WebPortal.CCMConnector.Data.ConnectorLogic.General;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.Customers.CommandsCCM
{
    public class DeleteSubscriptionInCCM : ACCMCommandAndQuery
    {
        private static readonly NLog.Logger Logger = NLog.LogManager.GetCurrentClassLogger();

        public static void DeleteSubscriptionByCustomerIdWp(string customerId)
        {
            try
            {
                using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
                {
                    ent.Database.Connection.ConnectionString = _prodTelesecConString;
                    var toDelete = ent.WPSubscriptions.SingleOrDefault(x =>
                        x.CustomerIdWP == customerId
                        && !x.Deleted);
                    toDelete.Deleted = true;
                    toDelete.EndDate = DateTime.UtcNow;
                    toDelete.LastModifiedOn = DateTime.UtcNow;
                    toDelete.LastModifiedBy = "CCMConnector";
                    toDelete.Client.Deleted = true;
                    toDelete.Client.InvoiceFiche = 0;
                    toDelete.Client.BranchFiche = null;
                    toDelete.Client.LastModifiedOn = DateTime.UtcNow;
                    toDelete.Client.LastModifiedBy = "CCMConnector";
                    toDelete.Client.Customer.ToList().ForEach(x =>
                    {
                        x.ClientId = null;
                        x.LastModifiedDate = DateTime.Now;
                        x.LastModifiedAgent = "CNCTR";
                    });
                    toDelete.WPCustomerModules.ToList().ForEach(x =>
                    {
                        x.Deleted = true;
                        x.LastModifiedBy = "CCMConnector";
                        x.LastModifiedOn = DateTime.UtcNow;
                    });
                    ent.SaveChanges();
                }
            }
            catch (Exception e)
            {
                Logger.Error(e, $"Could not delete the subscription and its accompanying modules in ProdTelesec for CustomerId: {customerId}");
                throw;
            }
        }
    }
}
