﻿using System;
using System.Linq;
using WebPortal.CCMConnector.Data.ConnectorLogic.General;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.Customers.CommandsCCM
{
    public class ReplaceClientIdsInCustomerFichesCommand: ACCMCommandAndQuery
    {
        private static readonly NLog.Logger Logger = NLog.LogManager.GetCurrentClassLogger();

        public static void ReplaceClientIdsInMainFiches(string customerIdSource,
            string customerIdDestination)
        {
            try
            {
                using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
                {
                    ent.Database.Connection.ConnectionString = _prodTelesecConString;
                    var clientIdSource = ent.WPSubscriptions
                        .SingleOrDefault(x => !x.Deleted
                                              && x.CustomerIdWP == customerIdSource)
                        .ClientIdCCM;
                    var clientIdDestination = ent.WPSubscriptions
                        .SingleOrDefault(x => !x.Deleted
                                              && x.CustomerIdWP == customerIdDestination)
                        .ClientIdCCM;

                    var custToModify = ent.Customer
                        .Where(x => x.ClientId == clientIdSource)
                        .ToList();
                    custToModify.ForEach(x =>
                    {
                        x.ClientId = clientIdDestination;
                        x.LastModifiedDate = DateTime.Now;
                        x.LastModifiedAgent = "CNCTR";
                    });

                    ent.SaveChanges();
                }
            }
            catch (Exception e)
            {
                Logger.Error(e, $"Could not replace clientIds in customerfiches for this customerIdSource: '{customerIdSource}' towards this customerIdDestination: '{customerIdDestination}'.");
                throw;
            }
        }
    }
}
