﻿using System.Collections.Generic;
using System.Linq;
using WebPortal.CCMConnector.Data.ConnectorLogic.General;
using WebPortal.CCMConnector.Data.Models;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.Customers.CommandsCCM
{
    public class UpdateCustomersWithDossierIdsCommand : ACCMCommandAndQuery
    {
        public static void UpdateCustomersWithDossierIds(List<TempCompanyItem> tempCompanyItems)
        {
            var idList = tempCompanyItems
                .Where(x => x.DossierId != null)
                .Select(x => x.CustomerId);
            using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
            {
                ent.Database.Connection.ConnectionString = _prodTelesecConString;
                var custs = ent.Customer
                    .Where(x => idList.Contains(x.CustomerId) 
                                || (x.Mainfiche != null && idList.Contains(x.Mainfiche.Value)))

                    .ToList();
                foreach (var c in custs)
                {
                    var theTemp = tempCompanyItems.FirstOrDefault(x =>
                        x.CustomerId == c.CustomerId && x.DossierId != null);
                    if (theTemp != null)
                        c.DossierIdWP = theTemp.DossierId;
                    else
                    {
                        var subFicheTemp = tempCompanyItems.FirstOrDefault(x => x.CustomerId == c.Mainfiche);
                        if (subFicheTemp != null)
                            c.DossierIdWP = subFicheTemp.DossierId;
                    }
                }

                ent.SaveChanges();
            }
        }

        public static void UpdateCustomersSetViewWpButton(List<int> customerIds)
        {
            using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
            {
                ent.Database.Connection.ConnectionString = _prodTelesecConString;
                var custs = ent.Customer
                    .Where(x => customerIds.Contains(x.CustomerId))
                    .ToList();
                custs.ForEach(x => x.ShowWebPortalButton = true);
                ent.SaveChanges();
            }
        }

            public static void UpdateOneCustomerWithDossierId(int custId,
            string dossierId)
        {
            using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
            {
                ent.Database.Connection.ConnectionString = _prodTelesecConString;
                var oneCust = ent.Customer
                    .Where(x => x.CustomerId == custId || x.Mainfiche == custId)
                    .ToList();
                oneCust.ForEach(x => x.DossierIdWP = dossierId);
                ent.SaveChanges();
            }
        }
    }
}
