﻿using System;
using System.Collections.Generic;
using System.Linq;
using WebPortal.CCMConnector.Data.ConnectorLogic.General;
using WebPortal.CCMConnector.Data.Models;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.Customers.CommandsCCM
{
    public class UpdateSubscriptionsInCCM: ACCMCommandAndQuery
    {
        public void UpdateSubscriptionsWithCustomerIdWP(List<WPSubscriptionOverview> subscriptionsToUpdate)
        {
            var ids = subscriptionsToUpdate.Select(x => x.Id).ToList();
            using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
            {
                ent.Database.Connection.ConnectionString = _prodTelesecConString;
                var toUpdate = ent.WPSubscriptions.Where(x => ids.Contains(x.Id)).ToList();
                toUpdate.ForEach(x =>
                {
                    x.CustomerIdWP = subscriptionsToUpdate.Single(y => y.Id == x.Id).CustomerIdWP;
                    x.LastModifiedBy = "CCMConnector";
                    x.LastModifiedOn = DateTime.UtcNow;
                });
                ent.SaveChanges();
            }
        }
    }
}
