﻿using System;
using CRM.Domain.Customer;
using EventFlow;
using EventFlow.Aggregates.ExecutionResults;
using WebPortal.CCMConnector.Application.Customers.Commands;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.Customers.CommandsWP
{
    public class DeleteOneCustomerCommand
    {
        private ICommandBus _commandBus;

        private static readonly NLog.Logger Logger = NLog.LogManager.GetCurrentClassLogger();

        public DeleteOneCustomerCommand(ICommandBus commandBus)
        {
            _commandBus = commandBus;
        }


        public IExecutionResult DeleteCustomer(string customerId)
        {
            try
            {
                var aggregateId = CustomerId.With(customerId);
                var command = new DeleteCustomerCommand(aggregateId);
                var result = _commandBus.PublishAsync(command,
                        new System.Threading.CancellationToken())
                    .ConfigureAwait(false)
                    .GetAwaiter()
                    .GetResult();
                return result;

            }
            catch (Exception e)
            {
                Logger.Error(e, $"Could not delete Customer with id: '{customerId}'");
                throw;
            }
        }

    }
}
