﻿using System;
using System.Threading;
using CRM.Domain.Customer;
using EventFlow;
using EventFlow.Aggregates.ExecutionResults;
using WebPortal.CCMConnector.Application.Customers.Commands;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.Customers.CommandsWP
{
    public class ModifyMaxUsersCommand
    {
        private ICommandBus _commandBus;

        private static readonly NLog.Logger Logger = NLog.LogManager.GetCurrentClassLogger();

        public ModifyMaxUsersCommand(ICommandBus commandBus)
        {
            _commandBus = commandBus;
        }

        public IExecutionResult ModifyMaxUsers(string customerId, int maxUsers)
        {
            try
            {
                var aggregateId = CustomerId.With(customerId);
                var command = new ModifiyCustomerWebPortalLicenseAmountCommand(aggregateId, maxUsers);
                var result = _commandBus.PublishAsync(command, new CancellationToken()).ConfigureAwait(false).GetAwaiter().GetResult();
                return result;
            }
            catch (Exception e)
            {
                Logger.Error(e, $"Couldn't modify max users (licenses-amount) for customer '{customerId}'");
                throw;
            }

        }

    }
}
