﻿using System;
using System.Collections.Generic;
using System.Threading;
using CRM.Domain.Customer;
using EventFlow;
using EventFlow.Aggregates.ExecutionResults;
using WebPortal.CCMConnector.Application.Customers.Commands;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.Customers.CommandsWP
{
    public class ModifySubscriptionCommand
    {
        private ICommandBus _commandBus;

        public ModifySubscriptionCommand(ICommandBus commandBus)
        {
            _commandBus = commandBus;
        }

        private static readonly NLog.Logger Logger = NLog.LogManager.GetCurrentClassLogger();

        public IExecutionResult ModifySubscriptions(string customerId,
            List<string> modules)
        {
            try
            {
                var aggregateId = CustomerId.With(customerId);

                var command = new ModifyCustomerSubscriptionsCommand(aggregateId, modules);
                var result = _commandBus.PublishAsync(command, new CancellationToken()).ConfigureAwait(false).GetAwaiter().GetResult();
                return result;
            }
            catch (Exception e)
            {
                Logger.Error(e, $"Couldn't modify subscriptions for customer '{customerId}'");
                throw;
            }
        }


    }
}
