﻿using System.Collections.Generic;
using System.Linq;
using WebPortal.CCMConnector.Data.ConnectorLogic.General;
using WebPortal.CCMConnector.Data.Models;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.Customers.QueriesCCM
{
    public class GetAllCustomersWithTreeviewQuery : ACCMCommandAndQuery
    {
        public List<MainFicheWithSubficheIds> GetAllCustsWithTreeview()
        {
            using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
            {
                ent.Database.Connection.ConnectionString = _prodTelesecConString;


                
                var temp2 = ent.Customer.Where(x => x.Treeview.Count > 0 && x.EnableYN && x.ReceivesInvoices == true)
                    .Select(x => new MainFicheWithSubficheIds()
                    {
                        CCMId = x.CustomerId,
                        CCMLevel = x.Mainfiche.HasValue ? "SUB": "MAIN",
                        ClientCCMId = x.Client.ClientId
                    }).ToList();
                return temp2;
            }
        }

        public List<int> GetAllCustomerIdsWithTreeview(out List<int> rawList)
        {
            using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
            {
                ent.Database.Connection.ConnectionString = _prodTelesecConString;

                var allCustIdsInTreeview = ent.Treeview.Select(x => x.CustomerId).Distinct().ToList();

                var rtn = ent.Customer.Where(x => x.EnableYN 
                                                  && x.ReceivesInvoices == true
                                                  && allCustIdsInTreeview.Contains(x.CustomerId)).Select(x => x.CustomerId).ToList();
                rawList = new List<int>();
                    rawList.AddRange(rtn);

                var rtn2 = ent.Customer.Where(x => x.EnableYN 
                                                   && x.ReceivesInvoices == true
                                                   && allCustIdsInTreeview.Contains(x.CustomerId)).Select(x => x.Mainfiche ?? 0).ToList();

                rtn.AddRange(rtn2);

                rtn = rtn.Where(x => x > 0).Distinct().ToList();

                return rtn;
            }
        }

        }
}
