﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WebPortal.CCMConnector.Data.ConnectorLogic.General;
using WebPortal.CCMConnector.Data.Models;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.Customers.QueriesCCM
{
    public class GetCCMNameModificationsQuery : ACCMCommandAndQuery
    {
        public List<CCMIdAndString> GetClientNamesForWPCustomers(List<int> clientIds)
        {
            using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
            {
                ent.Database.Connection.ConnectionString = _prodTelesecConString;
                var rtn = ent.Client.Where(x => clientIds.Contains(x.ClientId))
                    .Select(x => new CCMIdAndString
                    {
                        CCMId = x.ClientId,
                        Value = x.ClientName
                    }).ToList();
                return rtn;

            }
        }

        public List<CCMIdAndString> GetCustomerNamesForWPDossiers(List<int> customerIds)
        {
            using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
            {
                ent.Database.Connection.ConnectionString = _prodTelesecConString;
                var rtn = ent.Customer.Where(x => customerIds.Contains(x.CustomerId))
                    .Select(x => new CCMIdAndString
                    {
                        CCMId = x.CustomerId,
                        Value = x.Name
                    }).ToList();
                return rtn;

            }
        }
    }
}
