﻿using System.Collections.Generic;
using System.Linq;
using WebPortal.CCMConnector.Data.ConnectorLogic.General;
using WebPortal.CCMConnector.Data.Models;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.Customers.QueriesCCM
{
    public class GetMainFichesQuery : ACCMCommandAndQuery
    {
        public List<IGrouping<string, TempCustomer>> GetMainFiches()
        {
            using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
            {
                ent.Database.Connection.ConnectionString = _prodTelesecConString;

                var mainFiches = ent.Customer.Where(x =>
                        x.Mainfiche == null && x.EnableYN)
                    .Select(x =>
                        new TempCustomer()
                        {
                            CustomerId = x.CustomerId,
                            CustName = x.Name,
                            Company = x.Company_ProfileID ?? 0
                        })
                    .OrderBy(x => x.CustName)
                    .ToList();
                var groupByName = mainFiches
                    .Where(x => x.ShortName != null)
                    .GroupBy(x => x.ShortName);
                return groupByName.ToList();
            }
        }
    }
}
