﻿using System;
using System.Collections.Generic;
using System.Linq;
using WebPortal.CCMConnector.Data.ConnectorLogic.General;
using WebPortal.CCMConnector.Data.EDMX;
using WebPortal.CCMConnector.Data.Models;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.Customers.QueriesCCM
{
    public class GetModificationsInCCMForWPQuery : ACCMCommandAndQuery
    {
        private static readonly NLog.Logger Logger = NLog.LogManager.GetCurrentClassLogger();

        public List<WPModification> GetModificationsCCM()
        {
            try
            {
                using (ProdtelesecEntities ent = new ProdtelesecEntities())
                {
                    ent.Database.Connection.ConnectionString = _prodTelesecConString;
                    var allModifications = ent.WPModificationUpload
                        .Where(x => !x.IsUploadedInWP)
                        .Select(x => new WPModification
                        {
                            CCMId = x.CCMId,
                            CustomerId = x.WPSubscriptions.CustomerIdWP,
                            Id = x.Id,
                            CCMLevel = x.CCMLevel,
                            SubscriptionId = x.SubscriptionId,
                            ModificationPinPoint = x.ModificationPinPoint,
                            MaxUsers = x.WPSubscriptions.UserAmount,
                        })
                        .ToList();
                    return allModifications;
                }
            }
            catch (Exception e)
            {
                Logger.Error(e, "Couldn't get Modifications from CCM");
                throw;
            }
        }
        }
}
