﻿using System.Linq;
using WebPortal.CCMConnector.Data.ConnectorLogic.General;
using WebPortal.CCMConnector.Data.Models;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.Customers.QueriesCCM
{
    public class GetModifyBranchModelsQuery: ACCMCommandAndQuery
    {
        public static ModifyBranchModel GetBranchModels(int clientId)
        {
            using (var ent = new EDMX.ProdtelesecEntities())
            {
                ent.Database.Connection.ConnectionString = _prodTelesecConString;
                var rtn = ent.Client
                    .Where(x => x.ClientId == clientId
                                && x.Deleted == false
                                && x.BranchFiche != null
                    )
                    .Select(x => new ModifyBranchModel()
                    {
                        ClientIdCcm = x.ClientId,
                        CustomerIdCcm = x.BranchFiche.Value,
                        CustomerIdWp = x.WPSubscriptions.FirstOrDefault(y
                                => !y.Deleted
                                   && y.ClientIdCCM == x.ClientId)
                            .CustomerIdWP
                    }).FirstOrDefault();

                if (rtn == null) return rtn;


                var rtn2 = ent.Address
                    .Where(x => x.CustomerId == rtn.CustomerIdCcm)
                    .Select(x => new ModifyBranchModel()
                    {
                        ClientIdCcm = rtn.ClientIdCcm,
                        CustomerIdCcm = x.CustomerId,
                        CustomerIdWp = rtn.CustomerIdWp,
                        BoxNumber = x.Box.Trim(),
                        BranchName = x.Customer.Name.Trim(),
                        Country = x.Country.Trim(),
                        City = x.City.Trim(),
                        DefaultEmail = x.DefaultEmail.Trim(),
                        DefaultFax = x.DefaultFax.Trim(),
                        Email = x.Email.Trim(),
                        Street = x.Street.Trim(),
                        PostalCode = x.Zipcode.Trim(),
                        HouseNumber = x.Number.Trim(),
                        FaxNumber = x.Customer.FaxNumber.Trim(),
                        Fax = x.Fax.Trim(),
                        EmailAddress = x.Customer.EmailAddress.Trim(),
                        Phone1 = x.Phone1.Trim(),
                        Phone2 = x.Phone2.Trim(),
                        HomePage = x.HomePage.Trim()
                    })
                    .FirstOrDefault();
                return rtn2;

            }
        }
    }
}
