﻿using System.Collections.Generic;
using System.Threading;
using EventFlow.Queries;
using WebPortal.CCMConnector.Application.Customers.Models;
using WebPortal.CCMConnector.Application.Customers.Queries;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.Customers.QueriesWP
{
    public class GetCustomers
    {
        private readonly IQueryProcessor _queryProcessor;

        public GetCustomers(IQueryProcessor queryProcessor)
        {
            _queryProcessor = queryProcessor;
        }

        public List<GetCustomerWithDossiersModel> GetCustomersAndDossiers(List<string> ids)
        {
            return _queryProcessor.ProcessAsync(new GetCustomersWithDossiersQuery(ids), new CancellationToken())
                .ConfigureAwait(false)
                .GetAwaiter()
                .GetResult();
        }
    }
}
