﻿using System;
using System.Threading;
using CRM.Domain.Dossier;
using EventFlow;
using EventFlow.Aggregates.ExecutionResults;
using WebPortal.CCMConnector.Application.Dossiers.Commands;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.Dossiers.Commands
{
    public class CreateWpDossierCommand
    {

        private ICommandBus _commandBus;

        private static readonly NLog.Logger Logger = NLog.LogManager.GetCurrentClassLogger();

        public CreateWpDossierCommand(ICommandBus commandBus)
        {
            _commandBus = commandBus;
        }


        public IExecutionResult CreateDossier(string customerId,
            string dossierName,
            int ccmCustId, DossierId dossierId)
        {
            try
            {
                var command = new CreateDossierCommand(dossierId, dossierName, customerId, ccmCustId);
                var result = _commandBus.PublishAsync(command, new CancellationToken()).ConfigureAwait(false).GetAwaiter().GetResult();
                return result;
            }
            catch (Exception e)
            {
                Logger.Error(e, $"Couldn't create Dossier '{dossierName}' for customer '{customerId}' with CCM-Id: {ccmCustId}");
                throw;
            }

        }

    }
}
