﻿using System;
using System.Collections.Generic;
using System.Linq;
using WebPortal.CCMConnector.Application.Dossiers.Models;
using WebPortal.CCMConnector.Data.ConnectorLogic.General;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.Dossiers.QueriesCCM
{
    public class CheckForDossiersQuery:ACCMCommandAndQuery
    {
        private static readonly NLog.Logger Logger = NLog.LogManager.GetCurrentClassLogger();

        public static void CheckDossierIdsInCcmFiches(List<GetFaultyDossierModel> faultyDossierModels)
        {
            try
            {
                var dossierList = faultyDossierModels.Select(x => x.Id).ToList();
                using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
                {
                    ent.Database.Connection.ConnectionString = _prodTelesecConString;
                    var ccmAndDossierIds = ent.Customer.Where(x => dossierList.Contains(x.DossierIdWP)
                                                                   && x.Mainfiche == null)
                        .Select(x => new
                        {
                            x.DossierIdWP,
                            x.CustomerId
                        }).ToDictionary(k => k.DossierIdWP, v => v.CustomerId);
                    foreach (var fdm in faultyDossierModels)
                    {
                        var result = ccmAndDossierIds.FirstOrDefault(x => x.Key == fdm.Id);
                        if (result.Value == 0) continue;

                        fdm.DossierIsRegisteredInCCM = true;
                    }
                }

            }
            catch (Exception e)
            {
                Logger.Error(e, "Couldn't check dossiers faulty DossierModels");
                throw;
            }
        }
    }
}
