﻿using System;
using System.Collections.Generic;
using System.Threading;
using EventFlow.Queries;
using WebPortal.Application.Dossiers.Queries;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.Dossiers.QueriesWP
{
    public class CheckIfDossierExistsQuery
    {
        private readonly IQueryProcessor _queryProcessor;

        public CheckIfDossierExistsQuery(IQueryProcessor queryProcessor)
        {
            _queryProcessor = queryProcessor;
        }

        private static readonly NLog.Logger Logger = NLog.LogManager.GetCurrentClassLogger();

        public Dictionary<string, int> CheckIfDossierExists(List<int> ccmIds)
        {
            try
            {
                return _queryProcessor
                    .ProcessAsync(new GetDossierIdsByCCMIdsQuery(ccmIds), new CancellationToken()).GetAwaiter().GetResult();
            }
            catch (Exception e)
            {
                string idString = "";
                ccmIds.ForEach(x => idString += x + "; ");
                Logger.Error(e, $"Couldn't check dossiers for these ccmIds: {idString}");
                throw;
            }
        }

    }
}
