﻿using System;
using System.Collections.Generic;
using System.Linq;
using AutoMapper;
using WebPortal.CCMConnector.Application.Customers.Models;
using WebPortal.CCMConnector.Data.ConnectorLogic.General;
using WebPortal.CCMConnector.Data.EDMX;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.Duties.QueriesCCM
{
    public class GetDutyAlarmsQuery : ACCMCommandAndQuery
    {
        public static List<DutyAlarmModel> GetDutyAlarms(IMapper mapper, DateTime previousRun)
        {
            using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
            {
                ent.Database.Connection.ConnectionString = _prodTelesecConString;
                var rtn = ent.DutyAlarm.Where(x => !x.Deleted)
                    .ToList();
                var rtn2 = mapper.Map<List<DutyAlarm>, List<DutyAlarmModel>>(rtn)
                    .Where(x => x.MustRun2(previousRun))
                    .ToList();
                return rtn2;

            }
        }
    }
}
