﻿using System.Collections.Generic;
using System.Threading;
using CRM.Domain.Employee;
using EventFlow;
using EventFlow.Aggregates.ExecutionResults;
using WebPortal.CCMConnector.Application.Employees.Commands;
using WebPortal.CCMConnector.Data.Models;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.Employees.CommandsWP
{
    public class CreateEmployeesCommand
    {
        private readonly ICommandBus _commandBus;

        public CreateEmployeesCommand(ICommandBus commandBus)
        {
            _commandBus = commandBus;
        }

        public void CreateEmployees(List<TempEmployeeItem> tempEmployees)
        {
            foreach (var tE in tempEmployees)
            {
                CreateEmployee(tE);
            }
        }

        private IExecutionResult CreateEmployee(TempEmployeeItem tempEmployee)
        {
            var command = new CreateEmployeeCommand(EmployeeId.New, tempEmployee.Firstname, tempEmployee.LastName, tempEmployee.CC, tempEmployee.Comments, tempEmployee.SendMail ?? false, tempEmployee.MainAndSubficheIdAndCustomerId.CustomerId, tempEmployee.SetMessageToRead ?? false, tempEmployee.ContactDetails, tempEmployee.TagList);
            var result = _commandBus.PublishAsync(command, new CancellationToken()).ConfigureAwait(false).GetAwaiter().GetResult();
            return result;
        }
    }
}
