﻿using System;
using System.Linq;
using WebPortal.CCMConnector.Data.EDMX;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.General.CommandsCCM
{
    public class AddCurrentRunCommand : ACCMCommandAndQuery
    {
        internal static DateTime AddCurrentRun()
        {
            using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
            {
                ent.Database.Connection.ConnectionString = _prodTelesecConString;
                var rtn = DateTime.UtcNow;
                EDMX.WPConnectorUploadTimes currentRun = new WPConnectorUploadTimes
                {
                    UploadDateTime = rtn
                };
                ent.WPConnectorUploadTimes.Add(currentRun);
                ent.SaveChanges();
                return rtn;
            }
        }

        internal static void AddRemarksToCurrentRun(string comment)
        {
            using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
            {
                ent.Database.Connection.ConnectionString = _prodTelesecConString;
                var toModify = ent.WPConnectorUploadTimes
                    .OrderByDescending(x => x.Id)
                    .FirstOrDefault();
                toModify.Remarks = comment;
                ent.SaveChanges();
            }
        }
    }
}
