﻿using System;
using System.Collections.Generic;
using System.Linq;
using AutoMapper;
using WebPortal.CCMConnector.Data.Models;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.General.QueriesCCM
{
    public class GetAllKeysQuery : ACCMCommandAndQuery
    {
        private static readonly NLog.Logger Logger = NLog.LogManager.GetCurrentClassLogger();

        public static List<WPSubscriptionOverview> GetAllTheKeysForGettingTheData(IMapper mapper, DateTime today)
        {
            try
            {
                using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
                {
                    ent.Database.Connection.ConnectionString = _prodTelesecConString;
                    var rtn = ent.WPSubscriptions
                        .Where(x => x.StartDate <= today 
                                    && (x.EndDate == null || x.EndDate > today)
                                    && !x.Deleted)
                        .ToList();

                    return mapper.Map<List<EDMX.WPSubscriptions>, List<WPSubscriptionOverview>>(rtn);
                }

            }
            catch (Exception e)
            {
                Logger.Error(e,"Couldn't get subscriptions!");
                throw;
            }
        }

        public static WPSubscriptionOverview GetOneSubscription(IMapper mapper, Guid subscriptionId)
        {
            try
            {
                using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
                {
                    ent.Database.Connection.ConnectionString = _prodTelesecConString;
                    var rtn = ent.WPSubscriptions
                        .Single(x => x.Id == subscriptionId);
                    return mapper.Map<EDMX.WPSubscriptions, WPSubscriptionOverview>(rtn);
                }
            }
            catch (Exception e)
            {
                Logger.Error(e, $"Couldn't get subscription '{subscriptionId}'.");
                throw;
            }
        }
    }
}