﻿using System;
using System.Linq;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.General.QueriesCCM
{
    public class GetPreviousRunQuery: ACCMCommandAndQuery
    {
        internal static DateTime GetPreviousRun()
        {
            using (EDMX.ProdtelesecEntities ent = new EDMX.ProdtelesecEntities())
            {
                ent.Database.Connection.ConnectionString = _prodTelesecConString;
                var rtn = ent.WPConnectorUploadTimes
                    .Where(x => x.Remarks != null)
                    .OrderByDescending(x => x.Id)
                    .FirstOrDefault();
                if (rtn == null) return DateTime.UtcNow.AddDays(-7);

                return rtn.UploadDateTime;
            }
        }
    }
}
