﻿using System.Collections.Generic;
using System.Threading.Tasks;
using CRM.Domain.Shared.Enums;
using EventFlow.Queries;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.General.QueriesWP
{
    public abstract class AGetIdsForMultipleTypes
    {
        protected readonly IQueryProcessor _queryProcessor;
        protected readonly NLog.Logger Logger = NLog.LogManager.GetCurrentClassLogger();
        protected Dictionary<AggregateNameEnum, List<string>> _replaceDictionary;

        protected AGetIdsForMultipleTypes(IQueryProcessor queryProcessor)
        {
            _queryProcessor = queryProcessor;
        }

        internal virtual async Task<Dictionary<AggregateNameEnum, List<string>>> GetIdsBySharedId(string sharedId)
        {
            _replaceDictionary = new Dictionary<AggregateNameEnum, List<string>>();

            return _replaceDictionary;
        }

        protected void AddToDictionary(AggregateNameEnum theType,
            List<string> ids)
        {
            if (ids.Count == 0) return;

            _replaceDictionary.Add(theType, ids);
        }

    }
}
