﻿using System;
using System.Collections.Generic;
using System.Threading;
using EventFlow.Queries;
using WebPortal.CCMConnector.Application.InteractionStats.Queries;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.InteractionStats.QueriesWP
{
    public class GetStatsByMessageIdCcmQuery
    {
        private readonly IQueryProcessor _queryProcessor;
        private static readonly NLog.Logger Logger = NLog.LogManager.GetCurrentClassLogger();

        public GetStatsByMessageIdCcmQuery(IQueryProcessor queryProcessor)
        {
            _queryProcessor = queryProcessor;
        }

        public Dictionary<string, int> GetStatsByMessageIdCcm(List<int> ccmMessageIds)
        {
            try
            {
                return _queryProcessor.ProcessAsync(new GetStatisticsWithMessageIdCcmQuery(ccmMessageIds),
                        new CancellationToken(false))
                    .GetAwaiter().GetResult();
            }
            catch (Exception e)
            {
                string allCcmMessageIds = "";
                ccmMessageIds.ForEach(x => allCcmMessageIds += $"{x}, ");
                Logger.Error(e, $"Failed to get statistics for at least one of these MessageIds from CCM: '{allCcmMessageIds}' ");
                throw;
            }
        }
    }
}
