﻿using System;
using System.Collections.Generic;
using System.Linq;
using AutoMapper;
using WebPortal.CCMConnector.Data.ConnectorLogic.General;
using WebPortal.CCMConnector.Data.EDMX;

namespace WebPortal.CCMConnector.Data.ConnectorLogic.Tickets.CommandsCCM
{
    public class UploadCcmTicketsCommand:ACCMCommandAndQuery
    {
        private static readonly NLog.Logger Logger = NLog.LogManager.GetCurrentClassLogger();

        public static void UploadTicketsInCcm(List<Message> messages, IMapper mapper)
        {
            try
            {
                using (var ent = new EDMX.ProdtelesecEntities())
                {
                    ent.Database.Connection.ConnectionString = _prodTelesecConString;
                    ent.Message.AddRange(messages);
                    ent.SaveChanges();
                    ent.Histo_msg.AddRange(mapper.Map<List<Message>, List<Histo_msg>>(messages));
                    ent.SaveChanges();
                }
            }
            catch (Exception e)
            {
                var uniqueCustomerIds = messages.Select(x => x.CustomerId).Distinct().ToList();
                string customerIdString = "";
                uniqueCustomerIds.ForEach(x => customerIdString += $"{x}, ");
                Logger.Error(e, $"Could not save duty-alarm quotations for the following customers: {customerIdString}");
                throw;
            }
        }
    }
}
