﻿using System;
using EventFlow.Queries;
using System.Collections.Generic;
using System.Threading;
using WebPortal.CCMConnector.Application.Tickets.Models;
using WebPortal.CCMConnector.Application.Tickets.Queries;


namespace WebPortal.CCMConnector.Data.ConnectorLogic.Tickets.QueriesWP
{
    public class GetExistingTicketIdsQuery
    {
        private readonly IQueryProcessor _queryProcessor;
        private static readonly NLog.Logger Logger = NLog.LogManager.GetCurrentClassLogger();

        public GetExistingTicketIdsQuery(IQueryProcessor queryProcessor)
        {
            _queryProcessor = queryProcessor;
        }

        public List<GetWPAndCCMTicketIdModel> GetUploadedTickets(List<int> ccmMessageIds)
        {
            try
            {
                return _queryProcessor.Process(new GetTicketIdsByCCMMessageIdsQuery(ccmMessageIds), new CancellationToken());
            }
            catch (Exception e)
            {
                Logger.Error(e, "Couldn't get already uploaded tickets from WebPortal.");
                throw;
            }
        }

    }
}
