﻿using System;
using RingRing.BusinessLogic;
using RingRing.DataObject;

namespace WebPortal.CCMConnector.Data.IO
{
    public class SmsLogic
    {
        private readonly string _accessKey;
        private readonly NLog.Logger Logger = NLog.LogManager.GetCurrentClassLogger();

        public SmsLogic()
        {
            _accessKey = "47E70F40-37A0-4642-A9B2-F44DEE7DE93E";
        }

        /// <summary>
        /// receivers met '+' en gescheiden door komma
        /// </summary>
        /// <param name="receivers"></param>
        /// <param name="smsText"></param>
        public bool SendSms(string receivers, string smsText)
        {
            try
            {
                MessageRequest r = new MessageRequest();
                r.Message = smsText;
                r.ApiKey = _accessKey;
                r.To = receivers;

                MessageApi m = new MessageApi();
                var response = m.SendMessage(r);

                if (response.ResultCode == 0)
                {
                    Logger.Info($"Successfully send sms to: {receivers}");
                    return true;
                }
                Logger.Error($"Error sending sms to: {receivers}. {response.ResultDescription}");
                return false;
            }
            catch (Exception e)
            {
                Logger.Error(e, $"Error sending sms to: {receivers}");
            }

            return false;
        }
    }
}
