﻿using System;
using System.Collections.Generic;
using System.Linq;
using WebPortal.CCMConnector.Data.Logic.Commands;
using WebPortal.CCMConnector.Data.Logic.Queries;
using WebPortal.CCMConnector.Data.Mapper;
using WebPortal.CCMConnector.Data.Models;

namespace WebPortal.CCMConnector.Data.Logic
{
    public abstract class MainLogic
    {
        protected bool _isActiphone;
        protected string _wpConString;
        protected QueryFromCCM _queryFromCCM;
        protected QueryFromWebPortal _queryFromWebPortal;
        protected CommandsToWebPortal _commandsToWP;
        protected CommandsToCCM _commandsToCCM;
        protected MapperCCMConnector _mapper;
        protected DateTime _thisTime;
        protected DateTime _previousTime;

        public MainLogic(bool isActiphone, DateTime thisTime)
        {
            _queryFromCCM = new QueryFromCCM();
            _queryFromWebPortal = new QueryFromWebPortal(isActiphone);
            _commandsToWP = new CommandsToWebPortal(isActiphone);
            _commandsToCCM = new CommandsToCCM();
            _mapper = new Mapper.MapperCCMConnector();
            _thisTime = thisTime;
            _previousTime = _thisTime.AddSeconds(-60);
        }

    }
}
