﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WebPortal.CCMConnector.Data.Models;

namespace WebPortal.CCMConnector.Data.Logic.Queries
{
    public class QueryFromI3IC
    {
        private const string _i3icConString = @"data source=aac-sql01.cisicc.local;initial catalog=I3_IC;user id=sa;Password=T@v3rn1er2015*;MultipleActiveResultSets=True;App=EntityFramework";


        public void GetInteractionStats(List<TempDNIS> customerIds, DateTime start, DateTime end)
        {
            List<string> allDNIS = customerIds.Select(x => x.DNiSString).ToList();
            DateTime? nullDT = null;
            using (EDMX.I3_ICEntities1 ent = new EDMX.I3_ICEntities1())
            {
                ent.Database.Connection.ConnectionString = _i3icConString;
                //var rtn = ent.InteractionSummary.Join(ent.InteractionCustomAttributes, su => su.InteractionIDKey, at => at.InteractionIDKey, (su, at) => new { su, at })
                //    .Where(z => customerIds.Select(x => x.DNiSString).Contains(z.at.CustomString1)
                //    && z.su.InitiatedDateTimeUTC >= start
                //    && z.su.InitiatedDateTimeUTC < end)
                //    .Select(x => new TempInteractionStatItem()
                //    {
                //        DossierId = customerIds.First(y => y.DNIS == Convert.ToInt32(x.at.CustomString1)).CustomerIdCCM,
                //        Connected = x.su.ConnectedDateTimeUTC,
                //        Disconnected = x.su.TerminatedDateTimeUTC,
                //        DNIS = Convert.ToInt32(x.at.CustomString1),
                //    }).ToList();

                var rtn = ent.InteractionSummary.Join(ent.InteractionCustomAttributes, su => su.InteractionIDKey, at => at.InteractionIDKey, (su, at) => new { su, at })
                    .Where(z => allDNIS.Contains(z.at.CustomString1)
                    && z.su.InitiatedDateTimeUTC >= start
                    && z.su.InitiatedDateTimeUTC < end)
                    .Select(x => new TempInteractionStatItem()
                    {
                        ConnectedDateTimeUTC = x.su.ConnectedDateTimeUTC,
                        DNIS = x.at.CustomString1,
                        InteractionIDKey = x.su.InteractionIDKey,
                        InteractionId = x.su.InteractionID,
                        tAlert = x.su.tAlert ?? 0,
                        tConnected = x.su.tConnected ?? 0,
                        tHeld = x.su.tHeld ?? 0,
                        tIVRWait = x.su.tIVRWait ?? 0,
                        tPark = x.su.tPark ?? 0,
                        tQueueWait = x.su.tQueueWait ?? 0,
                        TerminatedDateTimeUTC = x.su.TerminatedDateTimeUTC,

                    }).ToList();

                rtn.ForEach(x => x.CustomerId = customerIds.First(y => y.DNiSString == x.DNIS).CustomerIdCCM);
                rtn.ForEach(x => x.ExtraSeconds = customerIds.First(y => y.DNiSString == x.DNIS).ExtraSeconds);
                rtn.ForEach(x => x.AnouncementSeconds = customerIds.First(y => y.DNiSString == x.DNIS).AnouncementSeconds);


                var res = JsonConvert.SerializeObject(rtn);
                return;
            }
        }
    }
}
