﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using CRM.Domain.Shared.Enums;
using WebPortal.CCMConnector.Data.Logic.Chapters;
using WebPortal.CCMConnector.Data.Logic.Commands;
using WebPortal.CCMConnector.Data.Logic.Queries;
using WebPortal.CCMConnector.Data.Mapper;
using WebPortal.CCMConnector.Data.Models;

namespace WebPortal.CCMConnector.Data.Logic
{
    public class SubscriptionLogic : MainLogic
    {
        private CompanyLogic _companyLogic;
        private TreeviewLogic _treeviewLogic;
        private InteractionStatsLogic _interactionStatsLogic;

        public SubscriptionLogic(bool isActiphone, DateTime thisTime) : base(isActiphone, thisTime)
        {
            _companyLogic = new CompanyLogic(_isActiphone, _thisTime);
            _treeviewLogic = new TreeviewLogic(_isActiphone, _thisTime);
            _interactionStatsLogic = new InteractionStatsLogic(_isActiphone, _thisTime);
        }

        public void SynchronizeCCMWithWebPortal()
        {
            var wpSubscriptions = _queryFromCCM.GetSubscriptionOverviewFromCCM(_isActiphone);

            _companyLogic.MakeNewTreeviewSubscriptions(wpSubscriptions);

            _companyLogic.MakeNewCompaniesForSubscriptionsMadeInCCM(wpSubscriptions);

            //GetCCMDataForEveryRequiredModule();

            //todo: (als laatste opdracht) Ga alle verlopen subscriptions af. Alle gebruikers voor deze sub moeten gedeactiveerd worden.
        }

        //public void GetCCMDataForEveryRequiredModule()
        //{
        //    var allKeys = _queryFromCCM.GetAllTheKeysForGettingTheData(_isActiphone);

        //    var custsWithTreeview = allKeys.Where(x => x.Module == Shared.Enums.ModuleName.AutoTreeview
        //        || x.Module == Shared.Enums.ModuleName.Treeview).ToList();

        //    var custsWithTreeviewUniqueIds = custsWithTreeview
        //        .GroupBy(x => x.CustomerIdCCM)
        //        .Select(x => x.First().CustomerIdCCM).ToList();

        //    var subCustsWithTreeview = allKeys.Where(x => (x.Module == Shared.Enums.ModuleName.AutoTreeview || x.Module == Shared.Enums.ModuleName.Treeview) && x.SubficheId.HasValue)
        //        .GroupBy(x => x.SubficheId)
        //        .Select(x => x.First().SubficheId.Value).ToList();
        //    custsWithTreeviewUniqueIds.AddRange(subCustsWithTreeview);

        //    var custIdsToPass = custsWithTreeviewUniqueIds.GroupBy(x => x).Select(x => x.Key).ToList();

        //    _treeviewLogic.GetAndPostDepartments(custIdsToPass);
        //    _treeviewLogic.GetAndPostNewEmployees(custsWithTreeview, custIdsToPass);

        //    var subscriptionsWithStatistics = allKeys.Where(x => x.Module == Shared.Enums.ModuleName.Statistics && x.SubficheId == null).ToList();

        //    _interactionStatsLogic.GetAndPostStatistics(subscriptionsWithStatistics);
            
        //}

        //ga na of de CompanyGuids daadwerkelijk in de WebPortal zitten.
        //Indien niet: wegschrijven in Eventlog.
        //public void MatchCompanyGuidsWPAndCCM()
        //{
        //    var wpSub = _queryFromCCM.GetSubscriptionOverviewFromCCM(_isActiphone);
        //    var companyGuids = _queryFromWebPortal.GetCompanyGuidsWP();
        //    foreach (var cg in companyGuids)
        //    {
        //        var subToFind = wpSub.SingleOrDefault(x => x.CompanyIdWP == cg.CompanyId && x.CustomerIdCCM == cg.CCMCustId);
        //        if (subToFind == null)
        //        {
        //            //De subscription wordt niet gevonden in 
        //        }
        //    }

        //}
    }
}