﻿using System;
using CRM.Domain.Shared.Enums;

namespace WebPortal.CCMConnector.Data.Models
{
    public abstract class AuditFields
    {
        public string CreatedBy { get; set; }
        public string LastModifiedBy { get; set; }
        public DateTime CreatedOn { get; set; }
        public DateTime LastModifiedOn { get; set; }

        public AuditFields()
        {
            CreatedOn = DateTime.UtcNow;
            LastModifiedOn = DateTime.UtcNow;
            CreatedBy = "CCMConnector";
            LastModifiedBy = "CCMConnector";
        }
    }

    public class NewWPCompany : AuditFields
    {
        public string Id { get; set; }
        public string CompanyName { get; set; }
        public int CustomerId { get; set; }
        public bool IsActiphoneCust { get; set; }
    }

    public class NewWPCompanyBranch : AuditFields
    {
        public string Id { get; set; }
        public string CompanyBranchName { get; set; }
        public int? SubFicheId { get; set; }
        public string CompanyId { get; set; }
        public NewAddress Address { get; set; }
        public Guid AddressId { get; set; }
        public bool IsHQ { get; set; }
        public Guid TempId { get; set; }
    }

    public class NewAddress : AuditFields
    {
        public Guid Id { get; set; }
        public string Street { get; set; }
        public string City { get; set; }
        public string PostalCode { get; set; }
        public string Country { get; set; }
        public string HouseNumber { get; set; }
        public string BoxNumber { get; set; }
    }

    public class WPContactDetail : AuditFields
    {
        public string Id { get; set; }
        public string ContactDetailName { get; set; }
        public string ContactDetailValue { get; set; }
        public bool IsPrivate { get; set; }
        public ContactDetailType ContactType { get; set; }

        public string CompanyBranchId { get; set; }
        public string EmployeeId { get; set; }
        public Guid TempId { get; set; }

        public WPContactDetail()
        {
        }

        //Voor Employee Contact Details
        public WPContactDetail(string contactDetailName, string contactDetailValue, bool isPrivate, string employeeId, ContactDetailType contactType)
        {
            Id = "";
            ContactDetailName = contactDetailName;
            ContactDetailValue = contactDetailValue;
            IsPrivate = isPrivate;
            EmployeeId = employeeId;
            ContactType = contactType;
        }
    }
}