﻿using System;

namespace WebPortal.CCMConnector.Data.Models
{
    public class TempInteractionStatItem
    {
        public IdsWithININVars DossierCustomerCCMAndDNISList { get; set; }
        public string InteractionIDKey { get; set; }
        public long InteractionId { get; set; }
        public string InteractionIdString => InteractionId.ToString();
        public string DNIS { get; set; }

        public int? OriginalCcmMessageId { get; set; }
        public string TicketId { get; set; }

        public decimal tConnected { get; set; }
        public decimal tHeld { get; set; }
        public decimal tPark { get; set; }
        public decimal tQueueWait { get; set; }

        public int tIVRWait { get; set; }
        public int tAlert { get; set; }

        private DateTime _connectedDateTimeUTC;
        public DateTime ConnectedDateTimeUTC
        {
            get => _connectedDateTimeUTC;
            set
            {
                var d = value.Ticks;
                _connectedDateTimeUTC = new DateTime(d, DateTimeKind.Utc);
            }
        }
        private DateTime _terminatedDateTimeUTC;
        public DateTime TerminatedDateTimeUTC
        {
            get => _terminatedDateTimeUTC;
            set
            {
                var d = value.Ticks;
                _terminatedDateTimeUTC = new DateTime(d, DateTimeKind.Utc);
            }
        }


        //public int AnouncementSeconds { get; set; }
        //public int ExtraSeconds { get; set; }

        public TimeSpan Duration =>
            tConnected > 0 ?

                new TimeSpan(0, 0, 0, 0, Convert.ToInt32(tConnected + tHeld + tPark) + (DossierCustomerCCMAndDNISList.ExtraSeconds * 1000))
                : new TimeSpan();

        public DateTime Delivered => ConnectedDateTimeUTC.AddSeconds(DossierCustomerCCMAndDNISList.AnouncementSeconds);

        public DateTime? Established
        {
            get
            {
                DateTime? nullDT = null;
                return tConnected > 0
                    ? Delivered.AddMilliseconds(Convert.ToInt32(tIVRWait + tQueueWait + tAlert))
                        .AddSeconds(DossierCustomerCCMAndDNISList.ExtraSeconds)
                    : nullDT;
            }
        }

        public DateTime ClearedDate =>
            tConnected > 0
                ? TerminatedDateTimeUTC.AddSeconds(DossierCustomerCCMAndDNISList.ExtraSeconds)
                : TerminatedDateTimeUTC;
    }
}
