﻿using System;
using System.IO;
using System.Linq;

namespace WebPortal.CCMConnector.DocExporter
{
    public class TextExporter
    {

        public static bool OverWriteCSV(string[,] allTheLines,
            string path,
            string fileName)
        {
            if (DeleteFile(path, fileName)) return WriteCSV(allTheLines, path, fileName);

            return false;
        }

        public static bool DeleteFile(string path,
            string fileName)
        {
            try
            {
                if (!Directory.Exists(path)) return true;

                    string[] files = Directory.GetFiles(path);
                if (files.Length == 0) return true;

                var fileToDelete = files.FirstOrDefault(x => x == $"{path}{fileName}");
                if (fileToDelete == null) return false;

                FileInfo fi = new FileInfo(fileToDelete);
                fi.Delete();
                return true;
            }
            catch (Exception e)
            {
                Console.WriteLine(e);
            }

            return false;

        }

        public static bool WriteCSV(string[,] allTheLines, string path, string fileName)
        {
            try
            {
                if (!Directory.Exists(path))
                {
                    Directory.CreateDirectory(path);
                }

                using (StreamWriter streamWriter = new StreamWriter($"{path}{fileName}"))
                {
                    for (int i = 0; i < allTheLines.GetLength(1); i++)
                    {
                        string oneLine = "";
                        for (int j = 0; j < allTheLines.GetLength(0); j++)
                        {
                            oneLine += $"{allTheLines[j,i]}," ;
                        }

                        streamWriter.WriteLine(oneLine);
                    }
                }

                return true;
            }
            catch (Exception e)
            {
                Console.WriteLine(e);
            }

            return false;
        }


    }
}
