﻿using System;
using System.Net.Mail;
using System.Threading.Tasks;

namespace WebPortal.CCMConnector.MailSmtp
{
    public class Mailer
    {
        public static async Task SendMail(string tenant, string subject, string htmlBody, string textBody, string receivers)
        {
            var from = tenant == "AAC" ? "contactcenter@aac.be" : "info@actiphone.be";
            string bcc = tenant == "AAC" ? "wacht@aac.be" : "wacht@actiphone.be";
            AlternateView htlmView = AlternateView.CreateAlternateViewFromString(htmlBody, null, "text/html");

            SmtpClient smtpClient = new SmtpClient("mail.aac.be", 25);
            var mail = new MailMessage
            {
                From = new MailAddress(from),
                IsBodyHtml = true,
                Body = textBody,
            };

            var receiversWithKomma = receivers.Replace(';', ',')
                .Substring(0, receivers.Length - 1);
            mail.To.Add(receiversWithKomma);
            mail.Bcc.Add(bcc);
            mail.Subject = subject;
            mail.AlternateViews.Add(htlmView);
            await smtpClient.SendMailAsync(mail);

        }

        public static async Task SendNotRunMail(DateTime previousRun)
        {
            var from = "webportalalert@aac.be";
            var notRunTime = DateTime.UtcNow - previousRun;
            var body =
                $"Last time Connector ran successfully was on {previousRun.ToLocalTime().ToShortDateString()} {previousRun.ToString("HH:mm:ss")}"
                + "\n\n"
                + $"The connector has not run properly for {notRunTime.TotalHours} hours or {notRunTime.TotalMinutes} minutes."
                + "\n\n"
                + @"Check server AAC-IIS01 --> '\\aac-iis01\e$\ConnectorCCM\Logs\Errors' for the details";

            var receivers = "roeland.vanonckelen@triple-a-it.be, philippe.frooninckx@triple-a-it.be";

            var subject = "WEBPORTAL CONNECTOR ERROR!";

            SmtpClient smtpClient = new SmtpClient("mail.aac.be", 25);
            var mail = new MailMessage
            {
                From = new MailAddress(from),
                IsBodyHtml = false,
                Body = body,
            };


            mail.To.Add(receivers);
            mail.Subject = subject;
            await smtpClient.SendMailAsync(mail);
        }

    }
}
