﻿using System;
using System.Diagnostics;
using System.ServiceProcess;
using System.Timers;
using WebPortal.CCMConnector.Data.ConnectorLogic;

namespace WebPortal.CCMConnector.Service
{
    public partial class ConnectorCCM : ServiceBase
    {
        private double _timerInterval;
        public ConnectorCCM()
        {
            InitializeComponent();
            _timerInterval = 60000;
        }

        protected override void OnStart(string[] args)
        {
            Timer timer = new Timer();
            timer.Interval = _timerInterval;
            timer.Start();
            timer.Elapsed += Timer_Elapsed;
            EventLog.WriteEntry("Started CCMConnector To WebPortal!", EventLogEntryType.Information);
        }

        private void Timer_Elapsed(object sender, ElapsedEventArgs e)
        {
            //var conString = "mongodb://localhost";
            //var conString = "mongodb://aac-dev01.cisicc.local";
            //var dbName = "WPMongoTest";
            var conString = "mongodb://connector:connector123456789@192.168.121.11";
            //var dbName = "wp_dev";
            //var dbName = "wp_staging";
            var dbName = "wp_prod";

            try
            {
                using (ConnectorLogic connectorLogic = new ConnectorLogic(conString, dbName))
                {
                    connectorLogic.RepeatedUpload();
                }
            }
            catch (Exception ex)
            {
                EventLog.WriteEntry(ex.Message + "\r\n" + ex.StackTrace, EventLogEntryType.Error);
            }

        }

        protected override void OnStop()
        {
        }


        //public void startDezeShit()
        //{
        //    using (ConnectorLogic connectorLogic = new ConnectorLogic())
        //    {
        //        connectorLogic.RepeatedUpload();
        //    }

        //    Timer timer = new Timer();
        //    timer.Interval = _timerInterval;
        //    timer.Start();
        //    timer.Elapsed += Timer_Elapsed;
        //    EventLog.WriteEntry("Started CCMConnector To WebPortal!", EventLogEntryType.Information);
        //}

    }
}
