﻿using System.Collections.Generic;
using CRM.Domain.Shared.Enums;
using WebPortal.CCMConnector.Data.Models;
using WebPortal.CCMConnector.Data.TestGenerators;
using Xunit;

namespace WebPortal.CCMConnector.XUnitTest
{
    public class GenerateSubscriptions
    {
        [Fact]
        public void GenerateThisShit()
        {
            SubscriptionGenerator generator = new SubscriptionGenerator();
            var theList = MakeMeADictionaryOfSubs("nothing");
            foreach (var l in theList)
            {
                generator.GenerateNewSubscription(l.ClientId, 0, l.ModuleList);
            }
        }

        public List<ModuleToUploadList> MakeMeADictionaryOfSubs(string collection)
        {
            switch (collection)
            {
                case "a":
                    List<ModuleToUploadList> a = new List<ModuleToUploadList>();
                    a.Add(new ModuleToUploadList(299,
                        Add3Modules(8985, "MAIN")));
                    a.Add(AddClientModules(75));
                    a.Add(new ModuleToUploadList(367,
                        Add3Modules(5757, "MAIN")));
                    a.Add(AddClientModules(346));
                    a.Add(new ModuleToUploadList(23,
                        Add3Modules(9112, "MAIN")));
                    a.Add(AddClientModules(411));
                    a.Add(new ModuleToUploadList(115,
                        Add3Modules(5218, "MAIN")));
                    a.Add(new ModuleToUploadList(115,
                        Add3Modules(5232, "MAIN")));
                    a.Add(new ModuleToUploadList(485,
                        Add3Modules(999942, "SUB")));
                    a.Add(new ModuleToUploadList(485,
                        Add3Modules(999939, "SUB")));
                    return a;
                case "b":
                    List<ModuleToUploadList> b = new List<ModuleToUploadList>();
                    List<int> clientIds = new List<int>(){ 6,9,11,20,20,22,28,29,40,41,45,50,51,56,58,65,76,115,23,75,77,107,128,176,299,335,346,367,376,415,455,486
                    };
                    foreach (var cId in clientIds)
                    {
                       b.Add(new ModuleToUploadList(cId, Add5Modules(cId, "CLIENT"))); 
                    }
                    return b;

                case "covance": List<ModuleToUploadList> c = new List<ModuleToUploadList>();
                    List<int> clientIdsCovance = new List<int>()
                    {
                        621
                        ,622
                        ,623
                        ,624
                        ,625
                        ,626
                        ,627
                        ,628
                        ,629
                        ,630
                        ,631
                        ,632
                        ,633
                        ,634
                        ,635
                        ,636
                        ,637
                        ,638
                        ,639
                        ,640
                        ,641
                        ,642
                        ,643
                        ,644
                        ,645
                        ,646
                        ,647
                        ,648
                        ,649
                        ,650
                        ,651
                        ,652
                        ,653
                        ,654
                        ,655
                        ,656
                        ,657
                        ,658
                        ,659
                        ,660
                        ,661
                        ,662
                        ,663
                        ,664
                        ,665
                        ,666
                        ,667
                        ,668
                        ,669
                        ,670
                        ,671
                        ,672
                        ,673
                        ,674
                        ,675
                        ,676
                        ,677
                        ,678
                        ,679
                        ,680
                        ,681
                        ,682
                        ,683
                        ,684
                        ,685                    };
                    foreach (var cId in clientIdsCovance)
                    {
                        c.Add(new ModuleToUploadList(cId, Add2Modules(cId, "CLIENT")));
                    }
                    return c;

                case "covanceBU":
                    List<ModuleToUploadList> d = new List<ModuleToUploadList>();
                    List<int> clientIdsCovanceBU = new List<int>()
                    {
                        618
                        ,619
                        ,620
                        ,621
                        ,622
                        ,623
                        ,624
                        ,625
                        ,626
                        ,627
                        ,628
                        ,629
                        ,630
                        ,631
                        ,632
                        ,633
                        ,634
                        ,635
                        ,636
                        ,637
                        ,638
                        ,639
                        ,640
                        ,641
                        ,642
                        ,643
                        ,644
                        ,645
                        ,646
                        ,647
                        ,648
                        ,649
                        ,650
                        ,651
                        ,652
                        ,653
                        ,654
                        ,655
                        ,656
                        ,657
                        ,658
                        ,659
                        ,660
                        ,661
                        ,662
                        ,663
                        ,664
                        ,665
                        ,666
                        ,667
                        ,668
                        ,669
                        ,670
                        ,671
                        ,672
                        ,673
                        ,674
                        ,675
                        ,676
                        ,677
                        ,678
                        ,679
                        ,680
                        ,681
                        ,682                  };
                    foreach (var cId in clientIdsCovanceBU)
                    {
                        d.Add(new ModuleToUploadList(cId, Add2Modules(cId, "CLIENT")));
                    }
                    return d;


            }

            return null;
        }

        public ModuleToUploadList AddClientModules(int clientId)
        {
            ModuleToUploadList rtn 
                = new ModuleToUploadList(clientId, 
                    Add3Modules(clientId, "CLIENT"));
            return rtn;
        }

        public List<ModulesToUpload> Add3Modules(int ccmId, string ccmLevel)
        {
            var rtn = new List<ModulesToUpload>();
            for (int i = 0; i < 3; i++)
            {
                ModulesToUpload mtu = new ModulesToUpload()
                {
                    CCMId = ccmId,
                    CCMLevel = ccmLevel,
                    NameModule = i == 0 ? ModuleName.Script: i == 1 ? ModuleName.Statistics: ModuleName.Tickets,
                };
                rtn.Add(mtu);
            }

            return rtn;
        }

        public List<ModulesToUpload> Add2Modules(int ccmId,
            string ccmLevel)
        {
            var rtn = new List<ModulesToUpload>();
            rtn.Add(new ModulesToUpload(ccmId, ccmLevel, ModuleName.VirtualReception));
            rtn.Add(new ModulesToUpload(ccmId, ccmLevel, ModuleName.Duties));
            return rtn;
        }

        public List<ModulesToUpload> Add5Modules(int ccmId,
            string ccmLevel)
        {
            var rtn = new List<ModulesToUpload>();
            rtn.Add(new ModulesToUpload(ccmId, ccmLevel, ModuleName.Script));
            rtn.Add(new ModulesToUpload(ccmId, ccmLevel, ModuleName.Duties));
            rtn.Add(new ModulesToUpload(ccmId, ccmLevel, ModuleName.VirtualReception));
            rtn.Add(new ModulesToUpload(ccmId, ccmLevel, ModuleName.Tickets));
            rtn.Add(new ModulesToUpload(ccmId, ccmLevel, ModuleName.Statistics));
            return rtn;
        }

    }

    public class ModuleToUploadList
    {
        public int ClientId { get; set; }
        public List<ModulesToUpload> ModuleList { get; set; }


        public ModuleToUploadList(int clientId,
            List<ModulesToUpload> moduleList)
        {
            ClientId = clientId;
            ModuleList = moduleList;
        }

        public ModuleToUploadList()
        {
            
        }
    }

}
