﻿using System;
using System.Threading;
using CRM.Domain.Branch;
using CRM.Domain.Branch.ReadModels;
using CRM.Domain.CallScript;
using CRM.Domain.CallScript.ReadModels;
using CRM.Domain.Customer;
using CRM.Domain.Customer.ReadModels;
using CRM.Domain.Dossier;
using CRM.Domain.Dossier.ReadModels;
using CRM.Domain.Duty;
using Xunit;
using CRM.Domain.Duty.Enums;
using CRM.Domain.Duty.ReadModels;
using CRM.Domain.Employee;
using CRM.Domain.Employee.ReadModels;
using CRM.Domain.InteractionStatistic;
using CRM.Domain.InteractionStatistic.ReadModels;
using CRM.Domain.Ticket;
using CRM.Domain.Ticket.ReadModels;
using CRM.Domain.User;
using CRM.Domain.User.ReadModels;
using EventFlow;
using EventFlow.Configuration;
using EventFlow.Extensions;
using EventFlow.MongoDB.Extensions;
using EventFlow.Queries;
using WebPortal.Application.Branches.Commands;
using WebPortal.Application.Duties.Commands;
using WebPortal.Application.Duties.Queries;

namespace WebPortal.XUnitTest
{

    public class TestDuties
    {
        static string conString = "mongodb://connector:connector123456789@192.168.121.11";
        //string dbName = "wp_dev";
        static string dbName = "wp_dev";

        [Fact]
        public void TestDates()
        {
            DateTime startDate = new DateTime(2020, 4, 15);
            DateTime endDate = new DateTime(2020, 4, 15);

            DateTime startat = DateTime.UtcNow.Date.AddHours(0);
            DateTime endat = DateTime.UtcNow.Date.AddHours(0);

            var status = CheckStatus(startat, endat, startDate, endDate);
            Assert.Equal(DutyStatusEnum.Expired, status);


            startDate = new DateTime(2020, 4, 15);
            endDate = new DateTime(2020, 4, 15);
            startat = DateTime.UtcNow.Date.AddHours(22);
            endat = DateTime.UtcNow.Date.AddHours(22);

            status = CheckStatus(startat, endat, startDate, endDate);
            Assert.Equal(DutyStatusEnum.Expired, status);



            startDate = new DateTime(2020, 4, 16);
            endDate = new DateTime(2020, 4, 17);
            startat = DateTime.UtcNow.Date.AddHours(10);
            endat = DateTime.UtcNow.Date.AddHours(13);

            status = CheckStatus(startat, endat, startDate, endDate);

            Assert.Equal(DutyStatusEnum.Planned, status);


            startDate = new DateTime(2020, 4, 16);
            endDate = new DateTime(2020, 4, 17);
            startat = DateTime.UtcNow.Date.AddHours(10);
            endat = DateTime.UtcNow.Date.AddHours(21).AddMinutes(59);

            status = CheckStatus(startat, endat, startDate, endDate);

            Assert.Equal(DutyStatusEnum.Active, status);


            startDate = new DateTime(2020, 4, 17);
            endDate = new DateTime(2020, 4, 24);
            startat = DateTime.UtcNow.Date.AddHours(9);
            endat = DateTime.UtcNow.Date.AddHours(9).AddMinutes(5);

            status = CheckStatus(startat, endat, startDate, endDate);

            Assert.Equal(DutyStatusEnum.Upcoming, status);




            //startDate = new DateTime(2020, 4, 13);
            //startat = DateTime.UtcNow.Date.AddHours(19);
            //endat = DateTime.UtcNow.Date.AddHours(21);

            //status = CheckStatus(startat, endat, startDate, endDate);

            //Assert.Equal(status, DutyStatusEnum.Planned);

            //startat = DateTime.UtcNow.Date.AddHours(3);
            //endat = DateTime.UtcNow.Date.AddHours(9);
            //status = CheckStatus(startat, endat, startDate, endDate);

            //Assert.Equal(status, DutyStatusEnum.Planned);

            //endDate = new DateTime(2020, 4, 14);
            //status = CheckStatus(startat, endat, startDate, endDate);

            //Assert.Equal(status, DutyStatusEnum.Expired);

            //startat = DateTime.UtcNow.Date.AddHours(7);
            //endat = DateTime.UtcNow.Date.AddHours(23);
            //status = CheckStatus(startat, endat, startDate, endDate);

            //Assert.Equal(status, DutyStatusEnum.Expired);

            //startDate = DateTime.UtcNow.Date;
            //endDate = DateTime.UtcNow.Date;
            //startat = DateTime.UtcNow.Date.AddHours(19);
            //endat = DateTime.UtcNow.Date.AddHours(21);

            //status = CheckStatus(startat, endat, startDate, endDate);

            //Assert.Equal(status, DutyStatusEnum.Planned);

            //startDate = DateTime.UtcNow.Date;
            //endDate = DateTime.UtcNow.Date;
            //startat = DateTime.UtcNow.Date.AddHours(9);
            //endat = DateTime.UtcNow.Date.AddHours(20);

            //status = CheckStatus(startat, endat, startDate, endDate);
            //Assert.Equal(status, DutyStatusEnum.Active);

            //startDate = DateTime.UtcNow.Date;
            //endDate = DateTime.UtcNow.Date.AddDays(1);
            //startat = DateTime.UtcNow.Date.AddHours(8);
            //endat = DateTime.UtcNow.Date.AddHours(8);

            //status = CheckStatus(startat, endat, startDate, endDate);
            //Assert.Equal(status, DutyStatusEnum.Active);


            //startat = DateTime.UtcNow.Date.AddHours(8);
            //endat = DateTime.UtcNow.Date.AddHours(4);

            //status = CheckStatus(startat, endat, startDate, endDate);
            //Assert.Equal(status, DutyStatusEnum.Active);

            //startDate = DateTime.UtcNow.Date.AddDays(-7);
            //endDate = DateTime.UtcNow.Date;

            //status = CheckStatus(startat, endat, startDate, endDate);
            //Assert.Equal(status, DutyStatusEnum.Expired);


            //startDate = new DateTime(2020, 4,15);
            //endDate = new DateTime(2020, 4, 15);
            //startat = DateTime.UtcNow.Date;
            //endat = DateTime.UtcNow.Date;

            //status = CheckStatus(startat, endat, startDate, endDate);
            //Assert.Equal(status, DutyStatusEnum.Expired);

        }

        private DutyStatusEnum CheckStatus(DateTime StartAt, DateTime EndAt, DateTime StartDate, DateTime EndDate)
        {
            var startTime = new TimeSpan(StartAt.Hour, StartAt.Minute, 0);
            var endTime = new TimeSpan(EndAt.Hour, EndAt.Minute, 0);

            DateTime completeStartDate, completeEndDate;
            bool lastDay = false;
            if (startTime == endTime)
            {
                completeStartDate = StartDate.Date.Add(startTime);
                completeEndDate = EndDate.Date.Add(endTime);
                lastDay = true;
            }
            else
            {
                var isStartDateActive = (DateTime.UtcNow.Date - StartDate.Date).Days >= 0;
                var isEndDateActive = (EndDate.Date - DateTime.UtcNow.Date).Days >= 0;

                if (!isStartDateActive) return DutyStatusEnum.Upcoming;

                if (!isEndDateActive) return DutyStatusEnum.Expired;

                lastDay = (EndDate - DateTime.UtcNow.Date).Days == 0;

                if (lastDay && startTime > endTime) return DutyStatusEnum.Expired;


                completeStartDate = DateTime.UtcNow.Date.Add(startTime);
                completeEndDate = startTime < endTime
                    ? DateTime.UtcNow.Date.Add(endTime)
                    : DateTime.UtcNow.Date.AddDays(1).Add(endTime);

            }

            var isStartActive = (DateTime.UtcNow - completeStartDate).Ticks >= 0;

            var isEndActive = (completeEndDate - DateTime.UtcNow).Ticks >= 0;

            if (isStartActive)
            {
                if (isEndActive) return DutyStatusEnum.Active;

                return lastDay
                    ? DutyStatusEnum.Expired
                    : DutyStatusEnum.Planned;

            }

            return startTime == endTime
                ? DutyStatusEnum.Upcoming
                : DutyStatusEnum.Planned;


        }

        private static IRootResolver Setup()
        {
            return  EventFlowOptions.New
            .ConfigureMongoDb(conString, dbName)
                .AddDefaults(typeof(CustomerAggregate).Assembly)
                .AddDefaults(typeof(BranchAggregate).Assembly)
                .AddDefaults(typeof(CallScriptAggregate).Assembly)
                .AddDefaults(typeof(DossierAggregate).Assembly)
                .AddDefaults(typeof(EmployeeAggregate).Assembly)
                .AddDefaults(typeof(InteractionStatisticAggregate).Assembly)
                .AddDefaults(typeof(TicketAggregate).Assembly)
                .AddDefaults(typeof(DutyAggregate).Assembly)
                .AddDefaults(typeof(CreateBranchCommand).Assembly)
                .UseMongoDbEventStore()
                .UseMongoDbSnapshotStore()
                .UseMongoDbReadModel<CallScriptReadModel>()
                .UseMongoDbReadModel<CustomerReadModel>()
                .UseMongoDbReadModel<BranchReadModel>()
                .UseMongoDbReadModel<DossierReadModel>()
                .UseMongoDbReadModel<EmployeeReadModel>()
                .UseMongoDbReadModel<InteractionStatisticReadModel>()
                .UseMongoDbReadModel<TicketReadModel>()
                .UseMongoDbReadModel<DutyReadModel>()
            
            .CreateResolver();

            //return EventFlowOptions.New
            //    .AddDefaults(typeof(DutyAggregate).Assembly)
            //    .AddCommands(new Type[]
            //    {
            //        typeof(AddDutyCommand)
            //    })
            //    .AddCommandHandlers(new Type[]
            //    {
            //        typeof(AddDutyCommandHandler)
            //    })
            //    .AddQueryHandlers(new Type[]
            //    {
            //        typeof(GetDutiesQueryHandler)
            //    })


            //    .ConfigureMongoDb(conString, dbName)
            //    .UseMongoDbEventStore()
            //    .UseMongoDbSnapshotStore()
                
            //    .UseMongoDbReadModel<DutyReadModel>()
            //    .CreateResolver();



        }

        //[Fact]
        //public void GetDutiesTest()
        //{
        //    var collection = Setup();
        //    var queryProcessor = collection.Resolve<IQueryProcessor>();

        //    var startdate = DateTime.UtcNow.AddDays(-7);
        //    var enddate = DateTime.UtcNow.AddDays(7);

        //    var q = new GetDutiesQuery("dossier-9f5e083f-db3d-4151-b3ba-afbd25002728", startdate, enddate);
        //    var result = queryProcessor.Process(q, new CancellationToken());

        //}
    }
}
