﻿using System;
using System.Threading;
using CRM.Domain.Customer;
using CRM.Domain.InteractionStatistic;
using CRM.Domain.InteractionStatistic.Enums;
using CRM.Domain.InteractionStatistic.ReadModels;
using EventFlow;
using EventFlow.Configuration;
using EventFlow.Extensions;
using EventFlow.MongoDB.Extensions;
using EventFlow.Queries;
using WebPortal.Application.Statistics.Queries;
using WebPortal.CCMConnector.Application.InteractionStats.Commands;
using Xunit;

namespace WebPortal.XUnitTest
{
    public class TestInteractionStatistic
    {
        private static Guid[] _statGuids = new Guid[]
        {
            new Guid("bedb6bca-e489-4447-a157-981e02b14ce6"), 
            new Guid("7d135ce8-7047-4270-ab1c-9cab375f8f0e"),
            new Guid("1469b42a-efcc-453e-84b6-2daeefd82706"), 
        };         
        
        private    DateTime _firstStatDateTime = new DateTime(2020,1,7);
        private int _firstDuration = 60;
        private  int _waitTime = 7;
        private  int _interactionId = 250;

        private static Guid _custGuid = new Guid("3807a41d-c74b-40ab-aaae-207913576a82");
        private CustomerId _customerId = CustomerId.With(_custGuid);

        private static int _dnis = 1234;

        private static IRootResolver Setup()
        {
            //var conString = "mongodb://aac-dev01.cisicc.local";

            var conString = "mongodb://localhost";

            return EventFlowOptions.New
                .AddDefaults(typeof(InteractionStatisticAggregate).Assembly)
                .AddCommands(new Type[]{typeof(CreateInteractionStatCommand)})
                .AddCommandHandlers(new Type[] { typeof(CreateInteractionStatCommandHandler)})
                .AddQueryHandlers(new Type[] { typeof(GetStatisticNumbersQueryHandler) })
                .ConfigureMongoDb(conString, "WPMongoTest")
                .UseMongoDbEventStore()
                .UseMongoDbSnapshotStore()
                .UseMongoDbReadModel<InteractionStatisticReadModel>()

                //.AddAspNetCore()
                .CreateResolver();
        }

        //[Fact]
        //public void TestStatistic()
        //{
        //    var collection = Setup();
        //    var commandBus = collection.Resolve<ICommandBus>();
        //    var queryProcessor = collection.Resolve<IQueryProcessor>();

        //    foreach (var guid in _statGuids)
        //    {
        //        DateTime connected = _firstStatDateTime.AddSeconds(_waitTime);
        //        TimeSpan duration = TimeSpan.FromSeconds(_firstDuration);
        //        DateTime disConnected = connected.AddSeconds(_firstDuration);
        //        var command = new CreateInteractionStatCommand(InteractionStatisticId.With(guid), _interactionId.ToString(), _customerId.Value, _dnis, _firstStatDateTime, connected, duration, disConnected, InteractionType.Call);
        //        var result = commandBus.PublishAsync(command, new System.Threading.CancellationToken()).ConfigureAwait(false).GetAwaiter().GetResult();
        //        Assert.True(result.IsSuccess);

        //        _waitTime += 7;
        //        _interactionId += 1;
        //        _firstDuration += 10;
        //        _firstStatDateTime = _firstStatDateTime.AddMinutes(2);

        //    }

        //    var q = new GetStatisticNumbersQuery(_customerId.Value, _firstStatDateTime.AddMonths(-1), _firstStatDateTime.AddMonths(1));

        //    var stats = queryProcessor.Process(q, new CancellationToken());
        //    Assert.True(stats != null);
        //}
    }
}
