﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WebPortal.XUnitTest.TestModels
{
    public class TempCompanyItem
    {
        public int TenantNumber { get; set; }
        public string TempId { get; set; }
        public int? MainFicheId { get; set; }
        public int CustomerId { get; set; }
        public string CompanyName { get; set; }

        public string CompanyBranchName { get; set; }
        public int? SubFicheId { get; set; }
        public string Street { get; set; }
        public string City { get; set; }
        public string PostalCode { get; set; }
        public string Country { get; set; }
        public string HouseNumber { get; set; }
        public string BoxNumber { get; set; }

        //ContactDetails
        public string FaxNumber { get; set; }
        public string Fax { get; set; }
        public string DefaultFax { get; set; }
        public string EmailAddress { get; set; }
        public string Email { get; set; }
        public string DefaultEmail { get; set; }
        public string Phone1 { get; set; }
        public string Phone2 { get; set; }
        public string HomePage { get; set; }

        public List<TempCompanyItem> CompanyBranches { get; set; }

        public static List<TempCompanyItem> TestData => JsonConvert.DeserializeObject<List<TempCompanyItem>>("[{\"TenantNumber\":1,\"TempId\":\"34553ee1-9d01-49aa-a8a0-7850c12f585f\",\"MainFicheId\":null,\"CustomerId\":5211,\"CompanyName\":\"MIELE BE - NL\",\"CompanyBranchName\":\"MIELE BE NL\",\"SubFicheId\":null,\"Street\":\"Hof te Bollebeeklaan\",\"City\":\"Mollem\",\"PostalCode\":\"1730\",\"Country\":\"BE\",\"HouseNumber\":\"9\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/451.16.66\",\"DefaultFax\":null,\"EmailAddress\":\"repairs@miele.be\",\"Email\":\"repairs@miele.be\",\"DefaultEmail\":null,\"Phone1\":\"02/451.16.16\",\"Phone2\":\"02/451.14.11\",\"HomePage\":\"HTTP://www.miele.be\"},{\"TenantNumber\":1,\"TempId\":\"bc405848-3788-4ef0-b83e-488532d49206\",\"MainFicheId\":null,\"CustomerId\":5363,\"CompanyName\":\"ALTIUS ADVOCATEN - AVOCATS\",\"CompanyBranchName\":\"ALTIUS\",\"SubFicheId\":null,\"Street\":\"Tour & Taxis Building Havenlaan  - Avenue du Port\",\"City\":\"Brussel\",\"PostalCode\":\"1000\",\"Country\":\"BE\",\"HouseNumber\":\"86C\",\"BoxNumber\":\"414\",\"FaxNumber\":null,\"Fax\":\"02/426.20.30\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"info@altius.com\",\"DefaultEmail\":null,\"Phone1\":\"02/426.14.14\",\"Phone2\":\"\",\"HomePage\":\"www.altius.com\"},{\"TenantNumber\":1,\"TempId\":\"b04deabf-c64e-47de-9a03-6d55524b52de\",\"MainFicheId\":null,\"CustomerId\":5692,\"CompanyName\":\"B.S.H. HOME APPLIANCES nv\",\"CompanyBranchName\":\"BSH\",\"SubFicheId\":null,\"Street\":\"Laarbeeklaan\",\"City\":\"Brussel\",\"PostalCode\":\"1090\",\"Country\":\"BE\",\"HouseNumber\":\"74\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/475.72.80\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"info@bsh-group.be\",\"DefaultEmail\":null,\"Phone1\":\"02/475.70.00\",\"Phone2\":\"\",\"HomePage\":\"HTTP://www.bsh-group.be\"},{\"TenantNumber\":2,\"TempId\":\"e965aaec-9840-4a50-89e3-595efd1d12a1\",\"MainFicheId\":null,\"CustomerId\":9112,\"CompanyName\":\"AIRPARKING\",\"CompanyBranchName\":\"AIRPARKING\",\"SubFicheId\":null,\"Street\":\"Vilvoordelaan\",\"City\":\"Zaventem\",\"PostalCode\":\"\",\"Country\":\"BE\",\"HouseNumber\":\"194\",\"BoxNumber\":\"\",\"FaxNumber\":\"027212648\",\"Fax\":\"02/721.26.48\",\"DefaultFax\":null,\"EmailAddress\":\"airparking@telenet.be\",\"Email\":\"airparking@telenet.be\",\"DefaultEmail\":\"airparking@telenet.be\",\"Phone1\":\"02/720.44.71\",\"Phone2\":\"02/725.68.54.\",\"HomePage\":\"HTTP://www.airparking.com\"},{\"TenantNumber\":2,\"TempId\":\"56126ab1-8b01-4db1-8f2a-288a86b99ded\",\"MainFicheId\":null,\"CustomerId\":9198,\"CompanyName\":\"COCA COLA BELGIE - LUXEMBURG FR\",\"CompanyBranchName\":\"COCA COLA BELUX FR\",\"SubFicheId\":null,\"Street\":\"Nijverheidsstraat\",\"City\":\"Londerzeel\",\"PostalCode\":\"1840\",\"Country\":\"BE\",\"HouseNumber\":\"20\",\"BoxNumber\":\"\",\"FaxNumber\":\"052308812\",\"Fax\":\"052/308.109.\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"technical_service_be@cokecce.com\",\"DefaultEmail\":null,\"Phone1\":\"052/308.800\",\"Phone2\":\"052/308.801\",\"HomePage\":\"www.cocacola.be\"},{\"TenantNumber\":2,\"TempId\":\"43fa0430-3a30-49e1-9402-5515aea4dd32\",\"MainFicheId\":9198,\"CustomerId\":91982,\"CompanyName\":\"COCA COLA BELGIE - BESTELLING DRANK FULL SERVICE\",\"CompanyBranchName\":\"01 - BESTELLING DRANK: FULL SERVICE KLANT\",\"SubFicheId\":91982,\"Street\":\"Nijverheidsstraat\",\"City\":\"Londerzeel\",\"PostalCode\":\"1840\",\"Country\":\"BE\",\"HouseNumber\":\"20\",\"BoxNumber\":\"\",\"FaxNumber\":\"052308109\",\"Fax\":\"052/308.109\",\"DefaultFax\":null,\"EmailAddress\":\"technical_service_be@cokecce.com\",\"Email\":\"technical_service_be@cokecce.com\",\"DefaultEmail\":null,\"Phone1\":\"052/308.800\",\"Phone2\":\"052/308.801\",\"HomePage\":\"www.cocacola.be\"},{\"TenantNumber\":2,\"TempId\":\"c7bc17a9-dcc1-4ce7-966c-5417888701f6\",\"MainFicheId\":9198,\"CustomerId\":91983,\"CompanyName\":\"COCA COLA BELGIE - BESTELLING DRANK GEWONE KLANTEN\",\"CompanyBranchName\":\"02 - BESTELLING DRANK: GEWONE KLANTEN\",\"SubFicheId\":91983,\"Street\":\"Nijverheidsstraat\",\"City\":\"Londerzeel\",\"PostalCode\":\"1840\",\"Country\":\"BE\",\"HouseNumber\":\"20\",\"BoxNumber\":\"\",\"FaxNumber\":\"052308109\",\"Fax\":\"052/308.109\",\"DefaultFax\":null,\"EmailAddress\":\"tccallcenter@cokecce.com\",\"Email\":\"technical_service_be@cokecce.com\",\"DefaultEmail\":null,\"Phone1\":\"052/308.800\",\"Phone2\":\"052/308.801\",\"HomePage\":\"www.cocacola.be\"},{\"TenantNumber\":2,\"TempId\":\"9c3eccf6-7288-49a2-949d-6f7ef8cb216f\",\"MainFicheId\":9198,\"CustomerId\":91984,\"CompanyName\":\"COCA COLA BELGIE - NIEUWE AANVRAAG AUTOMAAT/VENDOR\",\"CompanyBranchName\":\"03 - NIEUWE AANVRAAG voor PLAATSING\",\"SubFicheId\":91984,\"Street\":\"Nijverheidsstraat\",\"City\":\"Londerzeel\",\"PostalCode\":\"1840\",\"Country\":\"BE\",\"HouseNumber\":\"20\",\"BoxNumber\":\"\",\"FaxNumber\":\"052308109\",\"Fax\":\"052/308.109\",\"DefaultFax\":null,\"EmailAddress\":\"technical_service_be@cokecce.com\",\"Email\":\"technical_service_be@cokecce.com\",\"DefaultEmail\":null,\"Phone1\":\"052/308.800\",\"Phone2\":\"052/308.801\",\"HomePage\":\"www.cocacola.be\"},{\"TenantNumber\":1,\"TempId\":\"0f5f8fc3-6b9b-430a-8fab-664583870590\",\"MainFicheId\":5211,\"CustomerId\":521110,\"CompanyName\":\"MIELE - ADMINISTRATIE - FACTURATIE\",\"CompanyBranchName\":\"02 - ADMINISTRATIE - FACTURATIE\",\"SubFicheId\":521110,\"Street\":\"Hof te Bollebeeklaan\",\"City\":\"Mollem\",\"PostalCode\":\"1730\",\"Country\":\"BE\",\"HouseNumber\":\"9\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/451.16.66\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"repairs@miele.be\",\"DefaultEmail\":null,\"Phone1\":\"02/451.16.16\",\"Phone2\":\"02/451.14.11\",\"HomePage\":\"HTTP://www.miele.be\"},{\"TenantNumber\":1,\"TempId\":\"8dfcc2fb-7c40-46f1-9f6d-e61788bbab1e\",\"MainFicheId\":5211,\"CustomerId\":521120,\"CompanyName\":\"MIELE - CONSUMENTENBELANGEN\",\"CompanyBranchName\":\"03 - CONSUMENTENBELANGEN - INFO ivm TOESTELLEN\",\"SubFicheId\":521120,\"Street\":\"Hof te Bollebeeklaan\",\"City\":\"Mollem\",\"PostalCode\":\"1730\",\"Country\":\"BE\",\"HouseNumber\":\"9\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/451.16.66\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"repairs@miele.be\",\"DefaultEmail\":null,\"Phone1\":\"02/451.16.16\",\"Phone2\":\"02/451.14.11\",\"HomePage\":\"HTTP://www.miele.be\"},{\"TenantNumber\":1,\"TempId\":\"b151a231-bd66-4263-9bf9-43e959cc1da3\",\"MainFicheId\":5211,\"CustomerId\":521125,\"CompanyName\":\"MIELE NL - PROFESSIONELE TOESTELLEN\",\"CompanyBranchName\":\"07 - PROFESSIONELE TOESTELLEN\",\"SubFicheId\":521125,\"Street\":\"Hof te Bollebeeklaan\",\"City\":\"Mollem\",\"PostalCode\":\"1730\",\"Country\":\"BE\",\"HouseNumber\":\"9\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/451.16.66\",\"DefaultFax\":null,\"EmailAddress\":\"repairs@miele.be\",\"Email\":\"repairs@miele.be\",\"DefaultEmail\":null,\"Phone1\":\"02/451.16.16\",\"Phone2\":\"02/451.14.11\",\"HomePage\":\"HTTP://www.miele.be\"},{\"TenantNumber\":1,\"TempId\":\"8b6ea17f-6881-461f-868f-1112f77d6258\",\"MainFicheId\":5211,\"CustomerId\":521130,\"CompanyName\":\"MIELE NL (000220) - AANKOOP/INFO van NIEUW TOESTEL\",\"CompanyBranchName\":\"01 - AANKOOP/INFO van NIEUW TOESTEL\",\"SubFicheId\":521130,\"Street\":\"Hof te Bollebeeklaan\",\"City\":\"Mollem\",\"PostalCode\":\"1730\",\"Country\":\"BE\",\"HouseNumber\":\"9\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/451.16.66\",\"DefaultFax\":null,\"EmailAddress\":\"repairs@miele.be\",\"Email\":\"repairs@miele.be\",\"DefaultEmail\":null,\"Phone1\":\"02/451.16.16\",\"Phone2\":\"02/451.14.11\",\"HomePage\":\"HTTP://www.miele.be\"},{\"TenantNumber\":1,\"TempId\":\"818d441c-05bd-454d-bd41-7ebfd3a9a9fe\",\"MainFicheId\":5211,\"CustomerId\":521140,\"CompanyName\":\"MIELE - KEUKENS DIENST na VERKOOP - HERSTELLINGEN\",\"CompanyBranchName\":\"06 - KEUKENS: DIENST na VERKOOP - HERSTELLINGEN\",\"SubFicheId\":521140,\"Street\":\"Hof te Bollebeeklaan\",\"City\":\"Mollem\",\"PostalCode\":\"1730\",\"Country\":\"BE\",\"HouseNumber\":\"9\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/451.16.66\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"repairs@miele.be\",\"DefaultEmail\":null,\"Phone1\":\"02/451.16.16\",\"Phone2\":\"02/451.14.11\",\"HomePage\":\"HTTP://www.miele.be\"},{\"TenantNumber\":1,\"TempId\":\"6ea958c9-fba5-4462-9555-533970142551\",\"MainFicheId\":5211,\"CustomerId\":521150,\"CompanyName\":\"MIELE - VERKOOP ONDERDELEN\",\"CompanyBranchName\":\"04 - ONDERDELEN VERKOOP\",\"SubFicheId\":521150,\"Street\":\"Hof te Bollebeeklaan\",\"City\":\"Mollem\",\"PostalCode\":\"1730\",\"Country\":\"BE\",\"HouseNumber\":\"9\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/451.16.66\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"repairs@miele.be\",\"DefaultEmail\":null,\"Phone1\":\"02/451.16.16\",\"Phone2\":\"02/451.14.11\",\"HomePage\":\"HTTP://www.miele.be\"},{\"TenantNumber\":1,\"TempId\":\"567c8550-d3e6-4150-a96d-97f6cc7f24d5\",\"MainFicheId\":5211,\"CustomerId\":521155,\"CompanyName\":\"MIELE - STOFZUIGER\",\"CompanyBranchName\":\"08 - STOFZUIGERS\",\"SubFicheId\":521155,\"Street\":\"Hof te Bollebeeklaan\",\"City\":\"Mollem\",\"PostalCode\":\"1730\",\"Country\":\"BE\",\"HouseNumber\":\"9\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/451.16.66\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"repairs@miele.be\",\"DefaultEmail\":null,\"Phone1\":\"02/451.16.16\",\"Phone2\":\"02/451.14.11\",\"HomePage\":\"HTTP://www.miele.be\"},{\"TenantNumber\":1,\"TempId\":\"8628315b-eb64-45ca-80b0-69c1913edd7c\",\"MainFicheId\":5211,\"CustomerId\":521157,\"CompanyName\":\"MIELE NL (000220) - TECHNISCHE INFO\",\"CompanyBranchName\":\"05 - TECHNISCHE INFORMATIE NODIG\",\"SubFicheId\":521157,\"Street\":\"Hof te Bollebeeklaan\",\"City\":\"Mollem\",\"PostalCode\":\"1730\",\"Country\":\"BE\",\"HouseNumber\":\"9\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/451.16.66\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"repairs@miele.be\",\"DefaultEmail\":null,\"Phone1\":\"02/451.16.16\",\"Phone2\":\"02/451.14.11\",\"HomePage\":\"HTTP://www.miele.be\"},{\"TenantNumber\":1,\"TempId\":\"1b23e9cb-51c5-4adc-8acf-fe206b88a66f\",\"MainFicheId\":5211,\"CustomerId\":521160,\"CompanyName\":\"MIELE - TOESTELLEN - INTERVENTIEVRAAG\",\"CompanyBranchName\":\"09 - ANDERE TOESTELLEN: INTERVENTIEVRAAG\",\"SubFicheId\":521160,\"Street\":\"Hof te Bollebeeklaan\",\"City\":\"Mollem\",\"PostalCode\":\"1730\",\"Country\":\"BE\",\"HouseNumber\":\"9\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/451.16.66\",\"DefaultFax\":null,\"EmailAddress\":\"repairs@miele.be\",\"Email\":\"repairs@miele.be\",\"DefaultEmail\":\"repairs@miele.be\",\"Phone1\":\"02/451.16.16\",\"Phone2\":\"02/451.14.11\",\"HomePage\":\"https://dl.dropboxusercontent.com/u/22545795/MieleVideos.htm\"},{\"TenantNumber\":1,\"TempId\":\"f7226d19-2cef-41d8-a99c-6a5610ae4093\",\"MainFicheId\":5211,\"CustomerId\":521165,\"CompanyName\":\"MIELE NL (000220) - NIET GEPLANDE PANNE\",\"CompanyBranchName\":\"10 - PANNE kan NIET GEPLAND WORDEN in SAP\",\"SubFicheId\":521165,\"Street\":\"Hof te Bollebeeklaan\",\"City\":\"Mollem\",\"PostalCode\":\"1730\",\"Country\":\"BE\",\"HouseNumber\":\"9\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/451.16.66\",\"DefaultFax\":null,\"EmailAddress\":\"repairs@miele.be\",\"Email\":\"repairs@miele.be\",\"DefaultEmail\":\"repairs@miele.be\",\"Phone1\":\"02/451.16.16\",\"Phone2\":\"02/451.14.11\",\"HomePage\":\"HTTP://www.miele.be\"},{\"TenantNumber\":1,\"TempId\":\"d16eadb8-e51e-4efe-9d0e-33a38ed0a054\",\"MainFicheId\":5211,\"CustomerId\":521170,\"CompanyName\":\"MIELE - ALGEMEEN\",\"CompanyBranchName\":\"12 - ANDER\",\"SubFicheId\":521170,\"Street\":\"Hof te Bollebeeklaan\",\"City\":\"Mollem\",\"PostalCode\":\"1730\",\"Country\":\"BE\",\"HouseNumber\":\"9\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/451.16.66\",\"DefaultFax\":null,\"EmailAddress\":\"repairs@miele.be\",\"Email\":\"repairs@miele.be\",\"DefaultEmail\":\"repairs@miele.be\",\"Phone1\":\"02/451.16.16\",\"Phone2\":\"02/451.14.11\",\"HomePage\":\"HTTP://www.miele.be/nl/c/herstellingsdienst-301.htm\"},{\"TenantNumber\":1,\"TempId\":\"13ced4d2-f7d4-46b7-a8cb-9ce9061c28ba\",\"MainFicheId\":5211,\"CustomerId\":521180,\"CompanyName\":\"MIELE BE - NL - VERPLAATSEN afspraak DAG ZELF\",\"CompanyBranchName\":\"11 - VERPLAATSEN afspraak DAG ZELF\",\"SubFicheId\":521180,\"Street\":\"Hof te Bollebeeklaan\",\"City\":\"Mollem\",\"PostalCode\":\"1730\",\"Country\":\"BE\",\"HouseNumber\":\"9\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/451.16.66\",\"DefaultFax\":null,\"EmailAddress\":\"repairs@miele.be\",\"Email\":\"repairs@miele.be\",\"DefaultEmail\":null,\"Phone1\":\"02/451.16.16\",\"Phone2\":\"02/451.14.11\",\"HomePage\":\"HTTP://www.miele.be\"},{\"TenantNumber\":1,\"TempId\":\"42b31a5a-a00a-48ee-81e6-ccaaff3fa7a6\",\"MainFicheId\":5692,\"CustomerId\":569214,\"CompanyName\":\"B.S.H. HOME APPLIANCES nv - BESTEK GEVRAAGD\",\"CompanyBranchName\":\"01 - BESTEK gevraagd\",\"SubFicheId\":569214,\"Street\":\"Laarbeeklaan\",\"City\":\"Brussel\",\"PostalCode\":\"1090\",\"Country\":\"BE\",\"HouseNumber\":\"74\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/475.72.80\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"info@bsh-group.be\",\"DefaultEmail\":null,\"Phone1\":\"02/475.70.00\",\"Phone2\":\"\",\"HomePage\":\"HTTP://www.bsh-group.be\"},{\"TenantNumber\":1,\"TempId\":\"bb009fe8-87c4-47e6-bcff-038115ab7781\",\"MainFicheId\":5692,\"CustomerId\":569220,\"CompanyName\":\"B.S.H. HOME APPLIANCES nv - E-NUMMER LOCALISEREN\",\"CompanyBranchName\":\"03 - E-NUMMER LOCALISEREN op TOESTEL\",\"SubFicheId\":569220,\"Street\":\"Laarbeeklaan\",\"City\":\"Brussel\",\"PostalCode\":\"1090\",\"Country\":\"BE\",\"HouseNumber\":\"74\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/475.72.90\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"info@bsh-group.be\",\"DefaultEmail\":null,\"Phone1\":\"02/475.70.00\",\"Phone2\":\"\",\"HomePage\":\"http://www.siemens-home.be/nl/service/online-service-support\"},{\"TenantNumber\":1,\"TempId\":\"c3334226-0401-4ebc-84c3-92bd1f938786\",\"MainFicheId\":5692,\"CustomerId\":569250,\"CompanyName\":\"B.S.H. HOME APPLIANCES nv - KLEINHUISHOUDELECTRO\",\"CompanyBranchName\":\"04 - HERSTELLING van KLEINHUISHOUDELECTRO = GEEN INBOUW\",\"SubFicheId\":569250,\"Street\":\"Laarbeeklaan\",\"City\":\"Brussel\",\"PostalCode\":\"1090\",\"Country\":\"BE\",\"HouseNumber\":\"74\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/475.72.90\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"info@bsh-group.be\",\"DefaultEmail\":null,\"Phone1\":\"02/475.70.00\",\"Phone2\":\"\",\"HomePage\":\"HTTP://www.bsh-group.be\"},{\"TenantNumber\":1,\"TempId\":\"871f851f-60b8-47ed-8833-9b5566a13afc\",\"MainFicheId\":5692,\"CustomerId\":569255,\"CompanyName\":\"B.S.H. HOME APPLIANCES nv - GROOTHUISHOUDELECTRO\",\"CompanyBranchName\":\"05 - HERSTELLING van GROOTHUISHOUDELECTRO & INBOUW\",\"SubFicheId\":569255,\"Street\":\"Laarbeeklaan\",\"City\":\"Brussel\",\"PostalCode\":\"1090\",\"Country\":\"BE\",\"HouseNumber\":\"74\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/475.72.90\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"info@bsh-group.be\",\"DefaultEmail\":null,\"Phone1\":\"02/475.70.00\",\"Phone2\":\"\",\"HomePage\":\"\"},{\"TenantNumber\":1,\"TempId\":\"4824d1a8-e038-4f3e-b524-841569f20007\",\"MainFicheId\":5692,\"CustomerId\":569258,\"CompanyName\":\"B.S.H. HOME APPLIANCES nv - OPVOLGING door BSH van INTERACTION RECORD\",\"CompanyBranchName\":\"09 - OPVOLGING door BSH GEVRAAGD (interaction record)\",\"SubFicheId\":569258,\"Street\":\"Laarbeeklaan\",\"City\":\"Brussel\",\"PostalCode\":\"1090\",\"Country\":\"BE\",\"HouseNumber\":\"74\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/475.72.90\",\"DefaultFax\":null,\"EmailAddress\":\"Bru-AAC@bshg.com\",\"Email\":\"info@bsh-group.be\",\"DefaultEmail\":null,\"Phone1\":\"02/475.70.00\",\"Phone2\":\"\",\"HomePage\":\"HTTP://www.bsh-group.be\"},{\"TenantNumber\":1,\"TempId\":\"fd18aef2-dae9-41a2-84f1-812c8236d451\",\"MainFicheId\":5692,\"CustomerId\":569260,\"CompanyName\":\"B.S.H. HOME APPLIANCES nv - ALGEMEEN\",\"CompanyBranchName\":\"13 - ANDER\",\"SubFicheId\":569260,\"Street\":\"Laarbeeklaan\",\"City\":\"Brussel\",\"PostalCode\":\"1090\",\"Country\":\"BE\",\"HouseNumber\":\"74\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/475.72.90\",\"DefaultFax\":null,\"EmailAddress\":\"Bru-AAC@bshg.com\",\"Email\":\"info@bsh-group.be\",\"DefaultEmail\":\"info@bsh-group.be\",\"Phone1\":\"02/475.70.00\",\"Phone2\":\"\",\"HomePage\":\"HTTP://www.bsh-group.be\"},{\"TenantNumber\":1,\"TempId\":\"399a59a5-c019-4ed4-98b4-74da50fa3943\",\"MainFicheId\":5692,\"CustomerId\":569262,\"CompanyName\":\"B.S.H. HOME APPLIANCES nv - KLACHT ivm TECHNIEKER\",\"CompanyBranchName\":\"06 - KLACHT ivm TECHNIEKER (niet opgedaagd, onvriendelijk ...)\",\"SubFicheId\":569262,\"Street\":\"Laarbeeklaan\",\"City\":\"Brussel\",\"PostalCode\":\"1090\",\"Country\":\"BE\",\"HouseNumber\":\"74\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/475.72.80\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"info@bsh-group.be\",\"DefaultEmail\":null,\"Phone1\":\"02/475.70.00\",\"Phone2\":\"\",\"HomePage\":\"HTTP://www.bsh-group.be\"},{\"TenantNumber\":1,\"TempId\":\"c39d9174-efcf-4f37-9ed1-2d6dca1bd800\",\"MainFicheId\":5692,\"CustomerId\":569270,\"CompanyName\":\"B.S.H. HOME APPLIANCES nv - BUPA'S\",\"CompanyBranchName\":\"02 - BUPA'S\",\"SubFicheId\":569270,\"Street\":\"Laarbeeklaan\",\"City\":\"Brussel\",\"PostalCode\":\"1090\",\"Country\":\"BE\",\"HouseNumber\":\"74\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/475.72.80\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"info@bsh-group.be\",\"DefaultEmail\":null,\"Phone1\":\"02/475.70.00\",\"Phone2\":\"\",\"HomePage\":\"HTTP://www.bsh-group.be\"},{\"TenantNumber\":1,\"TempId\":\"8f3a8c88-9364-4a30-931a-d934934d4582\",\"MainFicheId\":5692,\"CustomerId\":569280,\"CompanyName\":\"B.S.H. HOME APPLIANCES nv - SPARE PARTS\",\"CompanyBranchName\":\"07 - ONDERDELEN\",\"SubFicheId\":569280,\"Street\":\"Laarbeeklaan\",\"City\":\"Brussel\",\"PostalCode\":\"1090\",\"Country\":\"BE\",\"HouseNumber\":\"74\",\"BoxNumber\":\"\",\"FaxNumber\":\"\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\\u0000\",\"Fax\":\"02/475.72.80\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"info@bsh-group.be\",\"DefaultEmail\":null,\"Phone1\":\"02/475.70.00\",\"Phone2\":\"\",\"HomePage\":\"HTTP://www.bsh-group.be\"},{\"TenantNumber\":2,\"TempId\":\"3a1a2335-5ee5-4d13-ac46-26474666b8b6\",\"MainFicheId\":9198,\"CustomerId\":919812,\"CompanyName\":\"COCA COLA BELGIE - BLIKJES/FLESJESAUTOMAAT/FRIGO\",\"CompanyBranchName\":\"04 - PANNE: BLIKAUTOMAAT - FLESAUTOMAAT - FRIGO\",\"SubFicheId\":919812,\"Street\":\"Nijverheidsstraat\",\"City\":\"Londerzeel\",\"PostalCode\":\"1840\",\"Country\":\"BE\",\"HouseNumber\":\"20\",\"BoxNumber\":\"\",\"FaxNumber\":\"052308812\",\"Fax\":\"052/308.109.\",\"DefaultFax\":null,\"EmailAddress\":\"technical_service_be@cokecce.com\",\"Email\":\"technical_service_be@cokecce.com\",\"DefaultEmail\":null,\"Phone1\":\"052/308.800\",\"Phone2\":\"052/308.801\",\"HomePage\":\"www.cocacola.be\"},{\"TenantNumber\":2,\"TempId\":\"68df058e-c5b2-46f7-a20c-4ca4ce05846c\",\"MainFicheId\":9198,\"CustomerId\":919814,\"CompanyName\":\"COCA COLA BELGIE - POSTMIX - PREMIX - FREESTYLE\",\"CompanyBranchName\":\"05 - PANNE: POSTMIX - PREMIX - FREESTYLE\",\"SubFicheId\":919814,\"Street\":\"Nijverheidsstraat\",\"City\":\"Londerzeel\",\"PostalCode\":\"1840\",\"Country\":\"BE\",\"HouseNumber\":\"20\",\"BoxNumber\":\"\",\"FaxNumber\":\"052308812\",\"Fax\":\"052/308.109.\",\"DefaultFax\":null,\"EmailAddress\":\"technical_service_be@cokecce.com\",\"Email\":\"technical_service_be@cokecce.com\",\"DefaultEmail\":null,\"Phone1\":\"052/308.800\",\"Phone2\":\"052/308.801\",\"HomePage\":\"www.cocacola.be\"},{\"TenantNumber\":2,\"TempId\":\"bd29aa94-3b46-49ec-a0d3-df2ee19dd2d5\",\"MainFicheId\":9198,\"CustomerId\":919817,\"CompanyName\":\"COCA COLA BELGIE - ANNULATIE PANNE\",\"CompanyBranchName\":\"06 - PANNE: ANNULATIE\",\"SubFicheId\":919817,\"Street\":\"Nijverheidsstraat\",\"City\":\"Londerzeel\",\"PostalCode\":\"1840\",\"Country\":\"BE\",\"HouseNumber\":\"20\",\"BoxNumber\":\"\",\"FaxNumber\":\"052308109\",\"Fax\":\"052/308.109\",\"DefaultFax\":null,\"EmailAddress\":\"technical_service_be@cokecce.com\",\"Email\":\"technical_service_be@cokecce.com\",\"DefaultEmail\":\"technical_service_be@cokecce.com\",\"Phone1\":\"052/308.800\",\"Phone2\":\"052/308.801\",\"HomePage\":\"www.cocacola.be\"},{\"TenantNumber\":2,\"TempId\":\"3c008a3e-39b4-4144-951c-aea1bd1abcff\",\"MainFicheId\":9198,\"CustomerId\":919830,\"CompanyName\":\"COCA COLA BELGIE - RECUPERATIE van INGESTOKEN GELD\",\"CompanyBranchName\":\"07 - RECUPERATIE van INGESTOKEN GELD\",\"SubFicheId\":919830,\"Street\":\"Nijverheidsstraat\",\"City\":\"Londerzeel\",\"PostalCode\":\"1840\",\"Country\":\"BE\",\"HouseNumber\":\"20\",\"BoxNumber\":\"\",\"FaxNumber\":\"052308812\",\"Fax\":\"052/308.109.\",\"DefaultFax\":null,\"EmailAddress\":\"technical_service_be@cokecce.com\",\"Email\":\"technical_service_be@cokecce.com\",\"DefaultEmail\":null,\"Phone1\":\"052/308.800\",\"Phone2\":\"052/308.801\",\"HomePage\":\"www.cocacola.be\"},{\"TenantNumber\":2,\"TempId\":\"01a9f9fd-6c68-4cd7-99d1-3d459f628625\",\"MainFicheId\":9198,\"CustomerId\":919840,\"CompanyName\":\"COCA COLA BELGIE - SLEUTEL VERLOREN\",\"CompanyBranchName\":\"08 - SLEUTEL van TOESTEL VERLOREN\",\"SubFicheId\":919840,\"Street\":\"Nijverheidsstraat\",\"City\":\"Londerzeel\",\"PostalCode\":\"1840\",\"Country\":\"BE\",\"HouseNumber\":\"20\",\"BoxNumber\":\"\",\"FaxNumber\":\"052308812\",\"Fax\":\"052/308.109.\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"technical_service_be@cokecce.com\",\"DefaultEmail\":null,\"Phone1\":\"052/308.800\",\"Phone2\":\"052/308.801\",\"HomePage\":\"www.cocacola.be\"},{\"TenantNumber\":2,\"TempId\":\"c245993c-3260-4c5d-9eb4-8d76bc1ef118\",\"MainFicheId\":9198,\"CustomerId\":919845,\"CompanyName\":\"COCA COLA BELGIE - BOMMELDING - BEDREIGING - IMAGO\",\"CompanyBranchName\":\"09 - VEILIGHEID - BOMMELDING - BEDREIGING - IMAGO\",\"SubFicheId\":919845,\"Street\":\"Nijverheidsstraat\",\"City\":\"Londerzeel\",\"PostalCode\":\"1840\",\"Country\":\"BE\",\"HouseNumber\":\"20\",\"BoxNumber\":\"\",\"FaxNumber\":\"052308812\",\"Fax\":\"052/308.109.\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"technical_service_be@cokecce.com\",\"DefaultEmail\":null,\"Phone1\":\"052/308.800\",\"Phone2\":\"052/308.801\",\"HomePage\":\"www.cocacola.be\"},{\"TenantNumber\":2,\"TempId\":\"61206ebe-42c2-4694-8151-156230d0c9f4\",\"MainFicheId\":9198,\"CustomerId\":919850,\"CompanyName\":\"COCA COLA BELGIE - ALGEMEEN\",\"CompanyBranchName\":\"10 - ANDERE\",\"SubFicheId\":919850,\"Street\":\"Nijverheidsstraat\",\"City\":\"Londerzeel\",\"PostalCode\":\"1840\",\"Country\":\"BE\",\"HouseNumber\":\"20\",\"BoxNumber\":\"\",\"FaxNumber\":\"052308812\",\"Fax\":\"052/308.109.\",\"DefaultFax\":null,\"EmailAddress\":\"technical_service_be@cokecce.com\",\"Email\":\"technical_service_be@cokecce.com\",\"DefaultEmail\":null,\"Phone1\":\"052/308.800\",\"Phone2\":\"052/308.801\",\"HomePage\":\"www.cocacola.be\"},{\"TenantNumber\":1,\"TempId\":\"7e789645-8da3-4a7d-8cd0-a45b9eb7c860\",\"MainFicheId\":5692,\"CustomerId\":1000124,\"CompanyName\":\"B.S.H. HOME APPLIANCES nv - PERS ivm DYSON\",\"CompanyBranchName\":\"10 - PERS ivm DYSON\",\"SubFicheId\":1000124,\"Street\":\"Laarbeeklaan\",\"City\":\"Brussel\",\"PostalCode\":\"1090\",\"Country\":\"BE\",\"HouseNumber\":\"74\",\"BoxNumber\":\"\",\"FaxNumber\":null,\"Fax\":\"02/475.72.80\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"info@bsh-group.be\",\"DefaultEmail\":null,\"Phone1\":\"02/475.70.00\",\"Phone2\":\"\",\"HomePage\":\"HTTP://www.bsh-group.be\"},{\"TenantNumber\":1,\"TempId\":\"5e6a070e-ca30-4fdc-8c8f-cc55c587d3fb\",\"MainFicheId\":5692,\"CustomerId\":1000125,\"CompanyName\":\"B.S.H. HOME APPLIANCES nv - TECHNISCHE ONDERSTEUNING gevraagd aan TELEFOON door CONSUMENT\",\"CompanyBranchName\":\"11 - TECHNISCHE ONDERSTEUNING gevraagd via TELEFOON\",\"SubFicheId\":1000125,\"Street\":\"Laarbeeklaan\",\"City\":\"Brussel\",\"PostalCode\":\"1090\",\"Country\":\"BE\",\"HouseNumber\":\"74\",\"BoxNumber\":\"\",\"FaxNumber\":null,\"Fax\":\"02/475.72.80\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"info@bsh-group.be\",\"DefaultEmail\":null,\"Phone1\":\"02/475.70.00\",\"Phone2\":\"\",\"HomePage\":\"HTTP://www.bsh-group.be\"},{\"TenantNumber\":1,\"TempId\":\"6a2b68b9-8f61-4122-a4a6-838db1e934a0\",\"MainFicheId\":5692,\"CustomerId\":1000126,\"CompanyName\":\"B.S.H. HOME APPLIANCES nv - VERDELERS\",\"CompanyBranchName\":\"12 - VERDELERS\",\"SubFicheId\":1000126,\"Street\":\"Laarbeeklaan\",\"City\":\"Brussel\",\"PostalCode\":\"1090\",\"Country\":\"BE\",\"HouseNumber\":\"74\",\"BoxNumber\":\"\",\"FaxNumber\":null,\"Fax\":\"02/475.72.80\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"info@bsh-group.be\",\"DefaultEmail\":null,\"Phone1\":\"02/475.70.00\",\"Phone2\":\"\",\"HomePage\":\"HTTP://www.bsh-group.be\"},{\"TenantNumber\":1,\"TempId\":\"1af3ba70-7f2c-48a1-b047-b24c780db5ec\",\"MainFicheId\":5692,\"CustomerId\":1000262,\"CompanyName\":\"B.S.H. HOME APPLIANCES nv - OPHALEN TOESTEL\",\"CompanyBranchName\":\"08 - OPHALING TOESTEL\",\"SubFicheId\":1000262,\"Street\":\"Laarbeeklaan\",\"City\":\"Brussel\",\"PostalCode\":\"1090\",\"Country\":\"BE\",\"HouseNumber\":\"74\",\"BoxNumber\":\"\",\"FaxNumber\":null,\"Fax\":\"02/475.72.80\",\"DefaultFax\":null,\"EmailAddress\":null,\"Email\":\"info@bsh-group.be\",\"DefaultEmail\":null,\"Phone1\":\"02/475.70.00\",\"Phone2\":\"\",\"HomePage\":\"HTTP://www.bsh-group.be\"}]");

    }
    public class TempEmail
    {
        public string TempId { get; set; }
        public string EmailAddress { get; set; }
        public List<string> EmailList { get; set; }
    }
}
